
package org.act.wsc.bpel4wsmodeling.debug.operate;
import java.util.HashMap;
import java.util.Map;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IFigureLifeCircleListener;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Line;

public class DebugIdToFigure {
    
    private Map map=null;
    
    public static final DebugIdToFigure INSTANCE=new DebugIdToFigure();
    
    public DebugIdToFigure() {
        super();
        map=new HashMap();
    }
  
    public boolean addItem(Figure figure){
        if(figure.getServicesSet()!=null){
            if(figure.getServicesSet() instanceof Activity){
                map.put(((Activity)figure.getServicesSet()).getAtDebugIdValue(),figure);
                return true;
            }
            if(figure.getServicesSet() instanceof Case){
                map.put(((Case)figure.getServicesSet()).getAtDebugIdValue(),figure);
                return true;
            }
            if(figure.getServicesSet() instanceof OtherWise){
                map.put(((OtherWise)figure.getServicesSet()).getAtDebugIdValue(),figure);
                return true;
            }
            if(figure.getServicesSet() instanceof OnAlarm){
                map.put(((OnAlarm)figure.getServicesSet()).getAtDebugIdValue(),figure);
                return true;
            }
            if(figure.getServicesSet() instanceof OnMessage){
                map.put(((OnMessage)figure.getServicesSet()).getAtDebugIdValue(),figure);
                return true;
            }
        }
        return false;
    }
    
    public boolean removeItem(Figure figure){
        if(figure.getServicesSet()!=null){
            if(figure.getServicesSet() instanceof Activity){
                map.remove(((Activity)figure.getServicesSet()).getAtDebugIdValue());
                return true;
            }
            if(figure.getServicesSet() instanceof Case){
                map.remove(((Case)figure.getServicesSet()).getAtDebugIdValue());
                return true;
            }
            if(figure.getServicesSet() instanceof OtherWise){
                map.remove(((OtherWise)figure.getServicesSet()).getAtDebugIdValue());
                return true;
            }
            if(figure.getServicesSet() instanceof OnAlarm){
                map.remove(((OnAlarm)figure.getServicesSet()).getAtDebugIdValue());
                return true;
            }
            if(figure.getServicesSet() instanceof OnMessage){
                map.remove(((OnMessage)figure.getServicesSet()).getAtDebugIdValue());
                return true;
            }
        }
        return false;
    }
    
	public Figure lookup(String debugId){
	    return (Figure) map.get(debugId);
	}
}
