package org.act.wsc.bpel4wsmodeling.def.process;
import java.util.Iterator;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IProcessChildListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IScopeChildListener;
//<p></p><p></p><p></p><p></p>
public class Scope extends Activity {
    Activity act = null;
    Attribute variableAccessSerializable;
    Variables variables;
    CorrelationSets correlationSets;
    public Scope() {
        super();
        this.setName("scope");
        this.variableAccessSerializable = new Attribute(
                "variableAccessSerializable", "");
        this.add(this.variableAccessSerializable);
    }
    public void setAtVariableAccessSerializableValue(String s) {
        this.variableAccessSerializable.setValue(s);
    }
    public String getAtVariableAccessSerializableValue() {
        return this.variableAccessSerializable.getValue();
    }
    public void addVariables(Variables variables) {
        if (this.filter(".\\variables") == null) {
            this.add(variables);
            variables.setFather(this);
        }
    }
    public void deleteVariables() {
        this.remove(variables);
    }
    public Metaset getVariables() {
        return this.filter(".\\variables");
    }
    public void addCorrelationSets(CorrelationSets correlationSets) {
        if (this.filter(".\\correlationSets") == null) {
            this.add(correlationSets);
            correlationSets.setFather(this);
        }
    }
    public void deleteCorrelationSets() {
        this.remove(correlationSets);
    }
    public Metaset getCorrelationSets() {
        return this.filter(".\\correlationSets");
    }
    public void addFaultHandlers(FaultHandlers faultHandlers) {
        if (this.filter(".\\faultHandlers") == null) {
            this.add(faultHandlers);
            faultHandlers.setFather(this);
        }
    }
    public void deleteFaultHandlers(FaultHandlers faultHandlers) {
        this.remove(faultHandlers);
    }
    public Metaset getFaultHandlers() {
        return this.filter(".\\faultHandlers");
    }
    public void addCompensationHandler(CompensationHandler compensationHandler) {
        if (this.filter(".\\compensationHandler") == null) {
            this.add(compensationHandler);
            compensationHandler.setFather(this);
        }
    }
    public void deleteCompensationHandler(
            CompensationHandler compensationHandler) {
        this.remove(compensationHandler);
    }
    public Metaset getCompensationHandler() {
        return this.filter(".\\compensationHandler");
    }
    public void addEventHandlers(EventHandlers eventHandlers) {
        if (this.filter(".\\eventHandlers") == null) {
            this.add(eventHandlers);
            eventHandlers.setFather(this);
        }
    }
    public void deleteEventHandlers(EventHandlers eventHandlers) {
        this.remove(eventHandlers);
    }
    public Metaset getEventHandlers() {
        return this.filter(".\\eventHandlers");
    }
    public void addActivity(Activity activity) {
        if ((this.filter(".\\invoke") == null)
                && (this.filter(".\\receive") == null)
                && (this.filter(".\\reply") == null)
                && (this.filter(".\\assign") == null)
                && (this.filter(".\\wait") == null)
                && (this.filter(".\\throw") == null)
                && (this.filter(".\\scope") == null)
                && (this.filter(".\\sequence") == null)
                && (this.filter(".\\while") == null)
                && (this.filter(".\\switch") == null)
                && (this.filter(".\\flow") == null)
                && (this.filter(".\\pick") == null)
                && (this.filter(".\\empty") == null)
                && (this.filter(".\\compensate") == null)
                && (this.filter(".\\terminate") == null)) {
            this.add(activity);
            activity.setFather(this);
            this.act = activity;
        }
    }
    public void deleteActivity(Activity activity) {
        this.remove(activity);
    }
    public void deleteActivity() {
        if (this.act != null) {
            this.remove(act);
        }
    }
                public Activity getActivity() {
        if (this.filter(".\\invoke") != null) {
            return (Invoke) this.filter(".\\invoke").car();
        }
        if (this.filter(".\\receive") != null) {
            return (Receive) this.filter(".\\receive").car();
        }
        if (this.filter(".\\reply") != null) {
            return (Reply) this.filter(".\\reply").car();
        }
        if (this.filter(".\\assign") != null) {
            return (Assign) this.filter(".\\assign").car();
        }
        if (this.filter(".\\wait") != null) {
            return (Wait) this.filter(".\\wait").car();
        }
        if (this.filter(".\\throw") != null) {
            return (Throw) this.filter(".\\throw").car();
        }
        if (this.filter(".\\scope") != null) {
            return (Scope) this.filter(".\\scope").car();
        }
        if (this.filter(".\\sequence") != null) {
            return (Sequence) this.filter(".\\sequence").car();
        }
        if (this.filter(".\\while") != null) {
            return (While) this.filter(".\\while").car();
        }
        if (this.filter(".\\switch") != null) {
            return (Switch) this.filter(".\\switch").car();
        }
        if (this.filter(".\\flow") != null) {
            return (Flow) this.filter(".\\flow").car();
        }
        if (this.filter(".\\pick") != null) {
            return (Pick) this.filter(".\\pick").car();
        }
        if (this.filter(".\\empty") != null) {
            return (Empty) this.filter(".\\empty").car();
        }
        if (this.filter(".\\compensate") != null) {
            return (Compensate) this.filter(".\\compensate").car();
        }
        if (this.filter(".\\terminate") != null) {
            return (Terminate) this.filter(".\\terminate").car();
        }
        return null;
    }
    
    public void addVariable(Variable variable) {
        if (this.filter(".\\variables") == null) {
            this.variables = new Variables();
            this.insert(variables, 0);
            variables.setFather(this);
        } else {
            this.variables = (Variables) this.getVariables().car();
        }
        if (this.variables.addVariable(variable) == true) {
            fireVariableAdded(variable);
        }
    }
    public void deleteVariable(Variable variable) {
        this.fireVariableDeleted(variable);
        this.variables = (Variables) this.getVariables().car();
        this.variables.deleteVariable(variable);
        fireVariableDeleted(variable);
        if (this.variables.getChilds().size() == 0) {
            this.deleteVariables();
        }
    }
    public void addCorrelationSet(CorrelationSet correlationSet) {
        if (this.filter(".\\correlationSets") == null) {
            this.correlationSets = new CorrelationSets();
            if (this.filter(".\\variables") == null) {
                this.insert(correlationSets, 0);
                correlationSets.setFather(this);
            } else {
                this.insert(correlationSets, this.getServicesSetPosition(this
                        .filter(".\\variables").car()) + 1);
                correlationSets.setFather(this);
            }
        } else {
            this.correlationSets = (CorrelationSets) this.getCorrelationSets()
                    .car();
        }
        if (this.correlationSets.addCorrelationSet(correlationSet) == true) {
            fireCorrelationSetAdded(correlationSet);
        }
    }
    public void deleteCorrelationSet(CorrelationSet correlationSet) {
        fireCorrelationSetDeleted(correlationSet);
        this.correlationSets = (CorrelationSets) this.getCorrelationSets()
                .car();
        this.correlationSets.deleteCorrelationSet(correlationSet);
        if (this.correlationSets.getChilds().size() == 0) {
            this.deleteCorrelationSets();
        }
    }
    private void fireVariableAdded(Variable var) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IScopeChildListener element = (IScopeChildListener) iter.next();
            element.addVariable(var);
        }
    }
    private void fireVariableDeleted(Variable var) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IScopeChildListener element = (IScopeChildListener) iter.next();
            element.deleteVariable(var);
        }
    }
    private void fireCorrelationSetAdded(CorrelationSet c) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IScopeChildListener element = (IScopeChildListener) iter.next();
            element.addCorrelationSet(c);
        }
    }
    private void fireCorrelationSetDeleted(CorrelationSet c) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IScopeChildListener element = (IScopeChildListener) iter.next();
            element.deleteCorrelationSet(c);
        }
    }
}
