package org.act.wsc.bpel4wsmodeling.projectdata;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.xml.namespace.QName;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistryEntry;
import javax.wsdl.Operation;
import javax.wsdl.Message;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.InputImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.MessageImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OperationImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OperationWrapper;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OutputImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PortTypeImpl;

public class ElementReader {
  Project project;
  Metaset elementsSS;
  String path;
  public ElementReader(String path, Project project) {
    this.project = project;
    this.path=path;
    this.project.setElementReader(this);
    try {
      elementsSS = Metaset.create(path);
      Metaset elementSSs = elementsSS.filter(".\\element");
      for (int i = 0; i < elementSSs.getChilds().size(); i++) {
        Metaset elementSS = (Metaset) elementSSs.getChilds().get(i);
        loadPortType(elementSS);
      }
    }
    catch (Exception ex) {
    }
  }

  public List getPortTypeEntrys(){
      Vector portTypeEntrys=new Vector();
      try {
        elementsSS = Metaset.create(path);
    } catch (Exception e) {
                e.printStackTrace();
    }
      Metaset elementSSs = elementsSS.filter(".\\element");
      if(elementSSs==null){
          return null;
      }
      for (int i = 0; i < elementSSs.getChilds().size(); i++) {
        Metaset elementSS = (Metaset) elementSSs.getChilds().get(i);
        Metaset portTypeSS = elementSS.filter(".\\portType").car();
        Attribute ptSSName = (Attribute) portTypeSS.getAttributes().get(0);
        String ptSSNameV = ptSSName.getValue();
        portTypeEntrys.add(project.getWSDLRegistry().findPortType("",ptSSNameV));
      }
      return portTypeEntrys;
  }
  
  private void loadPortType(Metaset element) {
    Metaset portTypeSS = element.filter(".\\portType").car();
        PortTypeImpl pt = new PortTypeImpl();
    Attribute ptSSName = (Attribute) portTypeSS.getAttributes().get(0);
    String ptSSNameV = ptSSName.getValue();
    pt.setQName(new QName("", ptSSNameV));
    WSDLRegistryEntry wre = new WSDLRegistryEntry();
    wre.sourceWSDL = null;
    wre.namespace = pt.getQName().getNamespaceURI();
    wre.localName = pt.getQName().getLocalPart();
    wre.type = WSDLRegistryEntry.TYPE_PT;
    wre.userObject = pt;
    this.project.wsdlRegistry.addPortType(wre);
        loadOperation(portTypeSS,pt);
  }
  private void loadOperation(Metaset portTypeSS,PortTypeImpl pt) {
    for (Iterator iter = portTypeSS.filter(".\\operation").getChilds().iterator(); iter.hasNext();) {
        Metaset opSS = (Metaset) iter.next();
        OperationImpl op = new OperationImpl();
        Attribute opSSName = (Attribute) opSS.getAttributes().get(0);
        String opSSNameV = opSSName.getValue();
        op.setName(opSSNameV);
        OperationWrapper opw = new OperationWrapper(op);
                Message inMessage = loadInMessage(opSS);
        if(inMessage!=null){
            InputImpl input = new InputImpl();
            input.setMessage(inMessage);
            op.setInput(input);
        }
        Message outMessage = loadOutMessage(opSS);
        if(outMessage!=null){
            OutputImpl output = new OutputImpl();
            output.setMessage(outMessage);
            op.setOutput(output);
        }
        pt.addOperation(op);
    }
  }
  private Message loadInMessage(Metaset opSS) {
      if(opSS.filter(".\\inMessage")!=null){
          Metaset inMessageSS = opSS.filter(".\\inMessage").car();
          Attribute inMessageName = (Attribute) inMessageSS.getAttributes().get(0);
          String inMessageNameV = inMessageName.getValue();
          
          MessageImpl mesg = new MessageImpl();
          mesg.setQName(new QName("", inMessageNameV));
          WSDLRegistryEntry wre = new WSDLRegistryEntry();
          wre.sourceWSDL = null;
          wre.namespace = mesg.getQName().getNamespaceURI();
          wre.localName = mesg.getQName().getLocalPart();
          wre.type = "message";
          wre.userObject = mesg;
          this.project.wsdlRegistry.addMessage(wre);
          return mesg;
      }
      return null;
  }
  private Message loadOutMessage(Metaset opSS) {       if(opSS.filter(".\\outMessage")!=null){
          Metaset outMessageSS = opSS.filter(".\\outMessage").car();
          Attribute outMessageName = (Attribute) outMessageSS.getAttributes().get(0);
          String outMessageNameV = outMessageName.getValue();
          MessageImpl mesg = new MessageImpl();
          mesg.setQName(new QName("", outMessageNameV));
          WSDLRegistryEntry wre = new WSDLRegistryEntry();
          wre.sourceWSDL = null;
          wre.namespace = mesg.getQName().getNamespaceURI();
          wre.localName = mesg.getQName().getLocalPart();
          wre.type = "message";
          wre.userObject = mesg;
          this.project.wsdlRegistry.addMessage(wre);
          return mesg;
      }
      return null;
  }
}
