package org.act.wsc.bpel4wsmodeling.projectdata;
import javax.wsdl.Definition;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;

public class ProjectReader {
    Metaset projectInfo;
    String projectName;
    String projectDes;
    String projectPath;
    Metaset wsdls;
    
    public ProjectReader(String path) {
        try {
            Metaset projectSS = Metaset.create(path);
            projectInfo = projectSS.filter(".\\project").car();
            projectName = projectInfo.selector(".\\", "name");
            projectDes = projectInfo.selector(".\\", "description");
            projectPath = path;            wsdls = projectSS.filter(".\\wsdls").car();
        } catch (Exception ex) {
        }
    }
    
    public void loadWsdl(Project pro) {
        for (int i = 0; i < wsdls.getChilds().size(); i++) {
            Metaset wsdl = (Metaset) wsdls.getChilds().get(i);
            String replicaUrl = wsdl.selector(".\\", "replica");
            String url = wsdl.selector(".\\", "url");
            String retrieveMode = wsdl.selector(".\\", "retrieveMode");
            ImportedWSDL iw = new ImportedWSDL();
            iw.wsdlLocation = url;
            iw.wsdlReplicaUrl = replicaUrl;
            iw.wsdlRetrieveMode = retrieveMode;
            Definition definition = null;
            if (iw.wsdlRetrieveMode.equals(ImportedWSDL.MOD_USERDEF)) {
                definition = pro.getUserWSDLDefinition(iw.wsdlReplicaUrl);
            } else {
                definition = pro.getWSDLDefinition(iw.wsdlReplicaUrl);
            }
            if (definition != null) {
                iw.wsdlTargetNamespace = definition.getTargetNamespace();
                                pro.imports.put(iw.wsdlReplicaUrl, iw);
                pro.getWSDLRegistry()
                        .registeWSDL(iw.wsdlReplicaUrl, definition);
            }
        }
    }
    
    public String getProjectName() {
        return this.projectName;
    }
    
    public String getProjectDes() {
        return this.projectDes;
    }
    
    public String getProjectPath() {
        return this.projectPath;
    }
}
