
package org.act.wsc.bpel4wsmodeling.projectdata;
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IProjectListener;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;

public class WorkSpace  {
        private Map projects = new HashMap();
    private Project activeProject = null;
    private List listeners;     private static WorkSpace instance = null;
    private ProjectWriter projectWriter;
    
    protected WorkSpace() {
        projects = new HashMap();
        listeners = new Vector();
    }

    public static WorkSpace getInstance() {
        if (instance == null) {
            instance = new WorkSpace();
        }
        return instance;
    }

    public Project createProject(String name, String des, String path) {
        Project project = new Project(name, des, path);
        this.setActiveProject(project);
        this.fireProjectCreated(project);
        this.projects.put(project.getProjectName(), project);
                projectWriter = new ProjectWriter(path + File.separator + name + ".awp");
        projectWriter.setProjectName(name);
        projectWriter.setAtProjectDescription(des);
        projectWriter.write();
        return project;
    }

    public void openProject(Project project) {
        if (project != null && this.projects.containsValue(project)) {
            GetActiveProjectDir.setdir(project.getProjectPath());
            this.setActiveProject(project);
            this.fireProjectOpened(project);
        }
    }

    public void openProject(String projectName, boolean isProjectExisted) {
        if (this.projects.containsKey(projectName)) {
            Project project = (Project) this.projects.get(projectName);
            GetActiveProjectDir.setdir(project.getProjectPath());
            this.setActiveProject(project);
            this.fireProjectOpened(project);
        }
    }

    public void openProject(String projectFilePath) {
                        
        ProjectReader projectReader = new ProjectReader(projectFilePath);
        String projectName = projectReader.getProjectName();
        String projectDes = projectReader.getProjectDes();
        String projectPath = GetActiveProjectDir.getactiveprodir();
        
        Project project = new Project(projectName, projectDes, projectPath);
        projectReader.loadWsdl(project);
        File propWsdlDir = new File(GetActiveProjectDir.getactiveprodir()
                + File.separator + "output" + File.separator + "bpel");
        if(this.getEle(propWsdlDir )!=null){
            ElementReader eleReader = new ElementReader(this.getEle(propWsdlDir ), project);
        }
        if(this.getExt (propWsdlDir )!=null){
            ExtWsdlReader extWsdlReader = new ExtWsdlReader(project);
            extWsdlReader.readExtWsdl(this.getExt (propWsdlDir ));
        }
        if(this.getProp (propWsdlDir )!=null){
            PropWsdlReader propWsdlReader = new PropWsdlReader(
                    project);
            propWsdlReader.readPropWsdl(this.getProp (propWsdlDir ));
        }
        if(this.getBPEL (propWsdlDir )!=null){
            ProcessReader pr = new ProcessReader(this.getBPEL (propWsdlDir ), project);
        }
       
        projectWriter = new ProjectWriter(projectFilePath);
        projectWriter.setProjectName(projectName);
        projectWriter.setAtProjectDescription(projectDes);
        this.setActiveProject(project);
        this.fireProjectOpened(project);
        this.projects.put(project.getProjectName(), project);
    }

    public String getEle(File propWsdlDir) {
        if (propWsdlDir.isDirectory()) {
            for (int i = 0; i < propWsdlDir.list().length; i++) {
                String fileName = propWsdlDir.list()[i];
                if (fileName.endsWith(".element")) {
                    
                    if (new File(propWsdlDir + File.separator + fileName)
                            .exists()) {
                        return propWsdlDir + File.separator + fileName;
                    }
                } 
            }
        }
        return null;
    }

    public String getExt(File propWsdlDir) {
        if (propWsdlDir.isDirectory()) {
            for (int i = 0; i < propWsdlDir.list().length; i++) {
                String fileName = propWsdlDir.list()[i];
                if (fileName.endsWith("_ext.wsdl")) {
                    
                    if (new File(propWsdlDir + File.separator + fileName)
                            .exists()) {
                        return propWsdlDir + File.separator + fileName;
                    }
                }
            }
        }
        return null;
    }
    
    public String getBPEL(File propWsdlDir) {
        if (propWsdlDir.isDirectory()) {
            for (int i = 0; i < propWsdlDir.list().length; i++) {
                String fileName = propWsdlDir.list()[i];
                if (fileName.endsWith(".bpel")) {
                                        if (new File(propWsdlDir + File.separator + fileName)
                            .exists()) {
                        return propWsdlDir + File.separator + fileName;
                    }
                }
            }
        }
        return null;
    }
    
    public String getProp(File propWsdlDir) {
        if (propWsdlDir.isDirectory()) {
            for (int i = 0; i < propWsdlDir.list().length; i++) {
                String fileName = propWsdlDir.list()[i];
                if (fileName.endsWith("_property.wsdl")) {
                                        if (new File(propWsdlDir + File.separator + fileName)
                            .exists()) {
                        return propWsdlDir + File.separator + fileName;
                    }
                }
            }
        }
        return null;
    }
    
    public void closeProject(Project project) {
        if (project != null) {
            this.setActiveProject(null);
            this.fireProjectClosed(project);
        }
    }

    public Project getNextProject(Project project) {
        Project nextProject = null;
        for (Iterator iter = this.projects.values().iterator(); iter.hasNext();) {
            Project project1 = (Project) iter.next();
            if (project1.equals(project) && iter.hasNext()) {
                nextProject = (Project) iter.next();
                return nextProject;
            }
        }
        return null;
    }

    public void removeProject(Project project) {
        this.setActiveProject(null);
        this.projects.remove(project.getProjectName());
        this.fireProjectRemoved(project);
        List projects = (List) this.projects.values();
        if (!projects.isEmpty()) {
            int nextIndex = projects.indexOf(project);
            Project nextProject = (Project) projects.get((nextIndex + 1)
                    % projects.size());
            this.openProject(nextProject);
        }
    }

    public void saveProject(Project project) {
        Metaset wsdls = this.projectWriter.getWsdls();
        int j = wsdls.getChilds().size();
        List list = wsdls.getChilds();
        for (int i = j - 1; i >= 0; i--) {
            Metaset s = (Metaset) list.get(i);
            wsdls.remove(s);
        }
        Iterator it = project.imports.values().iterator();
        while (it.hasNext()) {
            ImportedWSDL wsdl = (ImportedWSDL) it.next();
            Attribute url = new Attribute("url", wsdl.wsdlLocation);
            Attribute retrieveMode = new Attribute("retrieveMode",
                    wsdl.wsdlRetrieveMode);
            String wsdlName = wsdl.wsdlReplicaUrl.substring(wsdl.wsdlReplicaUrl
                    .lastIndexOf(File.separator), wsdl.wsdlReplicaUrl.length());
            Attribute replica = new Attribute("replica", File.separator
                    + "imports" + wsdlName);
            Metaset wsdlss = new Metaset("wsdl");
            wsdlss.add(replica);
            wsdlss.add(retrieveMode);
            wsdlss.add(url);
            this.projectWriter.addWsdl(wsdlss);
        }
        this.projectWriter.write();
        this.fireProjectSaved(project);
    }
    private void fireProjectCreated(Project project) {
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((IProjectListener) iter.next()).projectCreated(project);
        }
    }
    private void fireProjectOpened(Project project) {
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            IProjectListener listener = (IProjectListener) iter.next();
            listener.projectOpened(project);
        }
    }
    private void fireProjectClosed(Project project) {
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((IProjectListener) iter.next()).projectClosed(project);
        }
    }
    private void fireProjectRemoved(Project project) {
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((IProjectListener) iter.next()).projectRemoved(project);
        }
    }
    private void fireProjectSaved(Project project) {
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((IProjectListener) iter.next()).projectSaved(project);
        }
    }
    
    public Map getProjects() {
        return projects;
    }
    
    public Project getActiveProject() {
        return activeProject;
    }
    
    public void setActiveProject(Project activeProject) {
        this.activeProject = activeProject;
    }
    
    public void addListener(IProjectListener l) {
        if (!this.listeners.contains(l)) {
            this.listeners.add(l);
        }
    }
    
    public void removeListener(IProjectListener l) {
        if (this.listeners.contains(l)) {
            this.listeners.remove(l);
        }
    }
}
