
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.def.process.Assign;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.Compensate;
import org.act.wsc.bpel4wsmodeling.def.process.Empty;
import org.act.wsc.bpel4wsmodeling.def.process.Flow;
import org.act.wsc.bpel4wsmodeling.def.process.Invoke;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;
import org.act.wsc.bpel4wsmodeling.def.process.Pick;
import org.act.wsc.bpel4wsmodeling.def.process.Receive;
import org.act.wsc.bpel4wsmodeling.def.process.Reply;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;
import org.act.wsc.bpel4wsmodeling.def.process.Sequence;
import org.act.wsc.bpel4wsmodeling.def.process.Switch;
import org.act.wsc.bpel4wsmodeling.def.process.Terminate;
import org.act.wsc.bpel4wsmodeling.def.process.Throw;
import org.act.wsc.bpel4wsmodeling.def.process.Transaction;
import org.act.wsc.bpel4wsmodeling.def.process.Wait;
import org.act.wsc.bpel4wsmodeling.def.process.While;

public final class DataFactory {
    public static Figure createFigureByType(int type, int x, int y) {
        switch (type) {
        case Figure.LABLE_ASSIGN:
        case Figure.LABLE_EMPTY:
        case Figure.LABLE_INVOKE:
        case Figure.LABLE_RECEIVE:
        case Figure.LABLE_REPLY:
        case Figure.LABLE_TERMINATE:
        case Figure.LABLE_THROW:
        case Figure.LABLE_WAIT:
        case Figure.LABLE_COMPENSATE:
        case Figure.LABLE_TRANSACTION:
            return new MetaFigure(x, y, type);
        case Figure.LABLE_FLOW:
            return new FlowFigure(x, y);
        case Figure.LABLE_PICK:
            return new PickFigure(x, y);
        case Figure.LABLE_SCOPE:
            return new ScopeFigure(x, y);
        case Figure.LABLE_SEQUENCE:
            return new SequenceFigure(x, y);
        case Figure.LABLE_SWITCH:
            return new SwitchFigure(x, y);
        case Figure.LABLE_WHILE:
            return new WhileFigure(x, y);
        default:
            return null;
        }
    }
    
    public static Figure createFigureByType(int type) {
        switch (type) {
        case Figure.LABLE_ASSIGN:
        case Figure.LABLE_EMPTY:
        case Figure.LABLE_INVOKE:
        case Figure.LABLE_RECEIVE:
        case Figure.LABLE_REPLY:
        case Figure.LABLE_TERMINATE:
        case Figure.LABLE_THROW:
        case Figure.LABLE_WAIT:
        case Figure.LABLE_COMPENSATE:
        case Figure.LABLE_TRANSACTION:
            return new MetaFigure(type);
        case Figure.LABLE_FLOW:
            return new FlowFigure();
        case Figure.LABLE_PICK:
            return new PickFigure();
        case Figure.LABLE_SCOPE:
            return new ScopeFigure();
        case Figure.LABLE_SEQUENCE:
            return new SequenceFigure();
        case Figure.LABLE_SWITCH:
            return new SwitchFigure();
        case Figure.LABLE_WHILE:
            return new WhileFigure();
        default:
            return null;
        }
    }
    
    public static Metaset createServicesSetByType(int type) {                                                                     switch (type) {
        case Figure.LABLE_ASSIGN:
            return new Assign();
        case Figure.LABLE_EMPTY:
            return new Empty();
        case Figure.LABLE_INVOKE:
            return new Invoke();
        case Figure.LABLE_RECEIVE:
            return new Receive();
        case Figure.LABLE_REPLY:
            return new Reply();
        case Figure.LABLE_TERMINATE:
            return new Terminate();
        case Figure.LABLE_THROW:
            return new Throw();
        case Figure.LABLE_WAIT:
            return new Wait();
        case Figure.LABLE_FLOW:
            return new Flow();
        case Figure.LABLE_PICK:
            return new Pick();
        case Figure.LABLE_SCOPE:
            return new Scope();
        case Figure.LABLE_SEQUENCE:
            return new Sequence();
        case Figure.LABLE_SWITCH:
            return new Switch();
        case Figure.LABLE_WHILE:
            return new While();
        case Figure.LABLE_CASE:
            return new Case();
        case Figure.LABLE_OTHERWISE:
            return new OtherWise();
        case Figure.LABLE_ONALARM:
            return new OnAlarm();
        case Figure.LABLE_ONMESSAGE:
            return new OnMessage();
        case Figure.LABLE_COMPENSATE:
            return new Compensate();
        case Figure.LABLE_TRANSACTION:
            return new Transaction();
        default:
            return null;
        }
    }
    
    public static int getTypeByServicessSet(Metaset ss) {
        if (ss instanceof Invoke) {
            return Figure.LABLE_INVOKE;
        } else if (ss instanceof Receive) {
            return Figure.LABLE_RECEIVE;
        } else if (ss instanceof Reply) {
            return Figure.LABLE_REPLY;
        } else if (ss instanceof Assign) {
            return Figure.LABLE_ASSIGN;
        } else if (ss instanceof Empty) {
            return Figure.LABLE_EMPTY;
        } else if (ss instanceof Terminate) {
            return Figure.LABLE_TERMINATE;
        } else if (ss instanceof Throw) {
            return Figure.LABLE_THROW;
        } else if (ss instanceof Wait) {
            return Figure.LABLE_WAIT;
        } else if (ss instanceof Compensate) {
            return Figure.LABLE_COMPENSATE;
        } else if (ss instanceof Sequence) {
            return Figure.LABLE_SEQUENCE;
        } else if (ss instanceof Scope) {
            return Figure.LABLE_SCOPE;
        } else if (ss instanceof While) {
            return Figure.LABLE_WHILE;
        } else if (ss instanceof Pick) {
            return Figure.LABLE_PICK;
        } else if (ss instanceof Switch) {
            return Figure.LABLE_SWITCH;
        } else if (ss instanceof Flow) {
            return Figure.LABLE_FLOW;
        } else if (ss instanceof Case) {
            return Figure.LABLE_CASE;
        } else if (ss instanceof OtherWise) {
            return Figure.LABLE_OTHERWISE;
        } else if (ss instanceof OnAlarm) {
            return Figure.LABLE_ONALARM;
        } else if (ss instanceof OnMessage) {
            return Figure.LABLE_ONMESSAGE;
        } else if (ss instanceof Transaction) {
            return Figure.LABLE_TRANSACTION;
        } else {
            return -1;
        }
    }
}
