
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.swing.ImageIcon;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.debug.operate.DebugIdToFigure;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IFigureUpdatedListener;
import org.act.wsc.bpel4wsmodeling.resource.ResourceManager;
import org.act.wsc.bpel4wsmodeling.resource.StandardGraphicImage;

public abstract class Figure {
    
    public static final int LABLE_SWITCH = 13;
    public static final int LABLE_CASE = 131;
    public static final int LABLE_OTHERWISE = 132;
    public static final int LABLE_WHILE = 14;
    public static final int LABLE_PICK = 15;
    public static final int LABLE_ONMESSAGE = 151;
    public static final int LABLE_ONALARM = 152;
    public static final int LABLE_FLOW = 16;
    public static final int LABLE_SCOPE = 17;
    public static final int LABLE_SEQUENCE = 18;
    public static final int LABLE_JOINEND = 19;
    public static final int LABLE_THROW = 20;
    public static final int LABLE_EMPTY = 21;
    public static final int LABLE_WAIT = 22;
    public static final int LABLE_COMPENSATE = 2;
    public static final int LABLE_TERMINATE = 3;
    public static final int LABLE_INVOKE = 4;
    public static final int LABLE_RECEIVE = 5;
    public static final int LABLE_REPLY = 6;
    public static final int LABLE_ASSIGN = 7;
    public static final int LABLE_NOMINAL = 0;
    public static final int LABLE_TRANSACTION = 231;
    private ImageIcon getImageByType(int type) {
        ImageIcon image;
        switch (type) {
                case Figure.LABLE_ASSIGN:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.ASSIGN);
            return image;
        case Figure.LABLE_CASE:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.CASE);
            return image;
        case Figure.LABLE_EMPTY:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.EMPTY);
            return image;
        case Figure.LABLE_FLOW:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.FLOW);
            return image;
        case Figure.LABLE_INVOKE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.INVOKE);
            return image;
        case Figure.LABLE_JOINEND:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.JOIN_END);
            return image;
        case Figure.LABLE_ONALARM:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.ONALARM);
            return image;
        case Figure.LABLE_ONMESSAGE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.ONMESSAGE);
            return image;
        case Figure.LABLE_OTHERWISE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.OTHERWISE);
            return image;
        case Figure.LABLE_PICK:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.PICK);
            return image;
        case Figure.LABLE_RECEIVE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.RECEIVE);
            return image;
        case Figure.LABLE_REPLY:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.REPLY);
            return image;
        case Figure.LABLE_SCOPE:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.SCOPE);
            return image;
        case Figure.LABLE_SEQUENCE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.SEQUENCE);
            return image;
        case Figure.LABLE_SWITCH:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.SWITCH);
            return image;
        case Figure.LABLE_TERMINATE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.TERMINATE);
            return image;
        case Figure.LABLE_THROW:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.THROW);
            return image;
        case Figure.LABLE_WAIT:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.WAIT);
            return image;
        case Figure.LABLE_WHILE:
            image = ResourceManager.getGraphicImage(StandardGraphicImage.WHILE);
            return image;
        case Figure.LABLE_NOMINAL:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.NOMINAL);
            return image;
        case Figure.LABLE_TRANSACTION:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.TRANSACTION);
            return image;
        default:
            return null;
        }
    }
    
    private ImageIcon getDebugImageByType(int type) {
        ImageIcon debugImage;
        switch (type) {
        case Figure.LABLE_ASSIGN:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_ASSIGN);
            return debugImage;
        case Figure.LABLE_EMPTY:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_EMPTY);
            return debugImage;
        case Figure.LABLE_FLOW:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_FLOW);
            return debugImage;
        case Figure.LABLE_INVOKE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_INVOKE);
            return debugImage;
        case Figure.LABLE_PICK:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_PICK);
            return debugImage;
        case Figure.LABLE_RECEIVE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_RECEIVE);
            return debugImage;
        case Figure.LABLE_REPLY:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_REPLY);
            return debugImage;
        case Figure.LABLE_SCOPE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_SCOPE);
            return debugImage;
        case Figure.LABLE_SEQUENCE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_SEQUENCE);
            return debugImage;
        case Figure.LABLE_SWITCH:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_SWITCH);
            return debugImage;
        case Figure.LABLE_TERMINATE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_TERMINATE);
            return debugImage;
        case Figure.LABLE_THROW:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_THROW);
            return debugImage;
        case Figure.LABLE_WAIT:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_WAIT);
            return debugImage;
        case Figure.LABLE_WHILE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_WHILE);
            return debugImage;
        case Figure.LABLE_TRANSACTION:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.DEBUG_TRANSACTION);
            return debugImage;
        default:
            return null;
        }
    }
    
    private ImageIcon getStopImageByType(int type) {
        ImageIcon image;
        switch (type) {
                case Figure.LABLE_ASSIGN:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_ASSIGN);
            return image;
        case Figure.LABLE_CASE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_CASE);
            return image;
        case Figure.LABLE_EMPTY:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_EMPTY);
            return image;
        case Figure.LABLE_FLOW:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_FLOW);
            return image;
        case Figure.LABLE_INVOKE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_INVOKE);
            return image;
        case Figure.LABLE_ONALARM:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_ONALARM);
            return image;
        case Figure.LABLE_ONMESSAGE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_ONMESSAGE);
            return image;
        case Figure.LABLE_OTHERWISE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_OTHERWISE);
            return image;
        case Figure.LABLE_PICK:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_PICK);
            return image;
        case Figure.LABLE_RECEIVE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_RECEIVE);
            return image;
        case Figure.LABLE_REPLY:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_REPLY);
            return image;
        case Figure.LABLE_SCOPE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_SCOPE);
            return image;
        case Figure.LABLE_SEQUENCE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_SEQUENCE);
            return image;
        case Figure.LABLE_SWITCH:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_SWITCH);
            return image;
        case Figure.LABLE_TERMINATE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_TERMINATE);
            return image;
        case Figure.LABLE_THROW:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_THROW);
            return image;
        case Figure.LABLE_WAIT:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_WAIT);
            return image;
        case Figure.LABLE_WHILE:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_WHILE);
            return image;
        case Figure.LABLE_TRANSACTION:
            image = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_TRANSACTION);
            return image;
        default:
            return null;
        }
    }
    
    private ImageIcon getStopDebugImageByType(int type) {
        ImageIcon debugImage;
        switch (type) {
        case Figure.LABLE_ASSIGN:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_ASSIGN);
            return debugImage;
        case Figure.LABLE_EMPTY:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_EMPTY);
            return debugImage;
        case Figure.LABLE_FLOW:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_FLOW);
            return debugImage;
        case Figure.LABLE_INVOKE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_INVOKE);
            return debugImage;
        case Figure.LABLE_PICK:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_PICK);
            return debugImage;
        case Figure.LABLE_RECEIVE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_RECEIVE);
            return debugImage;
        case Figure.LABLE_REPLY:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_REPLY);
            return debugImage;
        case Figure.LABLE_SCOPE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_SCOPE);
            return debugImage;
        case Figure.LABLE_SEQUENCE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_SEQUENCE);
            return debugImage;
        case Figure.LABLE_SWITCH:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_SWITCH);
            return debugImage;
        case Figure.LABLE_TERMINATE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_TERMINATE);
            return debugImage;
        case Figure.LABLE_THROW:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_THROW);
            return debugImage;
        case Figure.LABLE_WAIT:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_WAIT);
            return debugImage;
        case Figure.LABLE_WHILE:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_WHILE);
            return debugImage;
        case Figure.LABLE_TRANSACTION:
            debugImage = ResourceManager
                    .getGraphicImage(StandardGraphicImage.STOP_DEBUG_TRANSACTION);
            return debugImage;
        default:
            return null;
        }
    }
    protected List layoutListeners = new Vector();
    protected int x = 0;
    protected int y = 0;
    protected ImageIcon image;
    protected ImageIcon debugImage;
    protected ImageIcon stopImage;
    protected ImageIcon stopDebugImage;
    protected int width = 0;
    protected int height = 0;
    protected int structWidth = 0;
    protected int structHeight = 0;
    protected int type = 0;
    protected boolean debugged = false;
    protected Line input = null;
    protected Line output = null;
    protected StructFigure parent = null;
    protected GraphLayer owner = null;
    private boolean isStopped = false;
    protected Metaset ss = null;
    
    protected Figure() {
        super();
            }
    protected Figure(int type) {
        super();
        Metaset newSS = null;
        newSS = DataFactory.createServicesSetByType(type);
        this.setServicesSet(newSS);
        this.type = type;
        image = this.getImageByType(this.getType());
        debugImage = this.getDebugImageByType(this.getType());
        stopImage = this.getStopImageByType(this.getType());
        stopDebugImage = this.getStopDebugImageByType(this.getType());
        this.width = image.getIconWidth();
        this.height = image.getIconHeight();
    }
    protected Figure(int x, int y, int type) {
        super();
        Metaset newSS = null;
        newSS = DataFactory.createServicesSetByType(type);
        this.setServicesSet(newSS);
        this.x = x;
        this.y = y;
        this.type = type;
        image = this.getImageByType(this.getType());
        debugImage = this.getDebugImageByType(this.getType());
        stopImage = this.getStopImageByType(this.getType());
        stopDebugImage = this.getStopDebugImageByType(this.getType());
        this.width = image.getIconWidth();
        this.height = image.getIconHeight();
    }
    protected Figure(Metaset ss) {
        super();
        this.type = DataFactory.getTypeByServicessSet(ss);
        image = this.getImageByType(this.getType());
        debugImage = this.getDebugImageByType(this.getType());
        stopImage = this.getStopImageByType(this.getType());
        stopDebugImage = this.getStopDebugImageByType(this.getType());
        this.width = image.getIconWidth();
        this.height = image.getIconHeight();
        this.setServicesSet(ss);
    }
    
    abstract public void translate(int dx, int dy);
    
    public void addLayoutListeners(IFigureUpdatedListener l) {
        if (!this.layoutListeners.contains(l)) {
            this.layoutListeners.add(l);
        }
    }
    
    public void removeLayoutListeners(IFigureUpdatedListener l) {
        if (this.layoutListeners.contains(l)) {
            this.layoutListeners.remove(l);
        }
    }
    
    public Line getInput() {
        return input;
    }
    
    public void setInput(Line input) {
        this.input = input;
    }
    
    public Line getOutput() {
        return output;
    }
    
    public void setOutput(Line output) {
        this.output = output;
    }
    
    public GraphLayer getOwner() {
        return owner;
    }
    
    public void setOwner(GraphLayer owner) {
        this.owner = owner;
        if (this instanceof StructFigure) {
            StructFigure structFigure = (StructFigure) this;
            for (Iterator iter = structFigure.figures.iterator(); iter
                    .hasNext();) {
                Figure element = (Figure) iter.next();
                element.setOwner(owner);
            }
            if (structFigure.getEnd() != null) {
                structFigure.getEnd().setOwner(owner);
            }
        }
    }
    
    public StructFigure getParent() {
        return parent;
    }
    
    public void setParent(StructFigure parent) {
        this.parent = parent;
    }
    
    public int getType() {
        return type;
    }
    
    public void setType(int type) {
        this.type = type;
    }
    
    public void setStopped(boolean isStopped) {
        this.isStopped = isStopped;
        fireFigureDebugStateUpdated();
    }
    
    public boolean isStopped() {
        return isStopped;
    }
    
    public int getX() {
        return x;
    }
    
    public void setX(int x) {
        this.x = x;
    }
    
    public int getY() {
        return y;
    }
    
    public void setY(int y) {
        this.y = y;
    }
    
    public int getHeight() {
        return height;
    }
    
    public int getWidth() {
        return width;
    }
    
    public abstract int getStructHeight();
    
    public abstract int getStructWidth();
    
    public void fireFigureLayoutUpated() {
        for (Iterator iter = this.layoutListeners.iterator(); iter.hasNext();) {
            IFigureUpdatedListener element = (IFigureUpdatedListener) iter
                    .next();
            element.figureLayoutUpdated();
        }
    }
    
    protected void fireFigureDebugStateUpdated() {
        for (Iterator iter = this.layoutListeners.iterator(); iter.hasNext();) {
            IFigureUpdatedListener element = (IFigureUpdatedListener) iter
                    .next();
            element.figureDebugStateUpdated();
        }
    }
    
    public ImageIcon getImage() {
        return image;
    }
    
    public ImageIcon getDebugImage() {
        return debugImage;
    }
    
    public void setServicesSet(Metaset ss) {
        this.ss = ss;
    }
    
    public Metaset getServicesSet() {
        return this.ss;
    }
    
    public String getDebugId() {
        if (this.ss instanceof Activity) {
            return ((Activity) this.ss).getAtDebugIdValue();
        }
        if (this.ss instanceof Case) {
            return ((Case) this.ss).getAtDebugIdValue();
        }
        if (this.ss instanceof OtherWise) {
            return ((OtherWise) this.ss).getAtDebugIdValue();
        }
        if (this.ss instanceof OnAlarm) {
            return ((OnAlarm) this.ss).getAtDebugIdValue();
        }
        if (this.ss instanceof OnMessage) {
            return ((OnMessage) this.ss).getAtDebugIdValue();
        }
        return null;
    }
    
    protected void setStructHeight(int structHeight) {
        this.structHeight = structHeight;
    }
    
    protected void setStructWidth(int structWidth) {
        this.structWidth = structWidth;
    }
    
    protected ScopeFigure getNearestScope() {
        Figure tempFigure = this;
        while (tempFigure.getParent() != null) {
            tempFigure = tempFigure.getParent();
            if (tempFigure instanceof ScopeFigure) {
                return (ScopeFigure) tempFigure;
            }
        }
        return null;
    }
    
    public List getVariableList() {
        List variables = new Vector();
        ScopeFigure scopeFigure = this.getNearestScope();
        if (scopeFigure != null) {
            Scope scope = (Scope) scopeFigure.getServicesSet();
            if (scope.getVariables() != null
                    && scope.getVariables().getChilds().size() > 0) {
                Metaset vs = scope.getVariables().car();
                variables.addAll(vs.getChilds());
            }
        }
        if (this.getOwner().getBPELProcess().getVariables() != null
                && this.getOwner().getBPELProcess().getVariables().getChilds()
                        .size() > 0) {
            Metaset vs = this.getOwner().getBPELProcess().getVariables().car();
            variables.addAll(vs.getChilds());
        }
        return variables;
    }
    
    public List getCorrelationSetList() {
        List correlationSets = new Vector();
        ScopeFigure scopeFigure = this.getNearestScope();
        if (scopeFigure != null) {
            Scope scope = (Scope) scopeFigure.getServicesSet();
            if (scope.getCorrelationSets() != null
                    && scope.getCorrelationSets().getChilds().size() > 0) {
                Metaset vs = scope.getCorrelationSets().car();
                correlationSets.addAll(vs.getChilds());
            }
        }
        if (this.getOwner().getBPELProcess().getCorrelationSets() != null
                && this.getOwner().getBPELProcess().getCorrelationSets()
                        .getChilds().size() > 0) {
            Metaset vs = this.getOwner().getBPELProcess().getCorrelationSets()
                    .car();
            correlationSets.addAll(vs.getChilds());
        }
        return correlationSets;
    }
    
    public Figure getNextExecuteFigure() {
        Figure figure = null;
        if (this.parent != null) {
            if (this.parent instanceof SequenceFigure) {
                int index = this.parent.getFigures().indexOf(this) + 1;
                if (index < this.parent.getFigures().size()) {
                    figure = (Figure) this.parent.getFigures().get(index);
                }
            } else if (this.parent instanceof WhileFigure) {
                figure = this.parent;
            } else {
                figure = null;
            }
        }
        return figure;
    }
    
    public boolean resetBreakpoint() {
        if (this.ss instanceof Activity) {
            ((Activity) this.ss).setBreakPoint();
            fireFigureDebugStateUpdated();
            return true;
        }
        return false;
    }
    
    
    public ImageIcon getStopDebugImage() {
        return stopDebugImage;
    }
    
    public ImageIcon getStopImage() {
        return stopImage;
    }
}
