
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Iterator;
import org.act.metaset.Metaset;
import java.util.List;

public class FlowFigure extends StructFigure {
    
    protected FlowFigure(boolean vacancy) {
        super();
    }
    protected FlowFigure() {
        super(Figure.LABLE_FLOW);
        this.init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
    }
    protected FlowFigure(int x, int y) {
        super(x, y, Figure.LABLE_FLOW);
        this.init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
                this.setLayout();
    }
    private void init() {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        NominalFigure nominalFigure1 = new NominalFigure();
        NominalFigure nominalFigure2 = new NominalFigure();
        this.figures.add(nominalFigure1);
        nominalFigure1.setParent(this);
        nominalFigure1.setOwner(this.getOwner());
        this.figures.add(nominalFigure2);
        nominalFigure2.setParent(this);
        nominalFigure2.setOwner(this.getOwner());
        Line line11 = new Line();
        Line line12 = new Line();
        Line line21 = new Line();
        Line line22 = new Line();
        this.lines.add(line11);
        this.lines.add(line12);
        this.lines.add(line21);
        this.lines.add(line22);
    }
    
    public FlowFigure(Metaset ss, List figures) {
        super(ss);
        this.init(ss, figures);
    }
    private void init(Metaset ss, List figures) {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        if (figures.size() > 0) {
            for (int i = 0; i < figures.size(); i++) {
                Figure f = (Figure) figures.get(i);
                f.setParent(this);
                f.setOwner(this.getOwner());
                this.figures.add(f);
                Line line11 = new Line();
                Line line12 = new Line();
                this.lines.add(line11);
                this.lines.add(line12);
            }
        } else {
            NominalFigure nominalFigure1 = new NominalFigure();
            NominalFigure nominalFigure2 = new NominalFigure();
            this.figures.add(nominalFigure1);
            nominalFigure1.setParent(this);
            nominalFigure1.setOwner(this.getOwner());
            this.figures.add(nominalFigure2);
            nominalFigure2.setParent(this);
            nominalFigure2.setOwner(this.getOwner());
            Line line11 = new Line();
            Line line12 = new Line();
            Line line21 = new Line();
            Line line22 = new Line();
            this.lines.add(line11);
            this.lines.add(line12);
            this.lines.add(line21);
            this.lines.add(line22);
        }
    }
    
    private void addBranch() {
                NominalFigure figure = new NominalFigure();
        this.figures.add(figure);
        figure.setParent(this);
        figure.setOwner(this.getOwner());
        Line line1 = new Line();
        Line line2 = new Line();
        this.lines.add(line1);
        this.lines.add(line2);
        this.boundChanged();
        this.fireFigureLayoutUpated();
        this.fireFigureAdded(figure);
        this.fireLineAdded(line1);
        this.fireLineAdded(line2);
    }
    public void addFigure(Figure figure) {
        this.addBranch();
    }
    
    private void removeBranch(Figure figure) {
                Line line1 = figure.getInput();
        Line line2;
        if (figure instanceof StructFigure
                && ((StructFigure) figure).getEnd() != null) {
            line2 = ((StructFigure) figure).getEnd().getOutput();
        } else {
            line2 = figure.getOutput();
        }
        this.figures.remove(figure);
        this.lines.remove(line1);
        this.lines.remove(line2);
        this.boundChanged();
        this.fireFigureLayoutUpated();
        this.fireFigureRemoved(figure);
        this.fireLineRemoved(line1);
        this.fireLineRemoved(line2);
    }
    
    public void removeFigure(Figure figure) {
        this.removeBranch(figure);
    }
    
    public void translate(int dx, int dy) {
        this.x += dx;
        this.y += dy;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure element = (Figure) iter.next();
            element.translate(dx, dy);
        }
        for (Iterator iter = this.lines.iterator(); iter.hasNext();) {
            Line element = (Line) iter.next();
            element.translate(dx, dy);
        }
        if (this.end != null) {
            this.end.translate(dx, dy);
        }
        this.fireFigureLayoutUpated();
    }
    protected Rectangle getStructBound() {
        return null;
    }
    
    public void setLayout() {
        this.end.setX(this.x);
        this.end.setY(this.y + this.getStructHeight() - this.end.height);
        int childFigureX = this.x - this.getStructWidth() / 2
                + StructFigure.BORDER_WIDTH;
        int childFigureY = this.y + this.getHeight() + Line.LINE_HEIGHT * 2;
        for (int i = 0; i < this.figures.size(); i++) {
                        Figure figure = (Figure) this.figures.get(i);
            figure.setX(childFigureX + figure.getStructWidth() / 2);
            figure.setY(childFigureY);
            if (figure instanceof StructFigure) {
                ((StructFigure) figure).setLayout();
            }
            childFigureX += figure.getStructWidth()
                    + StructFigure.HORIZONTAL_INTERVAL;
                        Line line1 = (Line) this.lines.get(i * 2);
            line1.reset();
            line1.setSource(this);
            line1.setTarget(figure);
            Point sPoint1 = (Point) line1.getPoints().get(0);
            Point tPoint1 = (Point) line1.getPoints().get(
                    line1.getPoints().size() - 1);
            line1.getPoints().add(1,
                    new Point(sPoint1.x, sPoint1.y + Line.LINE_HEIGHT));
            line1.getPoints().add(2,
                    new Point(tPoint1.x, tPoint1.y - Line.LINE_HEIGHT));
            Line line2 = (Line) this.lines.get(i * 2 + 1);
            line2.reset();
            if (figure instanceof StructFigure
                    && ((StructFigure) figure).getEnd() != null) {
                line2.setSource(((StructFigure) figure).getEnd());
            } else {
                line2.setSource(figure);
            }
            line2.setTarget(this.end);
            Point sPoint2 = (Point) line2.getPoints().get(0);
            Point tPoint2 = (Point) line2.getPoints().get(
                    line2.getPoints().size() - 1);
            line2.getPoints().add(1,
                    new Point(sPoint2.x, tPoint2.y - Line.LINE_HEIGHT));
            line2.getPoints().add(2,
                    new Point(tPoint2.x, tPoint2.y - Line.LINE_HEIGHT));
        }
    }
    public int getStructHeight() {
        if (this.structHeight == 0) {
            this.heightRecalculate();
        }
        return structHeight;
    }
    public void heightRecalculate() {
        this.structHeight = 0;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure figure = (Figure) iter.next();
            if (this.structHeight < figure.getStructHeight()) {
                this.structHeight = figure.getStructHeight();
            }
        }
        this.structHeight += this.height + this.end.getHeight()
                + Line.LINE_HEIGHT * 4;
    }
    public int getStructWidth() {
        if (this.structWidth == 0) {
            this.widthRecalculate();
        }
        return structWidth;
    }
    public void widthRecalculate() {
        this.structWidth = (this.figures.size() - 1)
                * StructFigure.HORIZONTAL_INTERVAL;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure figure = (Figure) iter.next();
            this.structWidth += figure.getStructWidth();
        }
        this.structWidth = Math.max(this.structWidth, this.width);
        this.structWidth += StructFigure.BORDER_WIDTH * 2;
    }
    public List getFirstChilds() {
                return this.figures;
    }
}
