
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import org.act.metaset.utils.MetasetUtil;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.projectdata.ProcessReader;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IFigureLifeCircleListener;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IFigureUpdatedListener;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.ILayerUpdatedListener;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class GraphLayer extends Layer {
    private List listeners = new Vector();     private List layerListeners=new Vector();    private ResourceBundle res = ResChoose.getLanguage();
    private Figure mainFigure = null;
    private BPELProcess bp;
    private Project project = MainFrame.getmainFrame().getProject();
    private Figure figureProcess = null;
    public final static int INIT_WIDTH=1000;
    public final static int INIT_HEIGHT=700;
    public final static int BORDER_WIDTH=10;
    public final static int BORDER_HEIGHT=20;
    
    private int width;
    private int height;
    
    boolean isInDebug=false;
    
    public GraphLayer() {
        super();
        this.width=INIT_WIDTH;
        this.height=INIT_HEIGHT;
                        this.bp = new BPELProcess();
        Iterator importedWSDLIterator = this.project.imports.values()
                .iterator();
        while (importedWSDLIterator.hasNext()) {
            ImportedWSDL thisImportedWSDL = (ImportedWSDL) importedWSDLIterator
                    .next();
            java.io.File thiswsdlFile = new java.io.File(
                    thisImportedWSDL.wsdlReplicaUrl);
            if (MetasetUtil.getPrefix(this.bp.getProcess(),
                    thisImportedWSDL.wsdlTargetNamespace) == null) {
                MetasetUtil.addNameSpace(this.bp.getProcess(), Project
                        .getCandidateName(MetasetUtil.getNameSpaces(this.bp
                                .getProcess()), "ns"),
                        thisImportedWSDL.wsdlTargetNamespace);
            }
        }
    }
    
    public GraphLayer(BPELProcess bprocess) {
        super();
        this.bp = bprocess;
        Activity act = bp.getActivity();
        if(act!=null){
            figureProcess = ProcessReader.createFigureByServicesSet(act);
            if(figureProcess!=null){
                this.width=Math.max(figureProcess.getStructWidth()+2*BORDER_WIDTH,INIT_WIDTH);
                this.height=Math.max(figureProcess.getStructHeight()+2*BORDER_HEIGHT,INIT_HEIGHT);
                figureProcess.setX(this.width/2+BORDER_WIDTH);
                figureProcess.setY(BORDER_HEIGHT);
            }
        }
        Iterator importedWSDLIterator = this.project.imports.values()
                .iterator();
        while (importedWSDLIterator.hasNext()) {
            ImportedWSDL thisImportedWSDL = (ImportedWSDL) importedWSDLIterator
                    .next();
            java.io.File thiswsdlFile = new java.io.File(
                    thisImportedWSDL.wsdlReplicaUrl);
            if (MetasetUtil.getPrefix(this.bp.getProcess(),
                    thisImportedWSDL.wsdlTargetNamespace) == null) {
                MetasetUtil.addNameSpace(this.bp.getProcess(), Project
                        .getCandidateName(MetasetUtil.getNameSpaces(this.bp
                                .getProcess()), "ns"),
                        thisImportedWSDL.wsdlTargetNamespace);
            }
        }
    }
    
    public void addListener(IFigureLifeCircleListener l) {
        if (!this.listeners.contains(l)) {
            this.listeners.add(l);
        }
    }
    
    public void removeListener(IFigureLifeCircleListener l) {
        if (this.listeners.contains(l)) {
            this.listeners.remove(l);
        }
    }
    
    
    public void addLayerUpdatedListener(ILayerUpdatedListener l) {
        if (!this.layerListeners.contains(l)) {
            this.layerListeners.add(l);
        }
    }
    
    public void removeLayerUpdatedListener(ILayerUpdatedListener l) {
        if (this.layerListeners.contains(l)) {
            this.layerListeners.remove(l);
        }
    }
    
    public Figure getMainFigure() {
        return mainFigure;
    }
    
    public void setMainFigure(Figure mainFigure) {
        if (mainFigure == null && this.mainFigure != null) {
                        this.fireFigureRemoved(this.mainFigure);
                    } else if (mainFigure != null && this.mainFigure == null) {
                        this.fireFigureAdded(mainFigure);
            mainFigure.setOwner(this);
            this.bp.addActivity((Activity) mainFigure.getServicesSet());
            this.bp.write();
        } else {
            Print.showMessage(res.getString("GL_ChooseAnotherPlace"),Print.MESSAGE_TYPE_WARNING);
        }
        this.mainFigure = mainFigure;
    }
    
    public void setMainFigure(Figure mainFigure, boolean flag) {
        if (mainFigure == null && this.mainFigure != null) {
                        this.fireFigureRemoved(this.mainFigure);
        } else if (mainFigure != null && this.mainFigure == null) {
                        this.fireFigureAdded(mainFigure);
            mainFigure.setOwner(this);
        } else {
            Print.showMessage(res.getString("GL_ChooseAnotherPlace"),Print.MESSAGE_TYPE_WARNING);
        }
        this.mainFigure = mainFigure;
    }
    private void fireFigureAdded(Figure figure) {
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((IFigureLifeCircleListener) iter.next()).figureAdded(figure);
        }
    }
    private void fireFigureRemoved(Figure figure) {
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((IFigureLifeCircleListener) iter.next()).figureRemoved(figure);
        }
    }
    
    
    public void setBPELProcess(BPELProcess bp) {
        this.bp = bp;
    }

    public BPELProcess getBPELProcess() {
        return this.bp;
    }
    
    public Figure getFigureProcess() {
        return this.figureProcess;
    }
    
    public int getWidth() {
        return width;
    }
    
    public void setWidth(int width) {
        this.width = width;
    }
    
    public int getHeight() {
        return height;
    }
    
    public void setHeight(int height) {
        this.height = height;
    }
    private void fireLayerSizeChanged() {
        for (Iterator iter = this.layerListeners.iterator(); iter.hasNext();) {
            ILayerUpdatedListener listener = (ILayerUpdatedListener) iter.next();
            listener.layerSizeChanged();
        }
    }
    
    private void fireFigureDebugStateUpdated() {
        for (Iterator iter = this.layerListeners.iterator(); iter.hasNext();) {
            IFigureUpdatedListener listener = (IFigureUpdatedListener) iter.next();
            listener.figureDebugStateUpdated();
        }
    }
    
    public void setLayout() {
        if(this.mainFigure.x<this.mainFigure.getStructWidth()/2){
            this.mainFigure.setX(this.mainFigure.getStructWidth()/2+BORDER_WIDTH);
        }
        this.width=Math.max(this.mainFigure.x+this.mainFigure.getStructWidth()/2,INIT_WIDTH);
        this.height=Math.max(this.mainFigure.y+this.mainFigure.getStructHeight(),INIT_HEIGHT);
        this.fireLayerSizeChanged();
    }
    
    
    public boolean isInDebug() {
        return isInDebug;
    }
    
    public void setInDebug(boolean isInDebug) {
        this.isInDebug = isInDebug;
        if(!isInDebug){
                        fireFigureDebugStateUpdated();
        }
    }
}
