
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Rectangle;
import java.util.Iterator;
import java.util.Vector;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.Sequence;
import java.util.List;

public class SequenceFigure extends StructFigure {
    
    public SequenceFigure(boolean vacancy) {
        super();
    }
    public SequenceFigure(int x, int y) {
        super(x, y, Figure.LABLE_SEQUENCE);
        init();
                this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
        this.setLayout();
    }
    
    private void init() {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        Line line1 = new Line();
        this.lines.add(line1);
    }
    public SequenceFigure() {
        super(Figure.LABLE_SEQUENCE);
        init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
    }
    public SequenceFigure(Metaset ss, List figures) {
        super(ss);
        init(ss, figures);
    }
    private void init(Metaset ss, List figures) {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        for (int j = 0; j < figures.size(); j++) {
            Figure f = (Figure) figures.get(j);
            f.setOwner(this.getOwner());
            f.setParent(this);
            this.figures.add(f);
        }
        for (int i = 0; i <= ss.getChilds().size(); i++) {
            Line line = new Line();
            this.lines.add(line);
        }
    }
    
    public void addFigure(Figure figureBefore, Figure figure) {
                int index = -1;
        int position = -1;         if (figureBefore instanceof JoinendFigure) {
            index = this.getFigures().indexOf(
                    ((JoinendFigure) figureBefore).getParent()) + 1;
            position = this.getServicesSet().getServicesSetPosition(
                    figureBefore.getParent().getServicesSet()) + 1;
        } else if (figureBefore.equals(this)) {
            index = 0;
            position = 0;
        } else if (figureBefore instanceof MetaFigure) {
            index = this.getFigures().indexOf(figureBefore) + 1;
            position = this.getServicesSet().getServicesSetPosition(
                    figureBefore.getServicesSet()) + 1;
        }
        if (index != -1) {
            this.figures.add(index, figure);
            figure.setParent(this);
                        Sequence s = (Sequence) this.getServicesSet();
            if (position == 0 && s.getChilds().size() == 0) {
                s.addActivity((Activity) figure.getServicesSet());
            } else {
                s.insertActivity((Activity) figure.getServicesSet(), position);
            }
            this.getOwner().getBPELProcess().write();
            Line line = new Line();
            this.lines.add(index, line);
            this.boundChanged();
            this.fireFigureAdded(figure);
            this.fireLineAdded(line);
            this.fireFigureLayoutUpated();
        }
    }
    
    public void removeFigure(Figure figure) {
                Line line = figure.getInput();
        this.figures.remove(figure);
        this.lines.remove(line);
        this.boundChanged();
        this.fireFigureLayoutUpated();
        this.fireFigureRemoved(figure);
        this.fireLineRemoved(line);
        figure = null;
        line = null;
    }
    public void translate(int dx, int dy) {
        this.x += dx;
        this.y += dy;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure element = (Figure) iter.next();
            element.translate(dx, dy);
        }
        for (Iterator iter = this.lines.iterator(); iter.hasNext();) {
            Line element = (Line) iter.next();
            element.translate(dx, dy);
        }
        if (this.end != null) {
            this.end.translate(dx, dy);
        }
        this.fireFigureLayoutUpated();
    }
    protected Rectangle getStructBound() {
        return null;
    }
    public int getStructHeight() {
        if (this.structHeight == 0) {
            this.heightRecalculate();
        }
        return this.structHeight;
    }
    public int getStructWidth() {
        if (this.structWidth == 0) {
            this.widthRecalculate();
        }
        return this.structWidth;
    }
    public void setLayout() {
        this.end.setX(this.x);
        this.end.setY(this.y + this.getStructHeight() - this.end.getHeight());
        int chileFigureY = this.y + this.height + Line.LINE_HEIGHT;
        Figure figureBefore = this;
        for (int i = 0; i < this.figures.size(); i++) {
            Figure element = (Figure) this.figures.get(i);
            element.setX(this.x);
            element.setY(chileFigureY);
            if (element instanceof StructFigure) {
                ((StructFigure) element).setLayout();
            }
            Line line = (Line) this.lines.get(i);
            line.reset();
            line.setSource(figureBefore);
            line.setTarget(element);
            if (element instanceof StructFigure
                    && ((StructFigure) element).getEnd() != null) {
                figureBefore = ((StructFigure) element).getEnd();
            } else {
                figureBefore = element;
            }
            chileFigureY += element.getStructHeight() + Line.LINE_HEIGHT;
        }
        Line line = (Line) this.lines.get(this.figures.size());
        line.reset();
        line.setSource(figureBefore);
        line.setTarget(this.end);
    }
    public void heightRecalculate() {
        this.structHeight = this.height;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure element = (Figure) iter.next();
            this.structHeight += element.getStructHeight() + Line.LINE_HEIGHT;
        }
        this.structHeight += this.end.getHeight() + Line.LINE_HEIGHT;
    }
    public void widthRecalculate() {
                this.structWidth = this.width;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure element = (Figure) iter.next();
            this.structWidth = Math.max(this.structWidth, element
                    .getStructWidth());
        }
        this.structWidth += StructFigure.BORDER_WIDTH * 2;
    }
    public List getFirstChilds() {
        List figureList = new Vector();
        if (this.figures.size() > 0) {
            figureList.add(this.figures.get(0));
        }
        return figureList;
    }
    public void addFigure(Figure figure) {
        if (this.figures.isEmpty()) {
                        this.getOutput().setSource(figure);
            Line line = new Line();
            line.setSource(this);
            line.setTarget(figure);
            figure.setParent(this);
            figure.setOwner(this.getOwner());
            this.figures.add(figure);
            this.lines.add(line);
            this.fireFigureAdded(figure);
            this.fireLineAdded(line);
        }
    }
}
