
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.wsdl.Binding;
import javax.wsdl.BindingOperation;
import javax.wsdl.PortType;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class BindingEx extends WSDLLabel implements IDerivedLabel, Binding {
    public static int timer=0;
    
    QName name=null;
    
    PortTypeEx portTypeEx=null;
    
    List bindingOperations = new Vector();
    List extensibilityElements = new Vector();
    private Binding binding;
    public static final String ATT_NAME = "name";
    public static final String ATT_TYPE = "type";
    
    public BindingEx() {
        super();
            }
    
    public BindingEx(Binding binding) {
        this.binding = binding;
    }
    
    public boolean addChild(WSDLLabel childLabel) {
        return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if (childLabel instanceof BindingOperationEx) {
            this.removeBindingOperation((BindingOperation) childLabel);
            return true;
        } else if (childLabel instanceof ExtensibilityElementEx) {
            this.removeExtensibilityElement((ExtensibilityElement) childLabel);
            return true;
        }
        return false;
    }
    
    public Binding getBinding() {
        return binding;
    }
    
    public void setBinding(Binding binding) {
        this.binding = binding;
    }
    
    public void addBindingOperation(BindingOperation bindingOperation) {
        this.bindingOperations.add(bindingOperation);
        if (bindingOperation instanceof BindingOperationEx) {
            BindingOperationEx new_name = (BindingOperationEx) bindingOperation;
            this.fireChildAdded(new_name);
        }
    }
	
    public void removeBindingOperation(BindingOperation bindingOperation) {
        this.bindingOperations.remove(bindingOperation);
        if (bindingOperation instanceof BindingOperationEx) {
            BindingOperationEx new_name = (BindingOperationEx) bindingOperation;
            this.fireChildRemoved(new_name);
        }
    }
    
    
    
    public void addExtensibilityElement(ExtensibilityElement extensibilityElement) {
        this.extensibilityElements.add(extensibilityElement);
        if (extensibilityElement instanceof ExtensibilityElementEx) {
            ExtensibilityElementEx new_name = (ExtensibilityElementEx) extensibilityElement;
            this.fireChildAdded(new_name);
        }
    }
    public void removeExtensibilityElement(ExtensibilityElement extensibilityElement) {
        this.extensibilityElements.remove(extensibilityElement);
        if (extensibilityElement instanceof ExtensibilityElementEx) {
            ExtensibilityElementEx new_name = (ExtensibilityElementEx) extensibilityElement;
            this.fireChildRemoved(new_name);
        }
    }
    
    public BindingOperation getBindingOperation(String operationName, String inputName,
            String outputName) {
        for (Iterator iter = this.bindingOperations.iterator(); iter.hasNext();) {
            BindingOperationEx bindingOperationEx = (BindingOperationEx) iter.next();
            if(bindingOperationEx.getName().equals(operationName)){
                if(inputName!=null&&bindingOperationEx.getBindingInput()!=null){
                    if(!bindingOperationEx.getBindingInput().getName().equals(inputName)){
                        return null;
                    }
                }
                if(outputName!=null&&bindingOperationEx.getBindingOutput()!=null){
                    if(!bindingOperationEx.getBindingOutput().getName().equals(outputName)){
                        return null;
                    }
                }
                return bindingOperationEx;
            }
        }
        return null;
    }
    
    public List getBindingOperations() {
        
        return this.bindingOperations;
    }
    
    public Element getDocumentationElement() {
                return null;
    }
    
    public List getExtensibilityElements() {
        
        return this.extensibilityElements;
    }
    
    public PortType getPortType() {
        
        return this.portTypeEx;
    }
    
    public QName getQName() {
        if(this.name==null){
            this.name=this.definitionEx.StringToQName(this.getLabelName());
        }
        return this.name;
    }
    
    public boolean isUndefined() {
                return false;
    }
    
    public void setDocumentationElement(Element arg0) {
            }
    
    public void setPortType(PortType portType) {
        if (portType instanceof PortTypeEx) {
            PortTypeEx oldProperty=this.portTypeEx;
            if(oldProperty==null||!oldProperty.equals(portType)){
                this.portTypeEx=(PortTypeEx) portType;
                this.firePropertyChanged(this);
            }
        }
    }
    
    public void setQName(QName name) {
        this.name=name;
        this.firePropertyChanged(this);
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        QName oldQName=this.getQName();
        QName newQName=this.definitionEx.StringToQName(newName);
        if(!newQName.equals(oldQName)){
            this.setQName(newQName);
            this.definitionEx.messages.remove(oldQName);
            this.definitionEx.messages.put(newQName,this);
            this.fireChildRenamed(this);
            
        }
    }
    
    public void setUndefined(boolean arg0) {
            }
    
    public String getName() {
        
        return this.definitionEx.QNameToString(this.getQName());
    }
    
    public Object getExtensionAttribute(QName arg0) {
                return null;
    }
    
    public Map getExtensionAttributes() {
                return null;
    }
    
    public List getNativeAttributeNames() {
                return null;
    }
    
    public void setExtensionAttribute(QName arg0, Object arg1) {
                
    }
}
