
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.wsdl.Binding;
import javax.wsdl.BindingFault;
import javax.wsdl.BindingInput;
import javax.wsdl.BindingOperation;
import javax.wsdl.BindingOutput;
import javax.wsdl.Definition;
import javax.wsdl.Fault;
import javax.wsdl.Import;
import javax.wsdl.Input;
import javax.wsdl.Message;
import javax.wsdl.Operation;
import javax.wsdl.Output;
import javax.wsdl.Part;
import javax.wsdl.Port;
import javax.wsdl.PortType;
import javax.wsdl.Service;
import javax.wsdl.Types;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.wsdl.extensions.ExtensionRegistry;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class DefinitionEx extends WSDLLabel implements IDerivedLabel,Definition {
    
    public static final String BINDING_TYPE_SOAP="soap";
    public static final String BINDING_TYPE_HTTP="http";
    public static final String BINDING_TYPE_MIME="mime";
    public static final String ATT_NAME="name";
    public static final String ATT_TARGET_NS="targetNamespace"; 
    
    public static final String XMLNS="xmlns";
    
    QName name=null;
    String targetNamespace=null;
    Map namespaces=new HashMap();
    Map imports=new HashMap();
    Types types=null;
    Map messages=new HashMap();
    Map portTypes=new HashMap();
    Map bindings=new HashMap();
    Map services=new HashMap();   
    List extensibilityElements=new Vector();
    String bindingType=BINDING_TYPE_SOAP;    
    
    
    public DefinitionEx() {
        super();
    }
  
    
    public boolean addChild(WSDLLabel childLabel) {
                if(childLabel instanceof MessageEx){
            
        }
        return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if (childLabel instanceof ImportEx) { 
            	if(this.removeImport((ImportEx) childLabel)!=null){
            	    this.fireChildRemoved(childLabel);
            	    return true;
            	}
        } 
        if(childLabel instanceof MessageEx){
            if(this.removeMessage(((MessageEx)childLabel).getQName())!=null){
                this.fireChildRemoved(childLabel);
                return true;
            }
            
        }
        if(childLabel instanceof PortTypeEx){
            if(this.removePortType(((PortTypeEx)childLabel).getQName())!=null){
                this.fireChildRemoved(childLabel);
                return true;
            }
            
        }
        if(childLabel instanceof BindingEx){
            if(this.removeBinding(((BindingEx)childLabel).getQName())!=null){
                this.fireChildRemoved(childLabel);
                return true;
            }
            
        }
        if(childLabel instanceof ServiceEx){
            if(this.removeService(((ServiceEx)childLabel).getQName())!=null){
                this.fireChildRemoved(childLabel);
                return true;
            }
        }
        return false;
    }
    
    public void addBinding(Binding binding) {
        
        if (binding instanceof BindingEx) {
            BindingEx new_name = (BindingEx) binding;
            this.bindings.put(new_name.getQName(),binding);
            this.fireChildAdded(new_name);
        }
        
    }
    
    public void addExtensibilityElement(ExtensibilityElement extensibilityElement) {
        
        if (extensibilityElement instanceof ExtensibilityElementEx) {
            ExtensibilityElementEx new_name = (ExtensibilityElementEx) extensibilityElement;
            this.extensibilityElements.add(new_name);
            this.fireChildAdded(new_name);
        }
    }
    
    public void addImport(Import import1) {
        
        if (import1 instanceof ImportEx) {
            ImportEx importEx = (ImportEx) import1;
            if(importEx.getNamespaceURI()==null){
                importEx.namespaceURI="URI"+(++ImportEx.timer);
            }
            this.imports.put(importEx.getNamespaceURI(),importEx);
            this.fireChildAdded(importEx);
        }
    }
    public ImportEx removeImport(ImportEx importEx){
           return (ImportEx) this.imports.remove(importEx.getNamespaceURI());
    }
    
    public void addMessage(Message message) {
        
        if (message instanceof MessageEx) {
            MessageEx new_name = (MessageEx) message;
            this.messages.put(new_name.getQName(),new_name);
            this.fireChildAdded(new_name);
        }
    }
    
    public void addNamespace(String prefix, String uri) {
        if(this.namespaces.containsKey(prefix)){
            this.namespaces.remove(prefix);
        }
        this.namespaces.put(prefix,uri);
        this.firePropertyChanged(this);
            }
    
    public void addPortType(PortType portType) {
        
        if (portType instanceof PortTypeEx) {
            PortTypeEx new_name = (PortTypeEx) portType;
            this.portTypes.put(new_name.getQName(),portType);
            this.fireChildAdded(new_name);
        }
    }
    
    public void addService(Service service) {
        
        if (service instanceof ServiceEx) {
            ServiceEx new_name = (ServiceEx) service;
            this.services.put(new_name.getQName(),service);
            this.fireChildAdded(new_name);
        }
    }
    
    public Binding getBinding(QName name) {
        return (Binding) bindings.get(name);
    }
    
    public Map getBindings() {
        if(this.bindings==null){
            this.bindings=new HashMap();
        }
        return this.bindings;
    }
    
    public String getDocumentBaseURI() {
                return null;
    }
    
    public Element getDocumentationElement() {
                return null;
    }
    
    public List getExtensibilityElements() {
        
        return this.extensibilityElements;
    }
    
    public ExtensionRegistry getExtensionRegistry() {
                return null;
    }
    
    public Map getImports() {
        
        return this.imports;
    }
    
    public List getImports(String arg0) {
                return null;
    }
    
    public Import getImport(String nameSpace) {
        return (Import) this.imports.get(nameSpace);
    }
    
    public Message getMessage(QName name) {
        return (Message) this.messages.get(name);
    }
    
    public Map getMessages() {
        
        return this.messages;
    }
    
    public String getNamespace(String prefix) {
        return (String) this.namespaces.get(prefix);
    }
    
    public Map getNamespaces() {
       
        return this.namespaces;
    }
    
    public PortType getPortType(QName name) {
        
        return (PortType) this.portTypes.get(name);
    }
    
    public Map getPortTypes() {
        
        return this.portTypes;
    }
    
    public String getPrefix(String namespaceUri) {
        for (Iterator iter = this.namespaces.keySet().iterator(); iter.hasNext();) {
            String prefix = (String) iter.next();
            if(namespaceUri.equals(this.namespaces.get(prefix))){
                return prefix;
            }
        }
        return null;
    }
    
    public QName getQName() {
        if(this.name==null){
            this.name=new QName(this.getLabelName());
        }
        return this.name;
    }
    
    public Service getService(QName name) {
        
        return (Service) this.services.get(name);
    }
    
    public Map getServices() {
        
        return this.services;
    }
    
    public String getTargetNamespace() {
        
        return this.targetNamespace;
    }
    
    public Types getTypes() {
        
        return this.types;
    }
    
    
    
    public Binding removeBinding(QName name) {
        
        return (Binding) this.bindings.remove(name);
    }
    
    public Message removeMessage(QName name) {
        
        return (Message) this.messages.remove(name);
    }
    
    public PortType removePortType(QName name) {
        
        return (PortType) this.portTypes.remove(name);
    }
    
    public Service removeService(QName name) {
        
        return (Service) this.services.remove(name);
    }
    
    public void setDocumentBaseURI(String arg0) {
                
    }
    
    public void setDocumentationElement(Element arg0) {
                
    }
    
    public void setExtensionRegistry(ExtensionRegistry arg0) {
                
    }
    
    public void setQName(QName name) {
        this.name=name;
        if(this.getQName()!=null&&!name.equals(this.getQName())){
            this.name=name;   
            this.firePropertyChanged(this);
        }
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        QName oldQName=this.getQName();
        QName newQName=new QName(newName);
        this.setQName(newQName);
        if(!newQName.equals(oldQName)){
            this.fireChildRenamed(this);
        }
    }
    
    public void setTargetNamespace(String targetNamespace) {
        this.targetNamespace=targetNamespace;
        if(this.getTargetNamespace()!=null&&!targetNamespace.equals(this.getTargetNamespace())){
            
            this.firePropertyChanged(this);
        }
        
    }
    
    public void setTypes(Types types) {
        if (types instanceof TypesEx) {
            this.types = (TypesEx) types;
        }
    }
    
    public void addTypes(TypesEx typesEx){
        if(this.types==null){
            this.setTypes(typesEx);
            this.fireChildAdded(typesEx);
        }
    }
    public void removeTypes(TypesEx typesEx){
        if(this.types!=null&&this.types.equals(typesEx)){
            this.types=null;
            this.fireChildRemoved(typesEx);
        }
    }
    
    public Binding createBinding() {
        BindingEx bindingEx=new BindingEx();
        bindingEx.setDefinitionEx(this);
        bindingEx.setQName(StringToQName("binding"+(++BindingEx.timer)));
        return bindingEx;
    }
    
    public BindingFault createBindingFault() {
        BindingFaultEx bindingFaultEx=new BindingFaultEx();
        bindingFaultEx.setDefinitionEx(this);
        bindingFaultEx.setName("fault"+(++BindingEx.timer));
        return bindingFaultEx;
    }
    
    public BindingInput createBindingInput() {
        BindingInputEx bindingInputEx=new BindingInputEx();
        bindingInputEx.setDefinitionEx(this);
        return bindingInputEx;
    }
    
    public BindingOperation createBindingOperation() {
        BindingOperationEx bindingOperationEx=new BindingOperationEx();
        bindingOperationEx.setDefinitionEx(this);
        bindingOperationEx.setName("operation"+(++BindingOperationEx.timer));
        return bindingOperationEx;
    }
    
    public BindingOutput createBindingOutput() {
        BindingOutputEx bindingOutputEx=new BindingOutputEx();
               bindingOutputEx.setDefinitionEx(this);
        return bindingOutputEx;
    }
    
    public Fault createFault() {
        FaultEx faultEx=new FaultEx();
        faultEx.setDefinitionEx(this);
        faultEx.setName("fault"+(++FaultEx.timer));
        return faultEx;
    }
    
    public Import createImport() {
        ImportEx importEx=new ImportEx();
        importEx.setDefinitionEx(this);
        return importEx;
    }
    
    public Input createInput() {
        InputEx inputEx=new InputEx();
        inputEx.setDefinitionEx(this);
        return inputEx;
    }
    
    public Message createMessage() {
        MessageEx messageEx=new MessageEx();
        messageEx.setDefinitionEx(this);
        messageEx.setQName(StringToQName("message"+(++MessageEx.timer)));
        return messageEx;
    }
    
    public Operation createOperation() {
        OperationEx operationEx=new OperationEx();
        operationEx.setDefinitionEx(this);
        operationEx.setName(operationEx.getLabelName()+(++OperationEx.timer));
        return operationEx;
    }
    
    public Output createOutput() {
        OutputEx outputEx=new OutputEx();
        outputEx.setDefinitionEx(this);
        return outputEx;
    }
    
    public Part createPart() {
        PartEx partEx=new PartEx();
        partEx.setDefinitionEx(this);
        partEx.setName(partEx.getLabelName()+(++PartEx.timer));
        return partEx;
    }
    
    public Port createPort() {
        PortEx portEx=new PortEx();
        portEx.setDefinitionEx(this);
        portEx.setName(portEx.getLabelName()+(++PortEx.timer));
        return portEx;
    }
    
    public PortType createPortType() {
        PortTypeEx portTypeEx=new PortTypeEx();
        portTypeEx.setDefinitionEx(this);
        portTypeEx.setQName(StringToQName(portTypeEx.getLabelName()+(++PortTypeEx.timer)));
        return portTypeEx;
    }
    
    public Service createService() {
        ServiceEx serviceEx=new ServiceEx();
        serviceEx.setDefinitionEx(this);
        serviceEx.setQName(StringToQName(serviceEx.getLabelName()+(++ServiceEx.timer)));
        return serviceEx;
    }
    
    public SOAPAddress createSOAPAddress() {
        SOAPAddress address=new SOAPAddress();
                address.setDefinitionEx(this);
        return address;
    }
    public Types createTypes() {
        TypesEx typesEx=new TypesEx();
                typesEx.setDefinitionEx(this);
        return typesEx;
    }
    
    public SchemaEx createSchema() {
        SchemaEx schemaEx=new SchemaEx();
        schemaEx.setDefinitionEx(this);
        return schemaEx;
    }
    
    public ElementEx createElement() {
        ElementEx elementEx=new ElementEx();
        elementEx.setDefinitionEx(this);
        elementEx.setName(elementEx.getLabelName()+(++ElementEx.timer));
        return elementEx;
    }
    
    public ComplexTypeEx createComplexType() {
        ComplexTypeEx complexTypeEx=new ComplexTypeEx();
        complexTypeEx.setDefinitionEx(this);
        complexTypeEx.setName(complexTypeEx.getLabelName()+(++ComplexTypeEx.timer));
        return complexTypeEx;
    }
    
    
    public Combiner createCombiner(String kind){
        Combiner combiner=new Combiner(kind);
        combiner.setDefinitionEx(this);
        return combiner;
    }
    
    
    public SimpleTypeEx createSimpleType() {
        SimpleTypeEx simpleTypeEx=new SimpleTypeEx();
        simpleTypeEx.setDefinitionEx(this);
        simpleTypeEx.setName(simpleTypeEx.getLabelName()+(++SimpleTypeEx.timer));
        return simpleTypeEx;
    }
    public SOAPBinding createSOAPBinding() {
        SOAPBinding binding=new SOAPBinding();
                binding.setDefinitionEx(this);
        return binding;
    }
    
    public SOAPBody createSOAPBody() {
        SOAPBody body=new SOAPBody();
                body.setDefinitionEx(this);
        return body;
    }
    public SOAPFault createSOAPFault() {
        SOAPFault fault=new SOAPFault();
                fault.setDefinitionEx(this);
        return fault;
    }
    public SOAPHeader createSOAPHeader() {
        SOAPHeader header=new SOAPHeader();
                header.setDefinitionEx(this);
        return header;
    }
    public SOAPOperation createSOAPOperation() {
        SOAPOperation operation=new SOAPOperation();
                operation.setDefinitionEx(this);
        return operation;
    }
    
    public HTTPAddress createHTTPAddress() {
        HTTPAddress address=new HTTPAddress();
                address.setDefinitionEx(this);
        return address;
    }
    public HTTPBinding createHTTPBinding() {
        HTTPBinding binding=new HTTPBinding();
                binding.setDefinitionEx(this);
        return binding;
    }
    public HTTPOperation createHTTPOperation() {
        HTTPOperation operation=new HTTPOperation();
                operation.setDefinitionEx(this);
        return operation;
    }
    
    public HTTPUrlEncoded createHTTPUrlEncoded() {
        HTTPUrlEncoded encoded=new HTTPUrlEncoded();
                encoded.setDefinitionEx(this);
        return encoded;
    }
    public HTTPUrlReplacement createHTTPUrlReplacement() {
        HTTPUrlReplacement replacement=new HTTPUrlReplacement();
                replacement.setDefinitionEx(this);
        return replacement;
    }
    
    public MIMEContent createMIMEContent() {
        MIMEContent content=new MIMEContent();
                content.setDefinitionEx(this);
        return content;
    }
    public MIMEMultipartRelated createMIMEMultipartRelated() {
        MIMEMultipartRelated multipartRelated=new MIMEMultipartRelated();
                multipartRelated.setDefinitionEx(this);
        return multipartRelated;
    }
    public MIMEPart createMIMEPart() {
        MIMEPart part=new MIMEPart();
                part.setDefinitionEx(this);
        return part;
    }
    public MIMEXml createMIMEXml() {
        MIMEXml xml=new MIMEXml();
                xml.setDefinitionEx(this);
        return xml;
    }
    
    public String getName() {
        
        return this.getLabelName();
    }
    
    public String getBindingType() {
        return bindingType;
    }
    
    public void setBindingType(String bindingType) {
        this.bindingType = bindingType;
    }
    
    public void setNamespaces(Map namespaces) {
        this.namespaces = namespaces;
        this.firePropertyChanged(this);
    }
    public String QNameToString(QName name){
        if(name==null){
            return null;
        }
        String string="";
        if(name.getNamespaceURI()!=null&&name.getNamespaceURI()!=""){
            if(this.getPrefix(name.getNamespaceURI())!=null){
                string=this.getPrefix(name.getNamespaceURI())+":";
            }
        }
        return string+name.getLocalPart();
    }
    
    
    public QName StringToQName(String name){
        int index;
        if((index=name.indexOf(':'))!=-1){
            String ns;
            String locName;
            ns=name.substring(0,index);
            locName=name.substring(index+1);
            return new QName(this.getNamespace(ns),locName);
        }
        else{
            return new QName(this.getNamespace("toi"),name);
        }
            }
}
