
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.wsdl.Operation;
import javax.wsdl.PortType;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class PortTypeEx extends WSDLLabel implements IDerivedLabel ,PortType{
    public static int timer=0;
    PortType portType;
    
    private QName name=null; 
    private List operations=new Vector();
    public static final String ATT_NAME = "name";
    
    public PortTypeEx(PortType portType) {
        super();
        this.portType = portType;
    }
    
    public PortTypeEx() {
        super();
            }
    
    public boolean addChild(WSDLLabel childLabel) {
        if(childLabel instanceof OperationEx){
			Operation operation=((OperationEx)childLabel).getOperation();
            operation.setName("newOperation");
			this.getPortType().addOperation(operation);
			this.fireChildAdded(childLabel);
			return true;
		}
        return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if(childLabel instanceof OperationEx){
            this.removeOperation((Operation) childLabel);
            return true;
        }
        return false;
    }
    
    public PortType getPortType() {
        return portType;
    }
    
    
    public void addOperation(Operation operation) {
        this.operations.add(operation);
        if (operation instanceof OperationEx) {
            OperationEx new_name = (OperationEx) operation;
            this.fireChildAdded(new_name);
        }
    }
    public void removeOperation(Operation operation) {
        if(this.operations.remove(operation)){
            if (operation instanceof OperationEx) {
                OperationEx new_name = (OperationEx) operation;
                this.fireChildRemoved(new_name);
            }
        }
        
    }
    
    public Element getDocumentationElement() {
                return null;
    }
    
    public Operation getOperation(String operationName, String inputName, String outputName) {
        for (Iterator iter = this.operations.iterator(); iter.hasNext();) {
            OperationEx operationEx = (OperationEx) iter.next();
            if(operationEx.getName().equals(operationName)){
                if(inputName!=null&&operationEx.getInput()!=null){
                    if(!this.definitionEx.QNameToString(((InputEx)operationEx.getInput()).getMessage().getQName()).equals(inputName)){
                        return null;
                    }
                }
                if(outputName!=null&&operationEx.getOutput()!=null){
                    if(!this.definitionEx.QNameToString(((OutputEx)operationEx.getOutput()).getMessage().getQName()).equals(outputName)){
                        return null;
                    }
                }
                return operationEx;
            }
        }
        return null;
    }
    
    public List getOperations() {
        
        return this.operations;
    }
    
    public QName getQName() {
        if(this.name==null){
            this.name=new QName(this.getLabelName());
        }
        return this.name;
    }
    
    public boolean isUndefined() {
                return false;
    }
    
    public void setDocumentationElement(Element arg0) {
                
    }
    
    public void setQName(QName name) {
        this.name=name;
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        QName oldQName=this.getQName();
        QName newQName=this.definitionEx.StringToQName(newName);
        
        if(!newQName.equals(oldQName)){
            this.setQName(newQName);
            this.definitionEx.portTypes.remove(oldQName);
            this.definitionEx.portTypes.put(newQName,this);
            this.fireChildRenamed(this);
            this.firePropertyChanged(this);
        }
    }
    
    public void setUndefined(boolean arg0) {
                
    }
    
    public String getName() {
        
        return this.definitionEx.QNameToString(this.getQName());
    }
    
    public Object getExtensionAttribute(QName arg0) {
                return null;
    }
    
    public Map getExtensionAttributes() {
                return null;
    }
    
    public List getNativeAttributeNames() {
                return null;
    }
    
    public void setExtensionAttribute(QName arg0, Object arg1) {
                
    }
}
