
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

public class SchemaEx extends ExtensibilityElementEx implements 
        IDerivedLabel {
    public static String ATT_TNS="targetNamespace";
    
    String targetNamespace=null;
    Map namespaces=new HashMap();
    
    List complexTypes=new Vector();
    List simpleTypes=new Vector();
    List elememts=new Vector();
    
    public SchemaEx() {
        super();
            }
    
    public boolean addChild(WSDLLabel childLabel) {
                return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if(childLabel instanceof ComplexTypeEx){
            this.removeComplexType((ComplexTypeEx) childLabel);
            return true;
        }
        if(childLabel instanceof SimpleTypeEx){
            this.removeSimpleType((SimpleTypeEx) childLabel);
            return true;
        }
        if(childLabel instanceof ElementEx){
            this.removeElement((ElementEx) childLabel);
            return true;
        }
        return false;
    }
	
    public void addSimpleType(SimpleTypeEx simpleTypeEx){
        this.simpleTypes.add(simpleTypeEx);
        this.fireChildAdded(simpleTypeEx);
    }
   
    public void removeSimpleType(SimpleTypeEx simpleTypeEx){
        if(this.simpleTypes.remove(simpleTypeEx)){
            this.fireChildRemoved(simpleTypeEx);
        }
    }
    
    public void addComplexType(ComplexTypeEx complexTypeEx){
        this.complexTypes.add(complexTypeEx);
        this.fireChildAdded(complexTypeEx);
    }
    
    public void removeComplexType(ComplexTypeEx complexTypeEx){
        if(this.complexTypes.remove(complexTypeEx)){
            this.fireChildRemoved(complexTypeEx);
        }
        
    }
   
    public void addElement(ElementEx elementEx){
        this.elememts.add(elementEx);
        this.fireChildAdded(elementEx);
    }
   
    public void removeElement(ElementEx elementEx){
        if(this.elememts.remove(elementEx)){
            this.fireChildRemoved(elementEx);
        }
    }
    
    public String getName() {
        
        return this.getLabelName();
    }
    
    public List getComplexTypes() {
        return complexTypes;
    }
    
    public List getElememts() {
        return elememts;
    }
    
    public List getSimpleTypes() {
        return simpleTypes;
    }
    
    
    
    public Map getNamespaces() {
        return namespaces;
    }
    public String getNamespaces(String prefix) {
        return (String) namespaces.get(prefix);
    }
    
    public void addNamespace(String prefix,String namespace){
        this.namespaces.put(prefix,namespace);
        this.firePropertyChanged(this);
    }
    
    public void removeNamespace(String prefix){
        this.namespaces.remove(prefix);
        this.firePropertyChanged(this);
    }
    
    public String getTargetNamespace() {
        return targetNamespace;
    }
    
    public void setTargetNamespace(String targetNamespace) {
        if(this.targetNamespace==null||!targetNamespace.equals(this.targetNamespace)){
            this.targetNamespace = targetNamespace;
            this.firePropertyChanged(this);
            this.getDefinitionEx().addNamespace("xmlns:xsdl",targetNamespace);
        }
        
    }
    
    public void setNamespaces(Map namespaces) {
        this.namespaces = namespaces;
        this.firePropertyChanged(this);
    }
}
