
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

public class SimpleTypeEx extends WSDLLabel implements TypeEx {
    public static int timer=0;
    public static final String KIND_ATOMIC="atomic";
    public static final String KIND_LIST="list";
    public static final String KIND_UNION="union";
    
    String kind;    String baseType=null;
    String itemType=null;
    List memberTypes=new Vector();
    private String name=null;
    public static final String ATT_BASE = "base";
    public static final String ATT_NAME = "name";
    public static final String CHILD_RETR = "restriction";
    public static final String ATT_ITEM = "itemType";
    public static final String ATT_MEMBER = "memberTypes"; 
   
    
    public SimpleTypeEx(String kind) {
        super();
        this.kind = kind;
    }
    
    
    public SimpleTypeEx() {
        
        super();
        this.kind=KIND_ATOMIC;
    }
    
    public String getName() {
        if(this.name==null){
            this.name=this.getLabelName();
        }
        return this.name;
    }
    
    
    public void setName(String name) {
        String oldName=this.getName();
        if(oldName==null||!name.equals(oldName)){
            this.name = name;
            this.firePropertyChanged(this);
        }
    }
    public void reName(String newName){
        if(newName==null){
            return;
        }
        String oldName=this.getName();
        this.setName(newName);
        if(!newName.equals(oldName)){
            this.fireChildRenamed(this);
        }
    }
    
    public String getKind() {
        return kind;
    }
    
    public void setKind(String kind) {
        if(kind=="atomic"||kind=="list"||kind=="choice"){
            this.kind = kind;
        }
    }
    
    public String getBaseType() {
        return baseType;
    }
    
    public void setBaseType(String baseType) {
        if(this.kind=="atomic"){
            String oldProperty=this.baseType;
            if(oldProperty==null||!oldProperty.equals(baseType)){
                this.clear();
                this.baseType = baseType;   
                this.firePropertyChanged(this);
            }
        }
    }
    
    private void clear() {
        this.baseType=null;
        this.itemType=null;
        this.memberTypes.clear();
    }
    
    public String getItemType() {
        return itemType;
    }
    
    public void setItemType(String itemType) {
        this.clear();
        if(this.kind=="list"){
            String oldProperty=this.itemType;
            if(oldProperty==null||!oldProperty.equals(itemType)){
                this.clear();
                this.itemType = itemType;   
                this.firePropertyChanged(this);
            }
               
        }
    }
    
    public void addMemberType(String typeEx){
        if(this.kind=="union"){
            this.memberTypes.add(typeEx);    
        }
    }
    public void removeMemberType(String typeEx){
        if(this.kind=="union"){
            this.memberTypes.remove(typeEx); 
        }
        
    }
    
    public String getMemberTypes() {
        String numberTypesString="";
        for (Iterator iter = this.memberTypes.iterator(); iter.hasNext();) {
            String numberType = (String) iter.next();
            numberTypesString+=numberType+" ";
        }
        return numberTypesString;
    }
    
    public void setMemberTypes(String numberTypesString) {
        String temp=numberTypesString;
        int index;
        this.memberTypes.clear();
        while((index=temp.indexOf(' '))!=-1){
            this.memberTypes.add(temp.substring(0,index-1));
            temp=temp.substring(index+1);
        }
        this.firePropertyChanged(this);
    }
}
