
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.listeners.IDeriveLabelListener;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.listeners.IPropertyListener;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLWriter;

public abstract class WSDLLabel {
    public static final String DEFINITION="definitions";
    public static final String IMPORT="import";
    
    public static final String TYPES="types";
    public static final String SCHEMA="schema";
    public static final String ELEMENT="element";
    public static final String COMPLEX_TYPE="comlexType";
    public static final String SIMPLE_TYPE="simpleType";
    public static final String COMB_ALL="all";
    public static final String COMB_SEQ="sequence";
    public static final String COMB_CHOICE="choice";
    
    public static final String MESSAGE="message";
    public static final String PART="part";
    
    public static final String PORTTYPE="portType";
    public static final String OPERATION="operation";
    public static final String INPUT="input";
    public static final String OUTPUT="output";
    public static final String FAULT="fault";
    
    public static final String BINDING="binding";
    public static final String BINDING_OPERATION="operation";
    public static final String BINDING_INPUT="input";
    public static final String BINDING_OUTPUT="output";
    public static final String BINDING_FAULT="fault";
    
    public static final String SERVICE="service";
    public static final String PORT="port";
    
    public static final String SOAP_ADDR="soap:address";
    public static final String SOAP_BINDING="soap:binding";
    public static final String SOAP_BODY="soap:body";
    public static final String SOAP_FAULT="soap:fault";
    public static final String SOAP_HEAD="soap:header";
    public static final String SOAP_OPER="soap:operation";
    
    public static final String HTTP_ADDR="http:address";
    public static final String HTTP_BINDING="http:binding";
    public static final String HTTP_OPER="http:operation";
    public static final String HTTP_URLENC="http:urlEncoded";
    public static final String HTTP_URLREP="http:urlReplacement";
    
    public static final String MIME_CONTENT="mime:content";
    public static final String MIME_MUL="mime:multipartRelated";
    public static final String MIME_PART="mime:part";
    public static final String MIME_XML="mime:mimeXml";
    
    
    public WSDLLabel() {
        super();
            }
    Map properties=null;
    
    public Map getProperties() {
        if(properties==null){
            properties=new HashMap();
        }
        return properties;
    }
    
    
    protected DefinitionEx definitionEx;
    
    public DefinitionEx getDefinitionEx() {
        return definitionEx;
    }
    
    public void setDefinitionEx(DefinitionEx definitionEx) {
        this.definitionEx = definitionEx;
    }
    
    
    protected String labelName;
    
    public String getLabelName() {
        if(labelName==null){
            if(this instanceof DefinitionEx){
                labelName="definitions";
            }
            else if(this instanceof ImportEx){
                labelName="import";
            }
            else if(this instanceof TypesEx){
                labelName="types";
            }
            else if(this instanceof SchemaEx){
                labelName="schema";
            }
            else if(this instanceof ComplexTypeEx){
                labelName="complexType";
            }
            else if(this instanceof SimpleTypeEx){
                labelName="simpleType";
            }
            else if(this instanceof ElementEx){
                labelName="element";
            }
            else if(this instanceof Combiner){
               labelName=((Combiner)this).getKind();
            }
            else if(this instanceof MessageEx){
                labelName="message";
            }
            else if(this instanceof PartEx){
                labelName="part";
            }
            else if(this instanceof PortTypeEx){
                labelName="portType";
            }
            else if(this instanceof OperationEx){
                labelName="operation";
            }
            else if(this instanceof InputEx){
                labelName="input";
            }
            else if(this instanceof OutputEx){
                labelName="output";
            }
            else if(this instanceof FaultEx){
                labelName="fault";
            }
            else if(this instanceof BindingEx){
                labelName="binding";
            }
            else if(this instanceof BindingOperationEx){
                labelName="operation";
            }
            else if(this instanceof BindingFaultEx){
                labelName="fault";
            }
            else if(this instanceof BindingInputEx){
                labelName="input";
            }
            else if(this instanceof BindingOutputEx){
                labelName="output";
            }
            else if(this instanceof ServiceEx){
                labelName="service";
            }
            else if(this instanceof PortEx){
                labelName="port";
            }
            else if(this instanceof SOAPAddress){
                labelName="soap:address";
            }  
            else if(this instanceof SOAPBinding){
                labelName="soap:binding";
            }
            else if(this instanceof SOAPBody){
                labelName="soap:body";
            }
            else if(this instanceof SOAPFault){
                labelName="soap:fault";
            }
            else if(this instanceof SOAPHeader){
                labelName="soap:header";
            }
            else if(this instanceof SOAPOperation){
                labelName="soap:operation";
            }
            else if(this instanceof HTTPAddress){
                labelName="http:address";
            }
            else if(this instanceof HTTPBinding){
                labelName="http:binding";
            }
            else if(this instanceof HTTPOperation){
                labelName="http:operation";
            }
            else if(this instanceof HTTPUrlEncoded){
                labelName="http:urlEncoded";
            }
            else if(this instanceof HTTPUrlReplacement){
                labelName="http:urlReplacement";
            }
            else if(this instanceof MIMEContent){
                labelName="mime:content";
            }
            else if(this instanceof MIMEMultipartRelated){
                labelName="mime:multipartRelated";
            }
            else if(this instanceof MIMEPart){
                labelName="mime:part";
            }
            else if(this instanceof MIMEXml){
                labelName="mime:mimeXml";
            }
        }
        return labelName;
    }
    
    abstract public String getName();
    
    Collection propertyListeners=new Vector();
    public boolean addIPropertyListener(IPropertyListener listener){
        return propertyListeners.add(listener);
    }
    public boolean removeIPropertyListener(IPropertyListener listener){
        return propertyListeners.remove(listener);
    }
    
    
    Collection deriveLabelListeners=new Vector();
 
    
    public boolean addIDeriveLabelListeners(IDeriveLabelListener element) {
        return deriveLabelListeners.add(element);
    }
    
    public boolean removeIDeriveLabelListeners(IDeriveLabelListener element) {
        return deriveLabelListeners.remove(element);
    }
    
	protected void fireChildAdded(WSDLLabel childLabel){
	    for (Iterator iter = this.deriveLabelListeners.iterator(); iter.hasNext();) {
            IDeriveLabelListener listener = (IDeriveLabelListener) iter.next();
            listener.childAdded(childLabel);
        }
	    if(!(this instanceof DefinitionEx)){
	        for (Iterator iter = this.getDefinitionEx().deriveLabelListeners.iterator(); iter.hasNext();) {
	            IDeriveLabelListener listener = (IDeriveLabelListener) iter.next();
	            if (listener instanceof WSDLWriter) {
	                ((WSDLWriter)listener).childAdded(childLabel);
                }
	        }
	    }
	    
	}
	protected void fireChildRemoved(WSDLLabel childLabel){
	    for (Iterator iter = this.deriveLabelListeners.iterator(); iter.hasNext();) {
            IDeriveLabelListener listener = (IDeriveLabelListener) iter.next();
            listener.childRemoved(childLabel);
        }	
	    if(!(this instanceof DefinitionEx)){
	        for (Iterator iter = this.getDefinitionEx().deriveLabelListeners.iterator(); iter.hasNext();) {
	            IDeriveLabelListener listener = (IDeriveLabelListener) iter.next();
	            if (listener instanceof WSDLWriter) {
	                ((WSDLWriter)listener).childRemoved(childLabel);
                }
	        }
	    }
	}
	protected void fireChildRenamed(WSDLLabel label){
	    for (Iterator iter = this.deriveLabelListeners.iterator(); iter.hasNext();) {
            IDeriveLabelListener listener = (IDeriveLabelListener) iter.next();
            listener.lableRenamed(label);
        }	    
	}
	protected void firePropertyChanged(WSDLLabel label){
	    for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            IPropertyListener listener = (IPropertyListener) iter.next();
            listener.propertyChanged(label);
        }
	    if(!(this instanceof DefinitionEx)){
	        for (Iterator iter = this.getDefinitionEx().propertyListeners.iterator(); iter.hasNext();) {
	            IPropertyListener listener = (IPropertyListener) iter.next();
	            if (listener instanceof WSDLWriter) {
	                listener.propertyChanged(label);
                }
	        }
	    }
	}
    
 
}
