
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view;
import java.awt.BorderLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.HashMap;
import java.util.ResourceBundle;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu.AbstractTreeRightMenu;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu.MenuFactory;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.WSDLPropertyTable;
import org.act.wsc.bpel4wsmodeling.view.graphic.LayerViewer;
import org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty.AddPropertyByType;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class WSDLTreePane extends LayerViewer {
    HashMap labelToNode = new HashMap();    
    private ResourceBundle res = ResChoose.getLanguage();
    DefinitionEx definitions = null;
    JTree WSDLTree;
    MyTreeNode root;
    MyTreeNode imports;
    MyTreeNode types;
    MyTreeNode messages;
    MyTreeNode portTypes;
    MyTreeNode bindings;
    MyTreeNode services;
    private String name = res.getString("WSDLTP_NoName");
    public static WSDLTreePane instance = null;
    
    public WSDLTreePane() {
        super();
        definitions = new DefinitionEx();
        this.layer = new WSDLLayer(definitions);
        jbInit();
        instance = this;
    }
    
    public WSDLTreePane(WSDLLayer layer) {
        super();
        this.layer = layer;
        this.definitions = layer.getDefinitionEx();
        jbInit();
        instance = this;
    }
    
    private void jbInit() {
        name = definitions.getName() + res.getString("WSDLTP_UDWSDL");
        root = new MyTreeNode(definitions, 0, this);
        imports = new MyTreeNode("imports", 1, this);
        types = new MyTreeNode("types", 1, this);
        messages = new MyTreeNode("messages", 1, this);
        portTypes = new MyTreeNode("portTypes", 1, this);
        bindings = new MyTreeNode("bindings", 1, this);
        services = new MyTreeNode("services", 1, this);
        root.add(imports);
        root.add(types);
        root.add(messages);
        root.add(portTypes);
        root.add(bindings);
        root.add(services);
        this.WSDLTree = new JTree(root);
        this.setLayout(new BorderLayout());
        this.add(this.WSDLTree);
        this.WSDLTree.addMouseListener(new MyMouseAdapter(this));
    }
                                                                                                                                                                                                                                                                                                        
    public JTree getWSDLTree() {
        return WSDLTree;
    }
    
    public HashMap getLabelToNode() {
        return labelToNode;
    }
    
    public DefinitionEx getDefinitions() {
        return definitions;
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public void setController() {
            }
    public static void main(String[] args) {
        WSDLTreePane pane = new WSDLTreePane();
        final JFrame frame = new JFrame();
        frame.setSize(800, 600);
        frame.getContentPane().add(new JScrollPane(pane));
        frame.show();
        frame.addWindowListener(new WindowListener() {
            public void windowActivated(WindowEvent e) {
                            }
            public void windowClosed(WindowEvent e) {
                            }
            public void windowClosing(WindowEvent e) {
                                frame.dispose();
            }
            public void windowDeactivated(WindowEvent e) {
                            }
            public void windowDeiconified(WindowEvent e) {
                            }
            public void windowIconified(WindowEvent e) {
                            }
            public void windowOpened(WindowEvent e) {
                            }
        });
    }
}

class MyMouseAdapter implements MouseListener {
    WSDLTreePane ownerPane;
    
    public MyMouseAdapter(WSDLTreePane ownerPane) {
        super();
        this.ownerPane = ownerPane;
    }
    
    public void mouseClicked(MouseEvent e) {
        if (e.getButton() == 3 && e.getClickCount() == 1) {
                        AbstractTreeRightMenu menu = MenuFactory
                    .createMenuByNode((MyTreeNode) ((JTree) e.getSource())
                            .getSelectionPath().getLastPathComponent());
            menu.show(ownerPane, e.getX(), e.getY());
        } else if (e.getButton() == 1 && e.getClickCount() == 1) {
                                                            WSDLPropertyTable propertyTable = new WSDLPropertyTable(
                    ((MyTreeNode) ((JTree) e.getSource()).getSelectionPath()
                            .getLastPathComponent()).getWsdlLabel());
            AddPropertyByType.addWSDLPropertyToFrame(new WSDLPropertyTable(
                    ((MyTreeNode) ((JTree) e.getSource()).getSelectionPath()
                            .getLastPathComponent()).getWsdlLabel()));
        }
    }
    
    public void mouseEntered(MouseEvent e) {
            }
    
    public void mouseExited(MouseEvent e) {
            }
    
    public void mousePressed(MouseEvent e) {
            }
    
    public void mouseReleased(MouseEvent e) {
            }
}
