
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlEncoded;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlReplacement;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEMultipartRelated;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingHTTPFaultRightMenu extends AbstractTreeRightMenu {
    
	  private ResourceBundle res = ResChoose.getLanguage();
    JMenu addExtensibilityElement=new JMenu(res.getString("BHTTPFRM_AddEx"));
    JMenuItem addHTTPUrlEncoded = new JMenuItem(res.getString("BHTTPFRM_AddHUrlEncode"));
    JMenuItem addHTTPUrlReplacement = new JMenuItem(res.getString("BHTTPFRM_AddHurlRep"));
    JMenuItem addMIMEContent = new JMenuItem(res.getString("BHTTPFRM_AddMimeContent"));
    JMenuItem addMIMEMultipartRelated = new JMenuItem(res.getString("BHTTPFRM_AddMimeMultipartRelated"));
    JMenuItem addMIMEXml = new JMenuItem(res.getString("BHTTPFRM_AddMimeXml"));
    JMenuItem setName = new JMenuItem(res.getString("BHTTPFRM_SetName"));
    
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addHTTPUrlEncoded);
    	addExtensibilityElement.add(addHTTPUrlReplacement);
    	addExtensibilityElement.add(addMIMEContent);
    	addExtensibilityElement.add(addMIMEMultipartRelated);
    	addExtensibilityElement.add(addMIMEXml);
     }
    
    
    public BindingHTTPFaultRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        
        if (myTreeNode.getWsdlLabel() instanceof BindingFaultEx) {
            final BindingFaultEx bindingFaultEx = (BindingFaultEx) myTreeNode
                    .getWsdlLabel();
            final BindingOperationEx bindingOperationEx = (BindingOperationEx)((MyTreeNode) myTreeNode.getParent()).getWsdlLabel();
            this.setName.addActionListener(new ActionListener() {
                String initialV = bindingFaultEx.getName();
                public void actionPerformed(ActionEvent e) {
                    String result = PropertyEditorFactory.showEditor(
                            BindingFaultEx.ATT_NAME + ": ", ""
                                    + BindingFaultEx.ATT_NAME, initialV);
                    if(result!=null){
                        bindingFaultEx.setName(result);
                        bindingFaultEx.setFaultEx((FaultEx) bindingOperationEx.getOperation().getFault(result));
                    }
                    
                }
            });
            this.add(setName);
                        
               this.addHTTPUrlReplacement.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          HTTPUrlReplacement httpUrlReplacement=(HTTPUrlReplacement)bindingFaultEx.getDefinitionEx().createHTTPUrlReplacement();
                          bindingFaultEx.addExtensibilityElement(httpUrlReplacement);
                   }});
               
               this.addHTTPUrlEncoded.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          HTTPUrlEncoded httpUrlEncoded=(HTTPUrlEncoded)bindingFaultEx.getDefinitionEx().createHTTPUrlEncoded();
                          bindingFaultEx.addExtensibilityElement(httpUrlEncoded);
                   }});
               
               this.addMIMEContent.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEContent mimeContent=(MIMEContent)bindingFaultEx.getDefinitionEx().createMIMEContent();
                          bindingFaultEx.addExtensibilityElement(mimeContent);
                   }});
               
               this.addMIMEMultipartRelated.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEMultipartRelated mimeMultipartRelated=(MIMEMultipartRelated)bindingFaultEx.getDefinitionEx().createMIMEMultipartRelated();
                          bindingFaultEx.addExtensibilityElement(mimeMultipartRelated);
                   }});
               
               this.addMIMEXml.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEXml mimeXml=(MIMEXml)bindingFaultEx.getDefinitionEx().createMIMEXml();
                          bindingFaultEx.addExtensibilityElement(mimeXml);
                   }});
        }
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
