
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.PaneHolder;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingHTTPRightMenu extends AbstractTreeRightMenu {
	  private ResourceBundle res = ResChoose.getLanguage();
    
	JMenuItem setType=new JMenuItem(res.getString("BHTTPRM_SetType"));
    JMenuItem addOperation=new JMenuItem(res.getString("BHTTPRM_AOperation"));
    JMenu addExtensibilityElement=new JMenu(res.getString("BHTTPRM_AExtensibilityElement"));
    JMenuItem addHTTPBinding = new JMenuItem(res.getString("BHTTPRM_AHTTPBinding"));
   
    
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addHTTPBinding);
     }
    
    
    public BindingHTTPRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (BindingHTTPRightMenu.this.myTreeNode.getWsdlLabel() instanceof BindingEx) {
            final BindingEx bindingEx = (BindingEx) BindingHTTPRightMenu.this.myTreeNode.getWsdlLabel();
            this.renameItem.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String newName=JOptionPane.showInputDialog(PaneHolder.getInstance(),res.getString("BHTTPRM_Newname"),res.getString("BHTTPRM_Rename"),JOptionPane.QUESTION_MESSAGE);
                    
                        bindingEx.reName(newName);
                }});
           
            this.add(this.addExtensibilityElement);
                       this.addHTTPBinding.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                       HTTPBinding binding=(HTTPBinding)bindingEx.getDefinitionEx().createHTTPBinding();
                        bindingEx.addExtensibilityElement(binding);
                }});
            
            this.addOperation.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    	BindingOperationEx bindingOperationEx=(BindingOperationEx)bindingEx.getDefinitionEx().createBindingOperation();
                        bindingEx.addBindingOperation(bindingOperationEx);
                    }});
            
            this.setType.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=null;
                    if(bindingEx.getPortType()!=null){
                       initialV=bindingEx.getDefinitionEx().QNameToString(bindingEx.getPortType().getQName()); 
                    }
                    List options=new Vector();
                    for (Iterator iter = bindingEx.getDefinitionEx().getPortTypes().values().iterator(); iter.hasNext();) {
                        PortTypeEx element = (PortTypeEx) iter.next();
                        options.add(element.getName());
                    }
                    String type = PropertyEditorFactory.showEditor( BindingEx.ATT_TYPE + ": ", ""
                            + BindingEx.ATT_TYPE, initialV, options);
                    if(type!=null){
                        bindingEx.setPortType(bindingEx.getDefinitionEx().getPortType(bindingEx.getDefinitionEx().StringToQName(type)));
                    }
                }});
            
            this.add(setType);
            this.add(addOperation);
            this.add(this.renameItem);
        }
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
