
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingSOAPOutputRightMenu extends AbstractTreeRightMenu {
    
	  private ResourceBundle res = ResChoose.getLanguage();
	
    JMenu addExtensibilityElement=new JMenu(res.getString("BSOAPOURM_AExtensibilityElement"));
    JMenuItem addSOAPBody = new JMenuItem(res.getString("BSOAPOURM_ABody"));
    JMenuItem addSOAPHeader = new JMenuItem(res.getString("BSOAPOURM_AHeader"));
    JMenuItem setName = new JMenuItem(res.getString("BSOAPOURM_SetName"));
    
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addSOAPBody);
    	addExtensibilityElement.add(addSOAPHeader);
     }
    
    
    public BindingSOAPOutputRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
       
        
        if (myTreeNode.getWsdlLabel() instanceof BindingOutputEx) {
            final BindingOutputEx bindingOutputEx = (BindingOutputEx)myTreeNode.getWsdlLabel();
            this.setName.addActionListener(new ActionListener() {
                String initialV = bindingOutputEx.getName();
                public void actionPerformed(ActionEvent e) {
                    String result = PropertyEditorFactory.showEditor(
                            BindingOutputEx.ATT_NAME + ": ", ""
                                    + BindingOutputEx.ATT_NAME, initialV);
                    if(result!=null){
                        bindingOutputEx.setName(result);    
                    }
                    
                }
            });
            this.add(setName);
            this.add(this.addExtensibilityElement);
            this.addSOAPBody.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    SOAPBody soapBody = (SOAPBody) bindingOutputEx
                            .getDefinitionEx().createSOAPBody();
                    bindingOutputEx.addExtensibilityElement(soapBody);
                }
            });
            this.addSOAPHeader.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    SOAPHeader soapHeader = (SOAPHeader) bindingOutputEx
                            .getDefinitionEx().createSOAPHeader();
                    bindingOutputEx.addExtensibilityElement(soapHeader);
                }
            });
        }
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
