
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ExtensibilityElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.utils.ConstanceSet;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class PartRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
    JMenuItem setElemente = new JMenuItem(res.getString("PARTRM_SetElement"));
    JMenuItem setType = new JMenuItem(res.getString("PARTRM_SetType"));
    PartEx partEx = null;
    
    public PartRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof PartEx) {
            partEx = (PartEx) myTreeNode.getWsdlLabel();
            this.renameItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String newName = JOptionPane.showInputDialog(MainFrame
                            .getmainFrame(), res.getString("PARTRM_NewName"), res.getString("PARTRM_Rename"),
                            JOptionPane.QUESTION_MESSAGE);
                    partEx.reName(newName);
                }
            });
            this.setElemente.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    List options = new Vector();
                    try{
                        for (Iterator iter = partEx.getDefinitionEx().getTypes()
                                .getExtensibilityElements().iterator(); iter
                                .hasNext();) {
                            SchemaEx schemaEx = (SchemaEx) iter.next();
                            for (Iterator iterator = schemaEx.getElememts()
                                    .iterator(); iterator.hasNext();) {
                                ElementEx elementEx = (ElementEx) iterator.next();
                                options.add(elementEx.getName());
                            }
                        }
                    }catch(NullPointerException ex){
                        
                    }
                   
                    String initialV = partEx.getDefinitionEx().QNameToString(partEx
                            .getElementName());
                    String element = PropertyEditorFactory.showEditor(
                            PartEx.ATT_ELEMENT + ": ", res.getString("PARTRM_Set")
                                    + PartEx.ATT_ELEMENT, initialV, options);
                    if (element != null) {
                        partEx.setElementName(partEx.getDefinitionEx().StringToQName(element));
                    }
                }
            });
            this.add(setElemente);
            this.setType.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    List options = new Vector();
                    for (Iterator iter = ConstanceSet.getXMLSchemaBuildinTypes().iterator(); iter.hasNext();) {
                        String type = (String) iter.next();
                        options.add(type);
                    }
                    if(partEx.getDefinitionEx().getTypes()!=null){
                        for (Iterator iter = partEx.getDefinitionEx().getTypes()
                                .getExtensibilityElements().iterator(); iter
                                .hasNext();) {
                            ExtensibilityElementEx extensibilityElementEx = (ExtensibilityElementEx) iter.next();
                            if (extensibilityElementEx instanceof SchemaEx) {
                                SchemaEx schemaEx = (SchemaEx) extensibilityElementEx;
                                String nsPrefix=schemaEx.getDefinitionEx().getPrefix(schemaEx.getTargetNamespace());
                                for (Iterator iterator = schemaEx.getSimpleTypes()
                                        .iterator(); iterator.hasNext();) {
                                    SimpleTypeEx elementEx = (SimpleTypeEx) iterator
                                            .next();
                                    options.add(nsPrefix+":"+elementEx.getName());
                                }
                                for (Iterator iterator = schemaEx.getComplexTypes()
                                        .iterator(); iterator.hasNext();) {
                                    ComplexTypeEx elementEx = (ComplexTypeEx) iterator
                                            .next();
                                    options.add(nsPrefix+":"+elementEx.getName());
                                }
                            }
                        }
                    }
                    
                    String initialV = partEx.getDefinitionEx().QNameToString(partEx
                            .getTypeName());
                    String element = PropertyEditorFactory.showEditor(
                            PartEx.ATT_TYPE + ": ", res.getString("PARTRM_Set")
                                    + PartEx.ATT_TYPE, initialV, options);
                    if (element!=null) {
                        partEx.setTypeName(partEx.getDefinitionEx().StringToQName(element));
                    }
                    
                }
            });
            this.add(setType);
            this.add(this.renameItem);
        }
        this.add(this.removeItem);
    }
}
