
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPFault;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class SOAPFaultRightMenu extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
   JMenuItem setName=new JMenuItem(res.getString("SOAPFRM_SetName"));
   JMenuItem setUse=new JMenuItem(res.getString("SOAPFRM_SetUse"));
   JMenuItem setEncodingStyle=new JMenuItem(res.getString("SOAPFRM_SetEncodingStyle"));
   JMenuItem setNamespace=new JMenuItem(res.getString("SOAPFRM_Namespace"));
   
    public SOAPFaultRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof SOAPFault) {
            final SOAPFault fault = (SOAPFault) myTreeNode.getWsdlLabel();
            final BindingOperationEx bindingOperationEx=(BindingOperationEx)((MyTreeNode)myTreeNode.getParent().getParent()).getWsdlLabel();
            this.setName.addActionListener(new ActionListener(){
                
                public void actionPerformed(ActionEvent e) {
                    String initialV=fault.getName();
                    List options=new Vector();
                    for (Iterator iter = bindingOperationEx.getBindingFaults().values().iterator(); iter.hasNext();) {
                        BindingFaultEx faultEx = (BindingFaultEx) iter.next();
                        options.add(faultEx.getName());
                    }
                    String result=PropertyEditorFactory.showEditor(SOAPFault.ATT_NAME+": ",res.getString("SOAPFRM_Set")+SOAPFault.ATT_NAME,initialV,options);
                    if (result!=null) {
                        fault.setName(result);
                    }
                    
                }});
            this.add(setName);
            
            this.setUse.addActionListener(new ActionListener(){
                
                public void actionPerformed(ActionEvent e) {
                    String initialV=fault.getUse();
                    List options=new Vector();
                    options.add("literal");
                    options.add("encoded");
                    String use=PropertyEditorFactory.showEditor(SOAPFault.ATT_USE+": ",res.getString("SOAPFRM_Set")+SOAPFault.ATT_USE,initialV,options);
                    if(use!=null){
                        fault.setUse(use);
                    }
                }});
            this.add(setUse);
            
            this.setEncodingStyle.addActionListener(new ActionListener(){
                String initialV=fault.getEncodingStyle();
                public void actionPerformed(ActionEvent e) {
                    String result=PropertyEditorFactory.showEditor(SOAPFault.ATT_ENC_STYLE+": ",res.getString("SOAPFRM_Set")+SOAPFault.ATT_ENC_STYLE,initialV);
                    if(result!=null){
                        fault.setEncodingStyle(result);
                    }
                    
                }});
            this.add(setEncodingStyle);
            
            this.setNamespace.addActionListener(new ActionListener(){
                String initialV=fault.getNamespace();
                public void actionPerformed(ActionEvent e) {
                    String result=PropertyEditorFactory.showEditor(SOAPFault.ATT_NS+": ",res.getString("SOAPFRM_Set")+SOAPFault.ATT_NS,initialV);
                    if(result!=null){
                        fault.setNamespace(result);
                    }
                    
                }});
            this.add(setNamespace);
            
        }
        this.add(this.removeItem);
    }
}
