
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class SchemaRightMenu extends AbstractTreeRightMenu {
	private ResourceBundle res = ResChoose.getLanguage();
    JMenuItem setTargetNamespace = new JMenuItem(res.getString("SCRM_SetTargetNamespace"));
    JMenuItem setNamespace = new JMenuItem(res.getString("SCRM_AODNamespace"));
    JMenuItem addElement = new JMenuItem(res.getString("SCRM_AElement"));
    JMenuItem addComplexType = new JMenuItem(res.getString("SCRM_AComplexType"));
    JMenuItem addSimpleType = new JMenuItem(res.getString("SCRM_ASimpleType"));
    
    public SchemaRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof SchemaEx) {
            final SchemaEx schemaEx = (SchemaEx) myTreeNode.getWsdlLabel();
            this.add(this.setTargetNamespace);
            this.setTargetNamespace.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String initialV = schemaEx.getTargetNamespace();
                    String result = PropertyEditorFactory.showEditor(
                            DefinitionEx.ATT_TARGET_NS + ": ",res.getString("SCRM_Set")
                                    + DefinitionEx.ATT_TARGET_NS, initialV);
                    if(result!=null){
                        schemaEx.setTargetNamespace(result);
                    }
                    
                }
            });
            this.add(this.setNamespace);
            this.setNamespace.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    Map namespaces=PropertyEditorFactory.showNamespacesEditor(schemaEx.getNamespaces());
                    if(namespaces!=null){
                        schemaEx.setNamespaces(namespaces);
                    }
                }});
            
            this.add(this.addElement);
            this.addElement.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    ElementEx elementEx = (ElementEx) schemaEx
                            .getDefinitionEx().createElement();
                    schemaEx.addElement(elementEx);
                }
            });
            this.add(this.addComplexType);
            this.addComplexType.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    ComplexTypeEx complexTypeEx = (ComplexTypeEx) schemaEx
                            .getDefinitionEx().createComplexType();
                    schemaEx.addComplexType(complexTypeEx);
                }
            });
            this.add(this.addSimpleType);
            this.addSimpleType.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    SimpleTypeEx simpleTypeEx = (SimpleTypeEx) schemaEx
                            .getDefinitionEx().createSimpleType();
                    schemaEx.addSimpleType(simpleTypeEx);
                }
            });
        }
    }
}
