
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor;
import java.util.Iterator;
import java.util.ResourceBundle;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ImportEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.InputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPFault;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ServiceEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.listeners.IPropertyListener;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class WSDLPropertyTable extends JTable implements IPropertyListener{
	 ResourceBundle res = ResChoose.getLanguage();
    JTable table=null;
    
    WSDLLabel label;
    
    String[][] propertyNV = null;
    
    public WSDLPropertyTable(WSDLLabel label) {
        super();
        this.label = label;
        initPropertyNV();
        if(propertyNV!=null){
            regularizePropertyNV();
            MyTableModel model=new MyTableModel();
            table=new JTable(model);
            model.setDataVector(propertyNV,new String[]{res.getString("propertyname"),res.getString("propertyvalue")});
            label.addIPropertyListener(this);
        }
    }
    
    private void regularizePropertyNV() {
        for (int i = 0; i < propertyNV.length; i++) {
            for (int j = 0; j < propertyNV[i].length; j++) {
                if(propertyNV[i][j]==null){
                    propertyNV[i][j]="";
                }
            }
        }
    }
    
    private void initPropertyNV() {
        propertyNV=null;
        if(label instanceof DefinitionEx){
            definitionProperty();
        }
        else if(label instanceof ImportEx){
            importProperty();
        }
        else if(label instanceof SchemaEx){
            schemaProperty();
        }
        else if(label instanceof ElementEx){
            elementProperty();
        }
        else if(label instanceof ComplexTypeEx){
            complexTypeProperty();
        }
        else if(label instanceof SimpleTypeEx){
            simpleTypeProperty();
        }
        else if(label instanceof MessageEx){
            messageProperty();
        }
        else if(label instanceof PartEx){
            partProperty();
        }
        else if(label instanceof PortTypeEx){
            portTypeProperty();
        }
        else if(label instanceof OperationEx){
            operationProperty();
        }
        else if(label instanceof InputEx){
            inputProperty();
        }
        else if(label instanceof OutputEx){
            outputProperty();
        }
        else if(label instanceof FaultEx){
            faultProperty();
        }
        else if(label instanceof BindingEx){
            bindingProperty();
        }
        else if(label instanceof BindingOperationEx){
            bindingOperationProperty();
        }
        else if(label instanceof BindingInputEx){
            bindingInputProperty();
        }
        else if(label instanceof BindingOutputEx){
            bindingOutputProperty();
        }
        else if(label instanceof BindingFaultEx){
            bindingFaultProperty();
        }
        else if(label instanceof ServiceEx){
            serviceProperty();
        }
        else if(label instanceof PortEx){
            portProperty();
        }
        else if(label instanceof SOAPAddress){
            SOAPAddressProperty();
        }
        else if(label instanceof SOAPBody){
            SOAPBodyProperty();
        }
        else if(label instanceof SOAPHeader){
            SOAPHeaderProperty();
        }
        else if(label instanceof SOAPFault){
            SOAPFaultProperty();
        }
        else if(label instanceof SOAPOperation){
            SOAPOperationProperty();
        }
        else if(label instanceof SOAPBinding){
            SOAPBindingProperty();
        }
        else if(label instanceof HTTPAddress){
            HTTPAddressProperty();
        }
        else if(label instanceof HTTPBinding){
            HTTPBindingProperty();
        }
        else if(label instanceof HTTPOperation){
            HTTPOperationProperty();
        }
        else if(label instanceof MIMEContent){
            MIMEContentProperty();
        }
        else if(label instanceof MIMEXml){
            MIMEXmlProperty();
        }
    }
    
   
   
    
    private void definitionProperty() {
        int size=((DefinitionEx)label).getNamespaces().size();
        propertyNV=new String[size+2][2];
        int index=0;
        if(((DefinitionEx)label).getQName()!=null){
            propertyNV[index][0]=DefinitionEx.ATT_NAME;
            propertyNV[index][1]=((DefinitionEx)label).getQName().getLocalPart();
            index++;
        }
        if(((DefinitionEx)label).getTargetNamespace()!=null){
            propertyNV[index][0]=DefinitionEx.ATT_TARGET_NS;
            propertyNV[index][1]=((DefinitionEx)label).getTargetNamespace();
            index++;
        }
        for (Iterator iter = ((DefinitionEx)label).getNamespaces().keySet().iterator(); iter.hasNext();) {
            String prefix = (String) iter.next();
            String ns=(String)((DefinitionEx)label).getNamespaces().get(prefix);
            propertyNV[index][0]=prefix;
            propertyNV[index][1]=ns;
            index++;
        }
    }
    
    private void MIMEXmlProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=MIMEXml.ATT_PART;
        propertyNV[0][1]=((MIMEXml)label).getPart();
    }
    
    
    private void schemaProperty() {
        int size=((SchemaEx)label).getNamespaces().size();
        propertyNV=new String[size+1][2];
        int index=0;
        if(((SchemaEx)label).getTargetNamespace()!=null){
            propertyNV[index][0]=SchemaEx.ATT_TNS;
            propertyNV[index][1]=((SchemaEx)label).getTargetNamespace();
            index++;
        }
        for (Iterator iter = ((SchemaEx)label).getNamespaces().keySet().iterator(); iter.hasNext();) {
            String prefix = (String) iter.next();
            String ns=(String)((SchemaEx)label).getNamespaces().get(prefix);
            propertyNV[index][0]=prefix;
            propertyNV[index][1]=ns;
            index++;
        }
    }
    
    
    private void MIMEContentProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=MIMEContent.ATT_PART;
        propertyNV[1][0]=MIMEContent.ATT_TYPE;
        propertyNV[0][1]=((MIMEContent)label).getPart();
        propertyNV[1][1]=((MIMEContent)label).getType();   
    }
    
    private void HTTPOperationProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=HTTPOperation.ATT_LOC;
        propertyNV[0][1]=((HTTPOperation)label).getLocation();
    }
    
    private void HTTPBindingProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=HTTPBinding.ATT_VERB;
        propertyNV[0][1]=((HTTPBinding)label).getVerb();
    }
    
    private void HTTPAddressProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=HTTPAddress.ATT_LOC;
        propertyNV[0][1]=((HTTPAddress)label).getLocation();
        
    }
    
    private void SOAPBindingProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=SOAPBinding.ATT_STYLE;
        propertyNV[1][0]=SOAPBinding.ATT_TRAN;
        propertyNV[0][1]=((SOAPBinding)label).getStyle();
        propertyNV[1][1]=((SOAPBinding)label).getTransport();
    }
    
    private void SOAPOperationProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=SOAPOperation.ATT_ACTION;
        propertyNV[1][0]=SOAPOperation.ATT_STYLE;
        propertyNV[0][1]=((SOAPOperation)label).getSoapAction();
        propertyNV[1][1]=((SOAPOperation)label).getStyle();
    }
    
    private void SOAPFaultProperty() {
        propertyNV=new String[4][2];
        propertyNV[0][0]=SOAPFault.ATT_NAME;
        propertyNV[1][0]=SOAPFault.ATT_USE;
        propertyNV[2][0]=SOAPFault.ATT_ENC_STYLE;
        propertyNV[3][0]=SOAPFault.ATT_NS;
        
        propertyNV[0][1]=((SOAPFault)label).getName();
        propertyNV[1][1]=((SOAPFault)label).getUse();
        propertyNV[2][1]=((SOAPFault)label).getEncodingStyle();
        propertyNV[3][1]=((SOAPFault)label).getNamespace();
    }
    
    private void SOAPHeaderProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=SOAPHeader.ATT_ELE;
        propertyNV[1][0]=SOAPHeader.ATT_FAULT;
        propertyNV[0][1]=((SOAPHeader)label).getElement();
        propertyNV[1][1]=((SOAPHeader)label).getFault();
        
    }
    
    private void SOAPBodyProperty() {
        propertyNV=new String[4][2];
        propertyNV[0][0]=SOAPBody.ATT_PARTS;
        propertyNV[1][0]=SOAPBody.ATT_USE;
        propertyNV[2][0]=SOAPBody.ATT_ENC_STYLE;
        propertyNV[3][0]=SOAPBody.ATT_NS;
        
        propertyNV[0][1]=((SOAPBody)label).getParts();
        propertyNV[1][1]=((SOAPBody)label).getUse();
        propertyNV[2][1]=((SOAPBody)label).getEncodingStyle();
        propertyNV[3][1]=((SOAPBody)label).getNamespace();
    }
    
    
    private void SOAPAddressProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=SOAPAddress.ATT_LOC;
        propertyNV[0][1]=((SOAPAddress)label).getLocation();
    }
    
    private void portProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=PortEx.ATT_NAME;
        propertyNV[1][0]=PortEx.ATT_BINDING;
        propertyNV[0][1]=((PortEx)label).getName();
        try {
            propertyNV[1][1]=label.getDefinitionEx().QNameToString(((PortEx)label).getBinding().getQName());
        } catch (NullPointerException e) {
            propertyNV[1][1]=null;
        }
    }
    
    private void serviceProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=ServiceEx.ATT_NAME;
        propertyNV[0][1]=((ServiceEx)label).getName();
    }
    
    private void bindingFaultProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=BindingFaultEx.ATT_NAME;
        propertyNV[0][1]=((BindingFaultEx)label).getName();
    }
    
    private void bindingOutputProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=BindingOutputEx.ATT_NAME;
        propertyNV[0][1]=((BindingOutputEx)label).getName();
    }
    
    private void bindingInputProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=BindingInputEx.ATT_NAME;
        propertyNV[0][1]=((BindingInputEx)label).getName();
    }
    
    private void bindingOperationProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=BindingOperationEx.ATT_NAME;
        propertyNV[0][1]=((BindingOperationEx)label).getName();
    }
    
    private void bindingProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=BindingEx.ATT_NAME;
        propertyNV[1][0]=BindingEx.ATT_TYPE;
        propertyNV[0][1]=((BindingEx)label).getName();
        try {
            propertyNV[1][1]=label.getDefinitionEx().QNameToString(((BindingEx)label).getPortType().getQName());
        } catch (NullPointerException e) {
            propertyNV[1][1]=null;
        }
        
    }
    
    private void faultProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=FaultEx.ATT_NAME;
        propertyNV[1][0]=FaultEx.ATT_MESSAGE;
        propertyNV[0][1]=((FaultEx)label).getName();
        try {
            propertyNV[1][1]=label.getDefinitionEx().QNameToString(((FaultEx)label).getMessage().getQName());
        } catch (NullPointerException e) {
            propertyNV[1][1]=null;
        }
    }
    
    private void outputProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=OutputEx.ATT_NAME;
        propertyNV[1][0]=OutputEx.ATT_MESSAGE;
        propertyNV[0][1]=((OutputEx)label).getName();
        try {
            propertyNV[1][1]=label.getDefinitionEx().QNameToString(((OutputEx)label).getMessage().getQName());
        } catch (NullPointerException e) {
            propertyNV[1][1]=null;
        }
    }
    
    private void inputProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=InputEx.ATT_NAME;
        propertyNV[1][0]=InputEx.ATT_MESSAGE;
        propertyNV[0][1]=((InputEx)label).getName();
        try {
            propertyNV[1][1]=label.getDefinitionEx().QNameToString(((InputEx)label).getMessage().getQName());
        } catch (NullPointerException e) {
            propertyNV[1][1]=null;
        }
        
    }
    
    private void operationProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=OperationEx.ATT_NAME;
        propertyNV[0][1]=((OperationEx)label).getName();
    }
    
    private void portTypeProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=PortTypeEx.ATT_NAME;
        propertyNV[0][1]=((PortTypeEx)label).getName();
    }
    
    private void partProperty() {
        propertyNV=new String[3][2];
        propertyNV[0][0]=PartEx.ATT_NAME;
        propertyNV[0][1]=((PartEx)label).getName();
        propertyNV[1][0]=PartEx.ATT_ELEMENT;
        propertyNV[1][1]=label.getDefinitionEx().QNameToString(((PartEx)label).getElementName());
        propertyNV[2][0]=PartEx.ATT_TYPE;
        propertyNV[2][1]=label.getDefinitionEx().QNameToString(((PartEx)label).getTypeName());
    }
    
    private void messageProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=MessageEx.ATT_NAME;
        propertyNV[0][1]=((MessageEx)label).getName();
    }
    
    private void simpleTypeProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=SimpleTypeEx.ATT_NAME;
        propertyNV[0][1]=((SimpleTypeEx)label).getName();
        if(((SimpleTypeEx)label).getKind().equals(SimpleTypeEx.KIND_ATOMIC)){
            propertyNV[1][0]=SimpleTypeEx.ATT_BASE;
            propertyNV[1][1]=((SimpleTypeEx)label).getBaseType();
        }
        else if(((SimpleTypeEx)label).getKind().equals(SimpleTypeEx.KIND_LIST)){
            propertyNV[1][0]=SimpleTypeEx.ATT_ITEM;
            propertyNV[1][1]=((SimpleTypeEx)label).getItemType();
        }
        else if(((SimpleTypeEx)label).getKind().equals(SimpleTypeEx.KIND_UNION)){
            propertyNV[1][0]=SimpleTypeEx.ATT_MEMBER;
            propertyNV[1][1]=((SimpleTypeEx)label).getMemberTypes();
        }
    }
    
    private void complexTypeProperty() {
        propertyNV=new String[1][2];
        propertyNV[0][0]=ComplexTypeEx.ATT_NAME;
        propertyNV[0][1]=((ComplexTypeEx)label).getName();
    }
    
    private void elementProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=ElementEx.ATT_NAME;
        propertyNV[1][0]=ElementEx.ATT_TYPE;
        propertyNV[0][1]=((ElementEx)label).getName();
        propertyNV[1][1]=((ElementEx)label).getTypeEx();
    }
    private void importProperty() {
        propertyNV=new String[2][2];
        propertyNV[0][0]=ImportEx.ATT_NS;
        propertyNV[1][0]=ImportEx.ATT_LOC_URL;
        propertyNV[0][1]=((ImportEx)label).getNamespaceURI();
        propertyNV[1][1]=((ImportEx)label).getLocationURI();
    }
    
      
    
    public JTable getTable() {
        return table;
    }
    
    class MyTableModel extends DefaultTableModel{
        
            
        public boolean isCellEditable(int row, int column) {
            return false;
        }
        
}
    
    public void propertyChanged(WSDLLabel label) {
        this.initPropertyNV();
        if(propertyNV!=null){
            this.regularizePropertyNV();
            ((MyTableModel)this.table.getModel()).setDataVector(propertyNV,new String[]{res.getString("propertyname"),res.getString("propertyvalue")});
        }
    }
}
