
package org.act.wsc.bpel4wsmodeling.utils;

import java.io.*;
import java.util.zip.ZipEntry;
import java.util.List;
import java.util.zip.ZipOutputStream;
public class CommonUtils {
  
  public static  void addFile2Zip( ZipOutputStream zos , String dir , String parentPath ,String ext) throws Exception
  {
      File src = new File( dir );
            if( src.exists() && src.isFile() )
      {
          String path = src.getPath();
          String entrypath = path.substring( parentPath.length()+1 , path.length()) ;
                    String strExt = entrypath.substring( entrypath.lastIndexOf(".")+1 , entrypath.length() ) ;
          if( !strExt.equals(ext))
          {
              BufferedInputStream in = new BufferedInputStream( new FileInputStream(src));
              zos.putNextEntry(new ZipEntry( entrypath ) );
              int c;
              while((c = in.read()) != -1)
                  zos.write(c);
              in.close();
          }
      }
            else if (src.exists() && src.isDirectory())
      {
          File[] fileLists = src.listFiles() ;
          for( int i=0;i<fileLists.length ;i++ )
          {
              String[] strFileLists = fileLists[i].list();
                            if( strFileLists!=null  && strFileLists.length == 0  )
              {
                  String path = fileLists[i].getPath();
                  String entrypath = path.substring( parentPath.length()+1 , path.length()) ;
                  zos.putNextEntry(new ZipEntry( entrypath+"/") );
              }
              else
              {
                  addFile2Zip(zos, fileLists[i].getPath() ,parentPath,ext);
              }
          }
      }
    }
    
    public static void copyDirectory(String sourceDir,String targetDir) throws Exception {
      FileInputStream fis = null;
      FileOutputStream fos = null;
      File[] fList = null;
      File copyFile = null;
      File file = new File(sourceDir);
      fList = file.listFiles();
      if(fList != null) {
        for(int i=0;i<fList.length;i++) {
          int pos = fList[i].getAbsolutePath().lastIndexOf('\\');
          String dir = fList[i].getAbsolutePath().substring(pos+1,fList[i].getAbsolutePath().length());
          if(fList[i].isDirectory()) {
            
            
            copyFile = new File(targetDir+"\\"+dir);
            if(!copyFile.exists())
              copyFile.mkdir();
            copyDirectory(fList[i].getAbsolutePath(),targetDir+"\\"+dir);
          }
          else if(fList[i].isFile()) {
            
            fis = new FileInputStream(fList[i]);
            fos = new FileOutputStream(targetDir+"\\"+dir);
            byte[] totalByte = new byte[fis.available()];
            fis.read(totalByte);
            fos.write(totalByte);
            fis.close();
            fos.close();
          }
        }
      }
    }
    
    public static void copyDirectorySpecFiles(String sourceDir,String targetDir,List spe,boolean isCopyDir) throws Exception {
      FileInputStream fis = null;
      FileOutputStream fos = null;
      File[] fList = null;
      File copyFile = null;
      File file = new File(sourceDir);
      fList = file.listFiles();
      if(fList != null) {
        for(int i=0;i<fList.length;i++) {
          int pos = fList[i].getAbsolutePath().lastIndexOf('\\');
          String dir = fList[i].getAbsolutePath().substring(pos+1,fList[i].getAbsolutePath().length());
          if(fList[i].isDirectory()) {
            if(isCopyDir) {
              
              
              copyFile = new File(targetDir+"\\"+dir);
              if(!copyFile.exists())
                copyFile.mkdir();
              copyDirectory(fList[i].getAbsolutePath(),targetDir+"\\"+dir);
            }
          }
          else if(fList[i].isFile()) {
            
            
            pos = dir.indexOf('.');
            String str = dir.substring(pos+1,dir.length());
            if(spe.contains(str)) {
              fis = new FileInputStream(fList[i]);
              fos = new FileOutputStream(targetDir+"\\"+dir);
              byte[] totalByte = new byte[fis.available()];
              fis.read(totalByte);
              fos.write(totalByte);
              fis.close();
              fos.close();
            }
          }
        }
      }
    }
    
    public static void copySpeFile(String sourceDir,String desDir,String sName,String dName) throws Exception{
       File in = new File(sourceDir+sName);
       FileInputStream fis = new FileInputStream(in);
       FileOutputStream fos = new FileOutputStream(desDir+dName);
       byte[] all  = new byte[fis.available()];
       fis.read(all);
       fos.write(all);
       fis.close();
       fos.close();
    }
    
    public static void copySpeFile(File sourceFile,String targetFilePath,
                                   String targetFileName) throws Exception {
      FileInputStream fis = new FileInputStream(sourceFile);
      FileOutputStream fos = new FileOutputStream(targetFilePath+targetFileName);
      byte[] all  = new byte[fis.available()];
      fis.read(all);
      fos.write(all);
      fis.close();
      fos.close();
    }
    
    public static void deleteDirectory(String dir) {
      File file = new File(dir);
      File delFile = null;
      File[] fList = file.listFiles();
      for(int i=0;i<fList.length;i++) {
        if(fList[i].isDirectory()) {
          File[] delList = fList[i].listFiles();
          if(delList == null || delList.length==0)
            fList[i].delete();
          else{
            deleteDirectory(fList[i].getAbsolutePath());
            fList[i].delete();
          }
        }
        else
          fList[i].delete();
      }
      file.delete();
    }
}
