
package org.act.wsc.bpel4wsmodeling.view.action;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Iterator;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLWriter;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;

public class UserDefineWSDLAction implements ActionListener {
    Project project;
    
    
    public UserDefineWSDLAction(Project project) {
        super();
        this.project = project;
    }
    
    public void actionPerformed(ActionEvent e) {
        DefinitionEx definitionEx=null;
        for (Iterator iter = project.imports.values().iterator(); iter.hasNext();) {
            ImportedWSDL importedWSDL = (ImportedWSDL) iter.next();
            if(importedWSDL.wsdlRetrieveMode.equals(ImportedWSDL.MOD_USERDEF)){
                String wsdlFile=importedWSDL.wsdlReplicaUrl;
                if (wsdlFile != null) {
                    if (wsdlFile.indexOf(GetActiveProjectDir.getactiveprodir()) == -1) {
                        wsdlFile = GetActiveProjectDir.getactiveprodir() + wsdlFile;
                    }
                    File file=new File(wsdlFile);
                                        org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLReader reader = new org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLReader(file);
                    definitionEx=reader.getDefinitionEx();
                    WSDLLayer layer=this.project.createWSDLLayer(definitionEx);
                    reader.readWSDL();
                    WSDLWriter writer=new WSDLWriter(definitionEx,file);
                    return;
                }
            }
        }
        if(definitionEx==null){
          definitionEx=new DefinitionEx();
          if (definitionEx.getTargetNamespace() == null) {
              definitionEx.setTargetNamespace("http://www.act.org/userdefined");
          }
          definitionEx.addNamespace(DefinitionEx.XMLNS,"http://schemas.xmlsoap.org/wsdl/");
          definitionEx.addNamespace("toi", "http://www.act.org/userdefined");
          definitionEx.addNamespace("soap","http://schemas.xmlsoap.org/wsdl/soap/");
          definitionEx.addNamespace("xsd", "http://www.w3.org/2001/XMLSchema");
          
          if(PropertyEditorFactory.showDefinitionPropertyEditor(definitionEx)){
                        File file=project.newUserDefWSDL(definitionEx);
              WSDLWriter writer=new WSDLWriter(definitionEx,file);
              writer.saveWSDL();
              WSDLLayer layer=this.project.createWSDLLayer(definitionEx);
          }
        }
        
    }
}
