
package org.act.wsc.bpel4wsmodeling.view.graphic;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import org.act.wsc.bpel4wsmodeling.projectdata.process.StructFigure;

public class BorderViewer implements ILineViewer{
    StructFigure structFigure=null;
    
    public BorderViewer(StructFigure structFigure) {
        super();
        this.structFigure = structFigure;
    }
    
    public StructFigure getStructFigure() {
        return structFigure;
    }
    
    public void setStructFigure(StructFigure structFigure) {
        this.structFigure = structFigure;
    }
    
    public void draw(Graphics g) {
		int sWidth=structFigure.getStructWidth();
		int sHeight=structFigure.getStructHeight();
		int width=structFigure.getWidth();
		int height=structFigure.getHeight();
		int x=structFigure.getX();
		int y=structFigure.getY();
		int dy=0;
		if(structFigure.getEnd()!=null){
		    dy=structFigure.getEnd().getHeight()/2;
		}
				Point[] points=new Point[6];
		points[0]=new Point(x-width/2,y+height/2);
		points[1]=new Point(x-sWidth/2,y+height/2);
		points[2]=new Point(x-sWidth/2,y+sHeight-dy);
		points[3]=new Point(x+sWidth/2,y+sHeight-dy);
		points[4]=new Point(x+sWidth/2,y+height/2);
		points[5]=new Point(x+width/2,y+height/2);
		g.setColor(Color.LIGHT_GRAY);
		for (int i = 0; i < points.length-1; i++) {
            Point p1 = points[i];
            Point p2 = points[i+1];
            g.drawLine(p1.x,p1.y,p2.x,p2.y);       
        }
    }
}
