
package org.act.wsc.bpel4wsmodeling.view.graphic;
import java.awt.event.MouseEvent;
import javax.swing.event.MouseInputListener;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.JoinendFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.MetaFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.NominalFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SequenceFigure;

public class FigureController implements MouseInputListener {
	Figure myFigure;
	FigureViewer myViewer;
	APresser myPresser;
	AReleaser myReleaser;
	AClicker myClicker;
	ADragger myDragger;
	
	public FigureController(Figure myFigure, FigureViewer myViewer) {
		super();
		this.myFigure = myFigure;
		this.myViewer = myViewer;
		if (myFigure instanceof SequenceFigure
				|| (myFigure instanceof MetaFigure && myFigure.getParent() instanceof SequenceFigure)
				|| (myFigure instanceof JoinendFigure && myFigure.getParent()
						.getParent() instanceof SequenceFigure)) {
			this.myReleaser=new InsertReleaser(myViewer);
		}
		else if(myFigure instanceof NominalFigure){
			this.myReleaser=new ReplacceReleaser(myViewer);
		}
		else{
			this.myReleaser=new CommonReleaser(myViewer);
		}
		this.myPresser=new CommonPresser(myViewer);
		this.myClicker=new CommonClicker(myViewer);
		this.myDragger=new CommonDragger(myViewer);
	}
	
	public void mouseClicked(MouseEvent e) {
				if (e.getButton() == 1 && e.getClickCount() == 1) {
			myClicker.singleClicked(e);
		} else if (e.getButton() == 1 && e.getClickCount() == 2) {
			myClicker.doubleClicked(e);
		} else if (e.getButton() == 3) {
			myClicker.rightClicked(e);
		}
	}
	
	public void mouseEntered(MouseEvent e) {
			}
	
	public void mouseExited(MouseEvent e) {
			}
	
	public void mousePressed(MouseEvent e) {
		this.myDragger.setLastLocation(e.getX(),e.getY());
		
	}
	
	public void mouseReleased(MouseEvent e) {
				myReleaser.releasedAction(e);
	}
	
	public void mouseDragged(MouseEvent e) {
	    if(myFigure.getParent()==null){
	        myDragger.dragInside(e);
	    }
			}
	
	public void mouseMoved(MouseEvent e) {
			}
}
