package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import java.util.Vector;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IActivityChildListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IActivityPropertyListener;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Source;
import org.act.wsc.bpel4wsmodeling.def.process.Target;
//<p></p><p></p><p></p><p></p>
public abstract class AbstractActProperty
    extends AbstractLeftProperty
    implements IActivityPropertyListener, IActivityChildListener {
  DefaultTableModel defaultSourceTableModel;
  DefaultTableModel defaultTargetTableModel;
  JTable jSourceTable;
  JTable jTargetTable;
  Activity act;
  List sour = new Vector();
  List target = new Vector();
  JTextField txtname;
  JTextField txtjoinCondition;
  JComboBox comBoxsuppressJoinFailure;
  public AbstractActProperty(Figure figure) {
    super(figure);
    this.act = (Activity) figure.getServicesSet();
    this.defaultSourceTableModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int column) {
        return false;
      }
    };
    this.defaultTargetTableModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int column) {
        return false;
      }
    };
    initSourceTable();
    initTargetTable();
    this.act.addPropertyListeners(this);
    this.act.addChildListeners(this);
  }
  
  private void jbInit() {
    this.txtname = new JTextField();
    txtname.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtNameValue(txtname.getText());
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    });
    this.txtjoinCondition = new JTextField();
    txtjoinCondition.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    });
    this.comBoxsuppressJoinFailure = new JComboBox();
    this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxsuppressJoinFailure)) {
          act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure
                                            .getSelectedItem().toString());
          process.write();
        }
      }
    });
  }
  abstract public void setAttTable();
  public void initSourceTable() {
    defaultSourceTableModel.setDataVector(
        new Object[][] {
    }
        ,
        new Object[] {
        "Source"});
    this.jSourceTable = new JTable(this.defaultSourceTableModel);
    this.jSourceTable.addMouseListener(new MouseAdapter() {       public void mouseClicked(MouseEvent e) {
        if (e.getButton() == 3) {
          int i = jSourceTable.getSelectedRow();
          if (i != -1) {
            Source s = (Source) sour.get(i);
          }
        }
      }
    });
  }
  public void initTargetTable() {
    defaultTargetTableModel.setDataVector(
        new Object[][] {
    }
        ,
        new Object[] {
        "Target"});
    this.jTargetTable = new JTable(defaultTargetTableModel);
    this.jTargetTable.addMouseListener(new MouseAdapter() {       public void mouseClicked(MouseEvent e) {
        if (e.getButton() == 3) {
          int i = jTargetTable.getSelectedRow();
          if (i != -1) {
          }
        }
      }
    });
  }
  public void nameUpdate(String name) {
    this.txtname.setText(name);
  }
  public void joinConditionUpdate(String joinCondition) {
    this.txtjoinCondition.setText(joinCondition);
  }
  public void suppressJoinFailureUpdate(String suppressJoinFailure) {
    for (int i = 0; i < comBoxsuppressJoinFailure.getItemCount(); i++) {
      if (this.comBoxsuppressJoinFailure.getItemAt(i).equals(
          suppressJoinFailure)) {
        this.comBoxsuppressJoinFailure.setSelectedIndex(i);
      }
    }
  }
  public void addTarget(Target t) {
    if (!this.target.contains(t)) {
      this.target.add(t);
      Object[] data = new Object[] {
          t.getAtLinkNameValue()};
      this.defaultTargetTableModel.addRow(data);
    }
  }
  public void deleteTartget(Target t) {
    if (this.target.contains(t)) {
      this.defaultTargetTableModel.removeRow(this.target.indexOf(t));
      this.target.remove(t);
    }
  }
  public void addSource(Source s) {
    if (!this.sour.contains(s)) {
      this.sour.add(s);
      Object[] data = new Object[] {
          s.getAtlinkNameValue()};
      this.defaultSourceTableModel.addRow(data);
    }
  }
  public void deleteSource(Source s) {
    if (this.sour.contains(s)) {
      this.defaultSourceTableModel.removeRow(this.sour.indexOf(s));
      this.sour.remove(s);
    }
  }
}
