
package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import javax.swing.DefaultCellEditor;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.Flow;
import javax.swing.JTextField;
import java.awt.event.ActionListener;
import javax.swing.JComboBox;
import java.awt.event.ActionEvent;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;

public class FlowProperty
    extends AbstractActProperty {
	 ResourceBundle res = ResChoose.getLanguage();
  Flow flowActivity;
  String name = null;
  String joinCondition = null;
  String suppressJoinFailure = null;
  
  public FlowProperty(Figure f) {
    super(f);
    this.flowActivity = (Flow)this.act;
    this.initAttTable();
  }
  
  void initAttTable() {
        name = this.act.getAtNameValue();
    joinCondition = this.act.getAtJoinConditionValue();
    suppressJoinFailure = this.act.getAtsuppressJoinFailureValue();
    defaultAttTableModel.setDataVector(
        new Object[][] { {"name", name}
        , {"joinCondition", joinCondition}
        , {"suppressJoinFailure", suppressJoinFailure}
    }
        ,
        new Object[] {
        		res.getString("propertyname"), res.getString("propertyvalue")});
    txtname = new JTextField();
    txtname.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtNameValue(txtname.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.txtjoinCondition = new JTextField();
    txtjoinCondition.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.comBoxsuppressJoinFailure = new JComboBox();
    this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxsuppressJoinFailure)) {
          act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure.
                                            getSelectedItem().toString());
          process.write();
        }
      }
    });
    
    EachRowRenderer rowRenderer = new EachRowRenderer();
    
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
    DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
        txtjoinCondition);
    DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
        comBoxsuppressJoinFailure);
    rowEditor.setEditorAt(0, txtnameEditor);
    rowEditor.setEditorAt(1, txtJoinConditionEditor);
    rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
  }
  
  public void addCopy(Copy c) {
  }
  
  public void deleteCopy(Copy c) {
  }
  
  public void setAttTable() {
    List it6 = new Vector();
    int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
    for (int i = j6; i >= 0; i--) {
      ActionListener it = this.comBoxsuppressJoinFailure.getActionListeners()[i];
      it6.add(it);
      this.comBoxsuppressJoinFailure.removeActionListener(it);
    }
    comBoxsuppressJoinFailure.removeAllItems();
    comBoxsuppressJoinFailure.addItem("yes");
    comBoxsuppressJoinFailure.addItem("no");
    if (this.flowActivity != null) {
      this.txtname.setText(this.name);
      this.txtjoinCondition.setText(this.joinCondition);
      for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
        String txtcon = (String)this.comBoxsuppressJoinFailure.getItemAt(f);
        if (this.suppressJoinFailure .equals(txtcon)) {
          this.comBoxsuppressJoinFailure.setSelectedIndex(f);
          break;
        }
      }
    }
    for (int i = 0; i < it6.size(); i++) {
      ActionListener it = (ActionListener) it6.get(i); ;
      this.comBoxsuppressJoinFailure.addActionListener(it);
    }
  }

public void addCorrelation(Correlation c) {
		
}

public void deleteCorrelation(Correlation correlation) {
		
}

public void correlatinNameUpdate(Correlation c, String s) {
		
}
}
