package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.util.*;
import javax.wsdl.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import org.act.metaset.*;
import org.act.metaset.utils.*;
import org.act.wsc.bpel4wsmodeling.def.process.*;
import org.act.wsc.bpel4wsmodeling.projectdata.*;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.*;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.*;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.*;
import org.act.wsc.bpel4wsmodeling.view.gui.*;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
//<p></p><p></p><p></p><p></p>
public class InvokeProperty
    extends AbstractActProperty {
	
	 ResourceBundle res = ResChoose.getLanguage();
  Invoke invoke;
  JComboBox jComboxPartnerLink;
  JComboBox jComboxPortType;
  JComboBox jComboxOperation;
  JComboBox jComboxInputVariable;
  JComboBox jComboxOutputVariable;
  Project project;
  MainFrame frame = MainFrame.getmainFrame();
  String partnerLink = null;
  String portType = null;
  String operation = null;
  String variableIn = null;
  String variableOut = null;
  String name = null;
  String joinCondition = null;
  String suppressJoinFailure = null;
  JTable jCorrelationTable;
  DefaultTableModel defaultCorrelationTableModel;
  List correlations = new Vector();
    public InvokeProperty(Figure f) {
    super(f);
    invoke = (Invoke)this.act;
    project = this.frame.getProject();
    this.defaultCorrelationTableModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int column) {
        return false;
      }
    };
    initAttTable();
    initCorrelationTable();
  }
  
  private void initCorrelationTable() {
    this.defaultCorrelationTableModel.setDataVector(new Object[][] {}
        ,
        new Object[] {"Correlations"});
    if (this.invoke.getCorrelations() != null) {
      for (int i = 0; i < this.invoke.getCorrelations().getChilds()
           .size(); i++) {
        Correlations cors = (Correlations)this.invoke.getCorrelations().car();
        Correlation correlation = (Correlation) cors.getChilds().get(i);
        this.correlations.add(correlation);
        Object[] data = new Object[] {
            correlation.getAtSetValue()};
        this.defaultCorrelationTableModel.addRow(data);
      }
    }
    this.jCorrelationTable = new JTable(this.defaultCorrelationTableModel);
    this.jCorrelationTable.addMouseListener(new MouseAdapter() {                   public void mouseClicked(MouseEvent e) {
        if (e.getButton() == 3) {
          int i = jCorrelationTable.getSelectedRow();
          if (i != -1) {
            Correlation correlation = (Correlation) correlations
                .get(i);
            InvokePropertyRightMenu rightMenu = new InvokePropertyRightMenu(
                correlation, figure);
            rightMenu.show(jCorrelationTable, e.getX(), e
                           .getY());
          }
        }
      }
    });
  }
  
  void initAttTable() {
    partnerLink = invoke.getAtPartnerLinkValue();
    portType = invoke.getAtPortTypeValue();
    operation = invoke.getAtOperationValue();
    variableIn = invoke.getAtInVariableValue();
    variableOut = invoke.getAtOutVariableValue();
    name = this.act.getAtNameValue();
    joinCondition = this.act.getAtJoinConditionValue();
    suppressJoinFailure = this.act.getAtsuppressJoinFailureValue();
    String portTypeDisplay = null;
    if (portType.indexOf(":") != -1) {
                  String strPrefix = portType.substring(0, portType.lastIndexOf(":"));
      String nameSpace = MetasetUtil.getActualNamespace(this.invoke,
          strPrefix);
                  String localName = portType.substring(
          portType.lastIndexOf(":") + 1, portType.length());
      portTypeDisplay = nameSpace + ":" + localName;
    }
    else {
      portTypeDisplay = portType;
    }
    defaultAttTableModel.setDataVector(new Object[][] { {"name", name}
                                       , {"joinCondition", joinCondition}
                                       , {"suppressJoinFailure",
                                       suppressJoinFailure}
                                       , {"partnerLink", partnerLink}
                                       , {"portType", portTypeDisplay}
                                       , {"operation", operation}
                                       , {"inputVariable", variableIn}
                                       , {"outputVariable", variableOut}
    }
        , new Object[] {
    		res.getString("propertyname"),res.getString("propertyvalue")});
        txtname = new JTextField();
    this.txtjoinCondition = new JTextField();
    this.comBoxsuppressJoinFailure = new JComboBox();
    this.jComboxPartnerLink = new JComboBox();
    this.jComboxPortType = new JComboBox();
    this.jComboxOperation = new JComboBox();
    this.jComboxInputVariable = new JComboBox();
    this.jComboxOutputVariable = new JComboBox();
    txtname.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtNameValue(txtname.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    });
    txtjoinCondition.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    });
    this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxsuppressJoinFailure)) {
          act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure
                                            .getSelectedItem().toString());
          process.write();
        }
      }
    });
    this.jComboxPartnerLink.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxPartnerLink)) {
          if (jComboxPartnerLink.getSelectedItem() != null) {
            String plinkSelectedName = (String) jComboxPartnerLink
                .getSelectedItem();
            invoke.setAtPartnerLinkValue(plinkSelectedName);
            process.write();
            if (plinkSelectedName != null
                && plinkSelectedName != "") {
              PartnerLinks plinks = (PartnerLinks) process
                  .getPartnerLinks().car();
              PartnerLink plink = plinks
                  .getPartnerLinkByName(plinkSelectedName);
              String plinktypename = plink
                  .getAtPartnerLinkTypeValue();
              if (plinktypename.startsWith("tns:")) {
                plinktypename = plinktypename.substring(plinktypename.indexOf(
                    ":") + 1, plinktypename.length());
              }
              PartnerLinkType plinkType = (PartnerLinkType) MainFrame
                  .getmainFrame().getProject()
                  .getPLinkTypeByName(plinktypename);
              jComboxPortType.removeAllItems();
              PortType pt = plinkType.getPartnerRole()
                  .getPortType();
              WSDLRegistry wsdlRegistry = project
                  .getWSDLRegistry();
              WSDLRegistryEntry wre = wsdlRegistry.findPortType(
                  pt.getQName().getNamespaceURI(), pt
                  .getQName().getLocalPart());
              jComboxPortType.addItem(wre);
            }
          }
          else {
            invoke.setAtPartnerLinkValue("");
            process.write();
          }
        }
      }
    });
    this.jComboxPortType.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxPortType)) {
          if (jComboxPortType.getSelectedItem() != null) {
            WSDLRegistryEntry wre = (WSDLRegistryEntry) jComboxPortType
                .getSelectedItem();
                                                            String strPrefix = MetasetUtil.getPrefix(process
                .getProcess(), wre.namespace);
            String portTypeName;
                        if (strPrefix == null) {
              portTypeName = wre.localName;             }
            else {
              portTypeName = strPrefix + ":" + wre.localName;             }
            invoke.setAtPortTypeValue(portTypeName);
            process.write();
            PortType pt = (PortType) wre.userObject;
            if (pt != null) {
              jComboxOperation.removeAllItems();
              List ops = pt.getOperations();
              for (int j = 0; j < ops.size(); j++) {
                Operation op = (Operation) ops.get(j);
                OperationWrapper opw = new OperationWrapper(op);
                jComboxOperation.addItem(opw);
              }
            }
          }
          else {
            invoke.setAtPortTypeValue("");
            process.write();
          }
        }
      }
    });
    this.jComboxOperation.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxOperation)) {
          if (jComboxOperation.getSelectedItem() != null) {
            OperationWrapper opw = (OperationWrapper) jComboxOperation
                .getSelectedItem();
            Operation op = opw.getWrappedOperation();
            String opName = op.getName();
            invoke.setAtOperationValue(opName);
            process.write();
            if (opw != null) {
              jComboxInputVariable.removeAllItems();
              jComboxOutputVariable.removeAllItems();
              List tempvs = figure.getVariableList();
              for (int i = 0; i < tempvs.size(); i++) {
                Variable v = (Variable) tempvs.get(i);
                String variablename = v.getAtNameValue();
                if (v.getAtMessageTypeValue().indexOf(":") == -1) {
                  if (op.getInput() != null) {
                    if (v
                        .getAtMessageTypeValue()
                        .equals(
                        op
                        .getInput()
                        .getMessage()
                        .getQName()
                        .getLocalPart())) {
                      jComboxInputVariable
                          .addItem(variablename);
                    }
                  }
                  if (op.getOutput() != null) {
                    if (v
                        .getAtMessageTypeValue()
                        .equals(
                        op
                        .getOutput()
                        .getMessage()
                        .getQName()
                        .getLocalPart())) {
                      jComboxOutputVariable
                          .addItem(variablename);
                    }
                  }
                }
                else {
                                                                                                                                                if (op.getInput() != null) {
                    Message message = op.getInput()
                        .getMessage();
                    String strPrefix = MetasetUtil
                        .getPrefix(
                        process.getProcess(),
                        message
                        .getQName()
                        .getNamespaceURI());
                    if (v
                        .getAtMessageTypeValue()
                        .equals(
                        strPrefix
                        + ":"
                        + op
                        .getInput()
                        .getMessage()
                        .getQName()
                        .getLocalPart())) {
                      jComboxInputVariable
                          .addItem(variablename);
                    }
                  }
                  if (op.getOutput() != null) {
                    Message message1 = op.getOutput()
                        .getMessage();
                    String strPrefix1 = MetasetUtil
                        .getPrefix(
                        process.getProcess(),
                        message1
                        .getQName()
                        .getNamespaceURI());
                    if (v
                        .getAtMessageTypeValue()
                        .equals(
                        strPrefix1
                        + ":"
                        + op
                        .getOutput()
                        .getMessage()
                        .getQName()
                        .getLocalPart())) {
                      jComboxOutputVariable
                          .addItem(variablename);
                    }
                  }
                }
              }
            }
          }
          else {
            invoke.setAtOperationValue("");
            process.write();
          }
        }
      }
    });
    this.jComboxInputVariable.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxInputVariable)) {
          invoke.setAtInVariableValue( (String) jComboxInputVariable
                                      .getSelectedItem());
          process.write();
        }
      }
    });
    this.jComboxOutputVariable.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxOutputVariable)) {
          invoke.setAtOutVariableValue( (String) jComboxOutputVariable
                                       .getSelectedItem());
          process.write();
        }
      }
    });
    
    EachRowRenderer rowRenderer = new EachRowRenderer();
    
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
    DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
        txtjoinCondition);
    DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
        comBoxsuppressJoinFailure);
    DefaultCellEditor jComboxPartnerLinkEditor = new DefaultCellEditor(
        jComboxPartnerLink);
    DefaultCellEditor jComboxPortTypeEditor = new DefaultCellEditor(
        jComboxPortType);
    DefaultCellEditor jComboxOperationEditor = new DefaultCellEditor(
        jComboxOperation);
    DefaultCellEditor jComboxInputVariableEditor = new DefaultCellEditor(
        jComboxInputVariable);
    DefaultCellEditor jComboxOutputVariableEditor = new DefaultCellEditor(
        jComboxOutputVariable);
    rowEditor.setEditorAt(0, txtnameEditor);
    rowEditor.setEditorAt(1, txtJoinConditionEditor);
    rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
    rowEditor.setEditorAt(3, jComboxPartnerLinkEditor);
    rowEditor.setEditorAt(4, jComboxPortTypeEditor);
    rowEditor.setEditorAt(5, jComboxOperationEditor);
    rowEditor.setEditorAt(6, jComboxInputVariableEditor);
    rowEditor.setEditorAt(7, jComboxOutputVariableEditor);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
  }
  
  public void addCopy(Copy c) {
  }
  
  public void deleteCopy(Copy c) {
  }
  
  public void setAttTable() {
    List it1 = new Vector();
    List it2 = new Vector();
    List it3 = new Vector();
    List it4 = new Vector();
    List it5 = new Vector();
    List it6 = new Vector();
    int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
    int j1 = this.jComboxPartnerLink.getActionListeners().length - 1;
    int j2 = this.jComboxPortType.getActionListeners().length - 1;
    int j3 = this.jComboxOperation.getActionListeners().length - 1;
    int j4 = this.jComboxInputVariable.getActionListeners().length - 1;
    int j5 = this.jComboxOutputVariable.getActionListeners().length - 1;
    for (int i = j6; i >= 0; i--) {
      ActionListener it = this.comBoxsuppressJoinFailure.getActionListeners()[i];
      it6.add(it);
      this.comBoxsuppressJoinFailure.removeActionListener(it);
    }
    for (int i = j1; i >= 0; i--) {
      ActionListener it = this.jComboxPartnerLink.getActionListeners()[i];
      it1.add(it);
      this.jComboxPartnerLink.removeActionListener(it);
    }
    for (int i = j2; i >= 0; i--) {
      ActionListener it = this.jComboxPortType.getActionListeners()[i];
      it2.add(it);
      this.jComboxPortType.removeActionListener(it);
    }
    for (int i = j3; i >= 0; i--) {
      ActionListener it = this.jComboxOperation.getActionListeners()[i];
      it3.add(it);
      this.jComboxOperation.removeActionListener(it);
    }
    for (int i = j4; i >= 0; i--) {
      ActionListener it = this.jComboxInputVariable.getActionListeners()[i];
      it4.add(it);
      this.jComboxInputVariable.removeActionListener(it);
    }
    for (int i = j5; i >= 0; i--) {
      ActionListener it = this.jComboxOutputVariable.getActionListeners()[i];
      it5.add(it);
      this.jComboxOutputVariable.removeActionListener(it);
    }
    jComboxPartnerLink.removeAllItems();
    jComboxPortType.removeAllItems();
    jComboxOperation.removeAllItems();
    jComboxInputVariable.removeAllItems();
    jComboxOutputVariable.removeAllItems();
    comBoxsuppressJoinFailure.removeAllItems();
    comBoxsuppressJoinFailure.addItem("yes");
    comBoxsuppressJoinFailure.addItem("no");
    if (this.process.getPartnerLinks() != null &&
        this.process.getPartnerLinks().getChilds().size() > 0) {
      Metaset plinks = this.process.getPartnerLinks().car();
      List tempPlinks = plinks.getChilds();
            for (int i = 0; i < tempPlinks.size(); i++) {
        PartnerLink plink = (PartnerLink) tempPlinks.get(i);
        String plinkName = plink.getAtNameValue();
        jComboxPartnerLink.addItem(plinkName);
        String plinktypename;
        if (plink.getAtPartnerLinkTypeValue().startsWith("tns:")) {
          plinktypename = plink.getAtPartnerLinkTypeValue().substring(plink.
              getAtPartnerLinkTypeValue().indexOf(":") + 1,
              plink.getAtPartnerLinkTypeValue().length());
        }
        else {
          plinktypename = plink.getAtPartnerLinkTypeValue();
        }
        PartnerLinkType plinkType = (PartnerLinkType) MainFrame.
            getmainFrame().getProject().getPLinkTypeByName(
            plinktypename);
        PortType pt = plinkType.getPartnerRole().getPortType();
        WSDLRegistry wsdlRegistry = project.getWSDLRegistry();
        WSDLRegistryEntry wre = wsdlRegistry.findPortType(pt.getQName().
            getNamespaceURI(), pt.getQName().getLocalPart());
        jComboxPortType.addItem(wre);
        List ops = pt.getOperations();
        for (int j = 0; j < ops.size(); j++) {
          Operation op = (Operation) ops.get(j);
          OperationWrapper opw = new OperationWrapper(op);
          jComboxOperation.addItem(opw);
          List tempvs = figure.getVariableList();
          for (int m = 0; m < tempvs.size(); m++) {
            Variable v = (Variable) tempvs.get(m);
            String variablename = v.getAtNameValue();
            if (v.getAtMessageTypeValue().indexOf(":") == -1) {
              if (op.getInput() != null) {
                if (v.getAtMessageTypeValue().equals(op.getInput().
                    getMessage().getQName().getLocalPart())) {
                  jComboxInputVariable.addItem(variablename);
                }
              }
              if (op.getOutput() != null) {
                if (v.getAtMessageTypeValue().equals(op.getOutput().
                    getMessage().getQName().getLocalPart())) {
                  jComboxOutputVariable.addItem(variablename);
                }
              }
            }
            else {
              if (op.getInput() != null) {
                Message message = op.getInput().getMessage();
                String strPrefix = MetasetUtil.getPrefix(this.process.
                    getProcess(), message.getQName().
                    getNamespaceURI());
                if (v.getAtMessageTypeValue().equals(strPrefix + ":" +
                    op.getInput().getMessage().getQName().getLocalPart())) {
                  jComboxInputVariable.addItem(variablename);
                }
              }
              if (op.getOutput() != null) {
                Message message1 = op.getOutput().getMessage();
                String strPrefix1 = MetasetUtil.getPrefix(this.process.
                    getProcess(), message1.getQName().
                    getNamespaceURI());
                if (v.getAtMessageTypeValue().equals(strPrefix1 + ":" +
                    op.getOutput().getMessage().getQName().getLocalPart())) {
                  jComboxOutputVariable.addItem(variablename);
                }
              }
            }
          }
                  }
      }
    }
    if (invoke != null) {
      this.txtname.setText(this.name);
      this.txtjoinCondition.setText(this.joinCondition);
      for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
        String txtcon = (String)this.comBoxsuppressJoinFailure.getItemAt(f);
        if (this.joinCondition.equals(txtcon)) {
          this.comBoxsuppressJoinFailure.setSelectedIndex(f);
          break;
        }
      }
      if (this.partnerLink != null && this.partnerLink != "") {
        for (int a = 0; a < this.jComboxPartnerLink.getItemCount(); a++) {
          String plinkName = (String)this.jComboxPartnerLink.getItemAt(a);
          if (this.partnerLink.equals(plinkName)) {
            this.jComboxPartnerLink.setSelectedIndex(a);
            break;
          }
        }
      }
      if (this.portType != null && this.portType != "") {
        for (int b = 0; b < this.jComboxPortType.getItemCount(); b++) {
          WSDLRegistryEntry wre = (WSDLRegistryEntry) jComboxPortType.getItemAt(
              b);
          if (portType.indexOf(":") != -1) {
            String strPrefix = portType.substring(0,
                                                  portType.lastIndexOf(":"));
            String nameSpace = MetasetUtil.getActualNamespace(this.invoke,
                strPrefix);
            String localName = portType.substring(portType.lastIndexOf(
                ":") + 1, portType.length());
            if (nameSpace.equals(wre.namespace) &&
                localName.equals(wre.localName)) {
              this.jComboxPortType.setSelectedIndex(b);
              break;
            }
          }
          else {
            if (portType.equals(wre.localName)) {
              this.jComboxPortType.setSelectedIndex(b);
              break;
            }
          }
        }
      }
      if (this.operation != null && this.operation != "") {
        for (int c = 0; c < this.jComboxOperation.getItemCount(); c++) {
          OperationWrapper opw = (OperationWrapper)this.jComboxOperation.
              getItemAt(c);
          if (opw.getOperationName().equals(this.operation)) {
            this.jComboxOperation.setSelectedIndex(c);
            break;
          }
        }
      }
      if (this.variableIn != null && this.variableIn != "") {
        for (int d = 0; d < this.jComboxInputVariable.getItemCount(); d++) {
          String inName = (String)this.jComboxInputVariable.getItemAt(d);
          if (inName.equals(this.variableIn)) {
            this.jComboxInputVariable.setSelectedIndex(d);
            break;
          }
        }
      }
      if (this.variableOut != null && this.variableOut != "") {
        for (int e = 0; e < this.jComboxOutputVariable.getItemCount(); e++) {
          String outName = (String)this.jComboxOutputVariable.getItemAt(e);
          if (outName.equals(this.variableOut)) {
            this.jComboxOutputVariable.setSelectedIndex(e);
            break;
          }
        }
      }
    }
    for (int i = 0; i < it6.size(); i++) {
      ActionListener it = (ActionListener) it6.get(i); ;
      this.comBoxsuppressJoinFailure.addActionListener(it);
    }
    for (int i = 0; i < it1.size(); i++) {
      ActionListener it = (ActionListener) it1.get(i);
      this.jComboxPartnerLink.addActionListener(it);
    }
    for (int i = 0; i < it2.size(); i++) {
      ActionListener it = (ActionListener) it2.get(i);
      this.jComboxPortType.addActionListener(it);
    }
    for (int i = 0; i < it3.size(); i++) {
      ActionListener it = (ActionListener) it3.get(i);
      this.jComboxOperation.addActionListener(it);
    }
    for (int i = 0; i < it4.size(); i++) {
      ActionListener it = (ActionListener) it4.get(i);
      this.jComboxInputVariable.addActionListener(it);
    }
    for (int i = 0; i < it5.size(); i++) {
      ActionListener it = (ActionListener) it5.get(i); ;
      this.jComboxOutputVariable.addActionListener(it);
    }
  }
  
  public void addCorrelation(Correlation c) {
        if (!this.correlations.contains(c)) {
      this.correlations.add(c);
      Object[] data = new Object[] {
          c.getAtSetValue()};
      this.defaultCorrelationTableModel.addRow(data);
          }
  }
  
  public void deleteCorrelation(Correlation correlation) {
        if (this.correlations.contains(correlation)) {
            this.defaultCorrelationTableModel.removeRow(this.correlations
                                                  .indexOf(correlation));
      this.correlations.remove(correlation);
    }
  }
  
  public void correlatinNameUpdate(String s) {
      }
  public JTable getCorrelationTable() {
    return this.jCorrelationTable;
  }
  
  public void correlatinNameUpdate(Correlation c, String s) {
      }
}
