
package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.ICorrelationSetPropertyListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IScopeChildListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IVariablePropertyListener;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSet;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSets;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.def.process.Variables;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.ScopeFigure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.processassist.CorrelationSetDialog;
import org.act.wsc.bpel4wsmodeling.view.processassist.VariableDialog;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class ScopeProperty extends AbstractActProperty implements IScopeChildListener,IVariablePropertyListener,ICorrelationSetPropertyListener{
	 ResourceBundle res = ResChoose.getLanguage();
    Scope scopeActivity;
    JComboBox comVariableAccessSerializable;
    String name = null;
    String joinCondition = null;
    String suppressJoinFailure = null;
    String variableAccessSerializable = null;
    JTable jVariablesTable;
    JTable jCorrelationSetTable;
    List variables = new Vector();
    List correlationSets = new Vector();
    
    DefaultTableModel defaultVariablesTableModel;
    DefaultTableModel defaultCorrelationSetTableModel;
    
    public ScopeProperty(Figure f) {
        super(f);
        this.scopeActivity = (Scope) this.act;
        this.initAttTable();
    }
    
    void initAttTable() {
        name = this.act.getAtNameValue();
        joinCondition = this.act.getAtJoinConditionValue();
        suppressJoinFailure = this.act.getAtsuppressJoinFailureValue();
                variableAccessSerializable = this.scopeActivity
                .getAtVariableAccessSerializableValue();
        this.comVariableAccessSerializable = new JComboBox();
        this.comVariableAccessSerializable
                .addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if (e.getSource().equals(comVariableAccessSerializable)) {
                            scopeActivity
                                    .setAtVariableAccessSerializableValue(comVariableAccessSerializable
                                            .getSelectedItem().toString());
                            process.write();
                        }
                    }
                });
        txtname = new JTextField();
        txtname.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    act.setAtNameValue(txtname.getText());
                    process.write();
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });
        this.txtjoinCondition = new JTextField();
        txtjoinCondition.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    act.setAtJoinConditionValue(txtjoinCondition.getText());
                    process.write();
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });
        this.comBoxsuppressJoinFailure = new JComboBox();
        this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (e.getSource().equals(comBoxsuppressJoinFailure)) {
                    act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure
                            .getSelectedItem().toString());
                    process.write();
                }
            }
        });
        defaultAttTableModel.setDataVector(
                new Object[][] {
                        { "name", name },
                        { "joinCondition", joinCondition },
                        { "suppressJoinFailure", suppressJoinFailure },
                        { "variableAccessSerializable",
                                variableAccessSerializable }, }, new Object[] {
                		res.getString("propertyname"), res.getString("propertyvalue") });
        
        EachRowRenderer rowRenderer = new EachRowRenderer();
        
        EachRowEditor rowEditor = new EachRowEditor(jAttTable);
        DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
        DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
                txtjoinCondition);
        DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
                comBoxsuppressJoinFailure);
        DefaultCellEditor comVariableAccessSerializableEditor = new DefaultCellEditor(
                comVariableAccessSerializable);
        rowEditor.setEditorAt(0, txtnameEditor);
        rowEditor.setEditorAt(1, txtJoinConditionEditor);
        rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
        rowEditor.setEditorAt(3, comVariableAccessSerializableEditor);
        this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
        this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
        
        this.defaultVariablesTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        this.defaultCorrelationSetTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        initVariablesTable();
        initCorrelationSetTable();
    }
    
    private void initVariablesTable() {
        defaultVariablesTableModel.setDataVector(new Object[][] {},
                new Object[] { "Variables" });
                if (this.scopeActivity.getVariables() != null) {
            Variables variables = (Variables) this.scopeActivity.getVariables().car();
            for (int i = 0; i < variables.getChilds().size(); i++) {
                Variable var = (Variable) variables.getChilds().get(i);
                this.addVariable(var);
            }
        }
        this.jVariablesTable = new JTable(defaultVariablesTableModel);
        this.jVariablesTable.addMouseListener(new MouseAdapter() {                                                                                                                                                           public void mouseClicked(MouseEvent e) {
                        if (e.getButton() == 3) {
                            int i = jVariablesTable.getSelectedRow();
                            if (i != -1) {
                                Variable variable = (Variable) variables.get(i);
                                ScopePropertyRightMenu rightMenu = new ScopePropertyRightMenu(
                                        (Object) variable, (ScopeFigure) ScopeProperty.this.figure);
                                rightMenu.show(jVariablesTable, e.getX(), e
                                        .getY());
                            }
                        }
                    }
                });
    }
    
    private void initCorrelationSetTable() {
        defaultCorrelationSetTableModel.setDataVector(new Object[][] {},
                new Object[] { "CorrelationSets" });
        if (this.scopeActivity.getCorrelationSets() != null) {
            CorrelationSets correlationSets = (CorrelationSets) this.scopeActivity
                    .getCorrelationSets().car();
            for (int i = 0; i < correlationSets.getChilds().size(); i++) {
                CorrelationSet correlationSet = (CorrelationSet) correlationSets
                        .getChilds().get(i);
                this.addCorrelationSet(correlationSet);
            }
        }
        this.jCorrelationSetTable = new JTable(defaultCorrelationSetTableModel);
        this.jCorrelationSetTable.addMouseListener(new MouseAdapter() {                                                                                                                                                                     public void mouseClicked(MouseEvent e) {
                        if (e.getButton() == 3) {
                            int i = jCorrelationSetTable.getSelectedRow();
                            if (i != -1) {
                                CorrelationSet correlationSet = (CorrelationSet) correlationSets
                                        .get(i);
                                ScopePropertyRightMenu rightMenu = new ScopePropertyRightMenu(
                                        (Object) correlationSet, (ScopeFigure) ScopeProperty.this.figure);
                                rightMenu.show(jCorrelationSetTable, e.getX(), e
                                        .getY());
                            }
                        }
                    }
                });
    }
    
    public void addCopy(Copy c) {
    }
    
    public void deleteCopy(Copy c) {
    }
    
    public void setAttTable() {
        List it6 = new Vector();
        List it7 = new Vector();
        int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
        int j7 = this.comVariableAccessSerializable.getActionListeners().length - 1;
        for (int i = j6; i >= 0; i--) {
            ActionListener it = this.comBoxsuppressJoinFailure
                    .getActionListeners()[i];
            it6.add(it);
            this.comBoxsuppressJoinFailure.removeActionListener(it);
        }
        for (int i = j7; i >= 0; i--) {
            ActionListener it = this.comVariableAccessSerializable
                    .getActionListeners()[i];
            it7.add(it);
            this.comVariableAccessSerializable.removeActionListener(it);
        }
        comBoxsuppressJoinFailure.removeAllItems();
        this.comVariableAccessSerializable.removeAllItems();
        comBoxsuppressJoinFailure.addItem("yes");
        comBoxsuppressJoinFailure.addItem("no");
        this.comVariableAccessSerializable.addItem("yes");
        this.comVariableAccessSerializable.addItem("no");
        if (this.scopeActivity != null) {
            this.txtname.setText(this.name);
            this.txtjoinCondition.setText(this.joinCondition);
            for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
                String txtcon = (String) this.comBoxsuppressJoinFailure
                        .getItemAt(f);
                if (this.suppressJoinFailure.equals(txtcon)) {
                    this.comBoxsuppressJoinFailure.setSelectedIndex(f);
                    break;
                }
            }
            for (int g = 0; g < this.comVariableAccessSerializable
                    .getItemCount(); g++) {
                String txtcon = (String) this.comVariableAccessSerializable
                        .getItemAt(g);
                if (this.variableAccessSerializable.equals(txtcon)) {
                    this.comVariableAccessSerializable.setSelectedIndex(g);
                    break;
                }
            }
        }
        for (int i = 0; i < it6.size(); i++) {
            ActionListener it = (ActionListener) it6.get(i);
            ;
            this.comBoxsuppressJoinFailure.addActionListener(it);
        }
        for (int i = 0; i < it7.size(); i++) {
            ActionListener it = (ActionListener) it7.get(i);
            ;
            this.comVariableAccessSerializable.addActionListener(it);
        }
    }
    
    public void addVariable(Variable var) {
        if (!this.variables.contains(var)) {
            this.variables.add(var);
            Object[] data = new Object[] { var.getAtNameValue() };
            this.defaultVariablesTableModel.addRow(data);
            var.addPropertyListeners(this);
        }
        
    }
    
    public void deleteVariable(Variable var) {
        if (this.variables.contains(var)) {
            var.removePropertyListner(this);
            this.defaultVariablesTableModel.removeRow(this.variables
                    .indexOf(var));
            this.variables.remove(var);
        }
    }
    
    public void varNameUpdate(Variable v, String name) {
        if (this.variables.contains(v)) {
            this.defaultVariablesTableModel.setValueAt(name, this.variables
                    .indexOf(v), 0);         }
    }
    
    public void addCorrelationSet(CorrelationSet correlationSet) {
        if (!this.correlationSets.contains(correlationSet)) {
            this.correlationSets.add(correlationSet);
            Object[] data = new Object[] { correlationSet.getAtNameValue() };
            this.defaultCorrelationSetTableModel.addRow(data);
            correlationSet.addPropertyListeners(this);
        }
    }
    
    public void deleteCorrelationSet(CorrelationSet correlationSet) {
        if (this.correlationSets.contains(correlationSet)) {
            correlationSet.removePropertyListner(this);
            this.defaultCorrelationSetTableModel.removeRow(this.correlationSets
                    .indexOf(correlationSet));
            this.correlationSets.remove(correlationSet);
        }
    }
    
    public void correlationSetNameUpdate(CorrelationSet c, String name) {
        if (this.correlationSets.contains(c)) {
            this.defaultCorrelationSetTableModel.setValueAt(name,
                    this.correlationSets.indexOf(c), 0);
        }
    }
    
    public void addCorrelation(Correlation c) {
                
    }
    
    public void deleteCorrelation(Correlation correlation) {
                
    }
    
    public void correlatinNameUpdate(Correlation c, String s) {
                
    }
    public JTable getVariablesTable() {
        return this.jVariablesTable;
    }
    public JTable getCorrelationSetTable() {
        return this.jCorrelationSetTable;
    }
    
}
class ScopePropertyRightMenu extends JPopupMenu{
	 ResourceBundle res = ResChoose.getLanguage();
    private JMenuItem editProperty = new JMenuItem(res.getString("editproperty"));
    private JMenuItem delete = new JMenuItem(res.getString("delete"));
    ScopeFigure figure;
    Variable variable=null;
    CorrelationSet correlationSet=null;
    public ScopePropertyRightMenu(Object object,ScopeFigure figure){
        this.figure=figure;
        this.add(this.editProperty);
        this.add(this.delete);
        if(object instanceof Variable){
            this.variable=(Variable)object;
            this.editProperty.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    VariableDialog dialog=new VariableDialog(MainFrame.getmainFrame(),ScopePropertyRightMenu.this.figure,variable);
                    dialog.setDialog() ;
                    dialog.setSize(new Dimension(700, 260));
                    dialog.setLocation( (MainFrame.getmainFrame().getWidth() -
                                              dialog.getWidth()) /
                                            2,
                                            (MainFrame.getmainFrame().getHeight() -
                                             dialog.getHeight()) /
                                            2);
                    dialog.show();
                }});
            this.delete.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    Scope scope=(Scope) ScopePropertyRightMenu.this.figure.getServicesSet();
                    scope.deleteVariable(variable);
                }});
        }
        else if(object instanceof CorrelationSet){
            this.correlationSet=(CorrelationSet)object;
            this.editProperty.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    CorrelationSetDialog dialog=new CorrelationSetDialog(MainFrame.getmainFrame(),ScopePropertyRightMenu.this,correlationSet);
                    dialog.setDialog();
                    dialog.setSize(new Dimension(470, 350));
                    dialog.setLocation( (MainFrame.getmainFrame().getWidth() -
                                              dialog.getWidth()) /
                                            2,
                                            (MainFrame.getmainFrame().getHeight() -
                                             dialog.getHeight()) /
                                            2);
                    dialog.show();
                }});
            this.delete.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    Scope scope=(Scope) ScopePropertyRightMenu.this.figure.getServicesSet();
                    scope.deleteCorrelationSet(correlationSet);
                }});
            
        }
    }
}
