
package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.Wait;
import javax.swing.JComboBox;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyListener;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;

public class WaitProperty
    extends AbstractActProperty {
	ResourceBundle res = ResChoose.getLanguage();
  Wait waitActivity;
  JTextField txtForTime;
  JTextField txtUntil;
  String name = null;
  String joinCondition = null;
  String suppressJoinFailure = null;
  String forTime = this.waitActivity.getAtForTimeValue();
  String until = this.waitActivity.getAtUntilValue();
  
  public WaitProperty(Figure f) {
    super(f);
    waitActivity = (Wait)this.act;
    this.initAttTable();
  }
  
  void initAttTable() {
    name = this.act.getAtNameValue();
    joinCondition = this.act.getAtJoinConditionValue();
    suppressJoinFailure = this.act.getAtsuppressJoinFailureValue();
    forTime = this.waitActivity.getAtForTimeValue();
    until = this.waitActivity.getAtUntilValue();
    defaultAttTableModel.setDataVector(new Object[][] { {"name", name}
                                       , {"joinCondition", joinCondition}
                                       , {"suppressJoinFailure",
                                       suppressJoinFailure}
                                       , {"for", forTime}
                                       , {"until", until}
    }
                                       , new Object[] {
    		res.getString("propertyname"), res.getString("propertyvalue")});
    this.txtForTime = new JTextField();
    this.txtForTime.addKeyListener(new KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          waitActivity.setAtForTimeValue(txtForTime.getText());
          process.write();
          if (txtForTime.getText() == null || txtForTime.getText().equals("")) {
            WaitProperty.this.txtUntil.setEditable(true);
          }
          else {
            WaitProperty.this.txtUntil.setEditable(false);
          }
        }
      }
    });
    this.txtUntil = new JTextField();
    this.txtUntil.addKeyListener(new KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          waitActivity.setAtUntilValue(txtUntil.getText());
          process.write();
          if (txtUntil.getText() == null || txtUntil.getText().equals("")) {
            WaitProperty.this.txtForTime.setEditable(true);
          }
          else {
            WaitProperty.this.txtForTime.setEditable(false);
          }
        }
      }
    });
    txtname = new JTextField();
    txtname.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtNameValue(txtname.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.txtjoinCondition = new JTextField();
    txtjoinCondition.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.comBoxsuppressJoinFailure = new JComboBox();
    this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxsuppressJoinFailure)) {
          act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure.
                                            getSelectedItem().toString());
          process.write();
        }
      }
    });
    
    EachRowRenderer rowRenderer = new EachRowRenderer();
    
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
    DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
        txtjoinCondition);
    DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
        comBoxsuppressJoinFailure);
    DefaultCellEditor txtForTimeEditor = new DefaultCellEditor(
        this.txtForTime);
    DefaultCellEditor txtUntilEditor = new DefaultCellEditor(this.txtUntil);
    rowEditor.setEditorAt(0, txtnameEditor);
    rowEditor.setEditorAt(1, txtJoinConditionEditor);
    rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
    rowEditor.setEditorAt(3, txtForTimeEditor);
    rowEditor.setEditorAt(4, txtUntilEditor);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
  }
  
  public void addCopy(Copy c) {
  }
  
  public void deleteCopy(Copy c) {
  }
  
  public void setAttTable() {
    List it6 = new Vector();
    int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
    for (int i = j6; i >= 0; i--) {
      ActionListener it = this.comBoxsuppressJoinFailure.getActionListeners()[i];
      it6.add(it);
      this.comBoxsuppressJoinFailure.removeActionListener(it);
    }
    comBoxsuppressJoinFailure.removeAllItems();
    comBoxsuppressJoinFailure.addItem("yes");
    comBoxsuppressJoinFailure.addItem("no");
    if (this.waitActivity != null) {
      this.txtname.setText(this.name);
      this.txtjoinCondition.setText(this.joinCondition);
      for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
        String txtcon = (String)this.comBoxsuppressJoinFailure.getItemAt(f);
        if (this.suppressJoinFailure.equals(txtcon)) {
          this.comBoxsuppressJoinFailure.setSelectedIndex(f);
          break;
        }
      }
      this.txtForTime.setText(this.forTime);
      this.txtUntil.setText(this.until);
    }
    for (int i = 0; i < it6.size(); i++) {
      ActionListener it = (ActionListener) it6.get(i); ;
      this.comBoxsuppressJoinFailure.addActionListener(it);
    }
  }

public void addCorrelation(Correlation c) {
		
}

public void deleteCorrelation(Correlation correlation) {
		
}

public void correlatinNameUpdate(Correlation c, String s) {
        
}
}
