package org.act.wsc.bpel4wsmodeling.view.graphic.processeditor;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.processassist.CorrelationSetDialog;
import org.act.wsc.bpel4wsmodeling.view.processassist.PartnerLinkDialog;
import org.act.wsc.bpel4wsmodeling.view.processassist.VariableDialog;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;
import java.util.ResourceBundle;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSet;
import org.act.wsc.bpel4wsmodeling.def.process.PartnerLink;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;

public class ProcessPropertyRightMenu
    extends JPopupMenu {
	 
	 ResourceBundle res = ResChoose.getLanguage();
  private JMenuItem editProperty = new JMenuItem(res.getString("editproperty"));
  private JMenuItem modelview = new JMenuItem(res.getString("editview"));
  private JMenuItem delete = new JMenuItem(res.getString("delete"));
  private Object obj;
  MainFrame frame = MainFrame.getmainFrame();
  GraphLayer myLayer;
  PartnerLink plink;
  Variable variable;
  CorrelationSet correlationSet;
  public ProcessPropertyRightMenu(Object object, GraphLayer graphLayer) {
    this.myLayer = graphLayer;
    this.obj = object;
    if (obj instanceof PartnerLink) {
      this.add(this.editProperty);
      this.add(this.delete);
      plink = (PartnerLink) obj;
      this.editProperty.addMouseListener(new MouseAdapter() {
        public void mouseReleased(MouseEvent e) {
          if (e.getButton() == 1&& e.getClickCount() == 1) {
            PartnerLinkDialog pLinkDialog = new PartnerLinkDialog(frame,
                myLayer, plink);
            pLinkDialog.setDialog() ;
            pLinkDialog.setSize(new Dimension(470, 350));
            pLinkDialog.setLocation( (frame.getWidth() -
                                      pLinkDialog.getWidth()) /
                                    2,
                                    (frame.getHeight() -
                                     pLinkDialog.getHeight()) /
                                    2);
            pLinkDialog.show();
          }
        }
      });
      this.delete .addMouseListener(new MouseAdapter(){
         public void mouseReleased(MouseEvent e) {
           if (e.getButton() == 1&& e.getClickCount() == 1) {
             myLayer.getBPELProcess() .deletePartnerLink(plink) ;
             myLayer.getBPELProcess() .write() ;
           }
         }
      }) ;
    }
    else if (obj instanceof Variable) {
      this.add(this.editProperty);
      this.add(this.delete);
      this.variable  = (Variable) obj;
     this.editProperty.addMouseListener(new MouseAdapter() {
       public void mouseReleased(MouseEvent e) {
         if (e.getButton() == 1&& e.getClickCount() == 1) {
           VariableDialog varDialog = new VariableDialog(frame,
               myLayer, variable);
           varDialog.setDialog() ;
           varDialog.setSize(new Dimension(700, 260));
           varDialog.setLocation( (frame.getWidth() -
                                     varDialog.getWidth()) /
                                   2,
                                   (frame.getHeight() -
                                    varDialog.getHeight()) /
                                   2);
           varDialog.show();
         }
       }
     });
     this.delete .addMouseListener(new MouseAdapter(){
        public void mouseReleased(MouseEvent e) {
          if (e.getButton() == 1&& e.getClickCount() == 1) {
            myLayer.getBPELProcess() .deleteVariable(variable) ;
            myLayer.getBPELProcess() .write() ;
          }
        }
     }) ;
    }else if(obj instanceof CorrelationSet){
      this.add(this.editProperty);
      this.add(this.delete);
      this.correlationSet  = (CorrelationSet) obj;
      this.editProperty.addMouseListener(new MouseAdapter() {
        public void mouseReleased(MouseEvent e) {
          if (e.getButton() == 1&& e.getClickCount() == 1) {
            CorrelationSetDialog cDialog = new CorrelationSetDialog(frame,
                myLayer,correlationSet);
            cDialog.setDialog() ;
            cDialog.setSize(new Dimension(470, 350));
            cDialog.setLocation( (frame.getWidth() -
                                      cDialog.getWidth()) /
                                    2,
                                    (frame.getHeight() -
                                     cDialog.getHeight()) /
                                    2);
            cDialog.show();
          }
        }
      });
      this.delete .addMouseListener(new MouseAdapter(){
         public void mouseReleased(MouseEvent e) {
           if (e.getButton() == 1&& e.getClickCount() == 1) {
             myLayer.getBPELProcess() .deleteCorrelationSet(correlationSet)  ;
             myLayer.getBPELProcess() .write() ;
           }
         }
      }) ;
    }
  }
}
