
package org.act.wsc.bpel4wsmodeling.view.graphic.rightbuttonmenu;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;

public class RightMenuFactory {
    
  public static AbstractRightMenu createRightMenuByFigure(Figure figure) {
    switch (figure.getType()) {
      case Figure.LABLE_SWITCH:
        return new SwitchRightMenu(figure);
      case Figure.LABLE_PICK:
        return new PickRightMenu(figure);
      case Figure.LABLE_FLOW:
        return new FlowRightMenu(figure);
      case Figure.LABLE_ASSIGN:
        return new AssignRightMenu(figure);
      case Figure.LABLE_INVOKE:
        return new InvokeRightMenu(figure);
      case Figure.LABLE_RECEIVE:
        return new ReceiveRightMenu(figure);
      case Figure.LABLE_REPLY:
        return new ReplyRightMenu(figure);
      case Figure.LABLE_SCOPE:
        return new ScopeRightMenu(figure);
      case Figure.LABLE_ONMESSAGE:
          return new OnMessageRightMenu(figure);
      default:
        return new CommonRightMenu(figure);
    }
  }
}
