
package org.act.wsc.bpel4wsmodeling.view.gui;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IProjectListener;
import org.act.wsc.bpel4wsmodeling.view.action.AddPartnerLinkTypeAction;
import org.act.wsc.bpel4wsmodeling.view.action.AddPropertyAction;
import org.act.wsc.bpel4wsmodeling.view.action.AddPropertyAliasAction;
import org.act.wsc.bpel4wsmodeling.view.action.AddRoleAction;
import org.act.wsc.bpel4wsmodeling.view.action.ImportLocalWSDLAction;
import org.act.wsc.bpel4wsmodeling.view.action.ImportUDDIWSDLAction;
import org.act.wsc.bpel4wsmodeling.view.action.UserDefineWSDLAction;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class JProjectMenu extends JMenu implements IProjectListener{
    private JMenu importWSDL;
    private JMenuItem itemLOCALWSDL;
    private JMenuItem itemUDDIWSDL;
    private JMenuItem UserDefineWSDL;
    private JMenu design;
    private JMenuItem designPortType;
    private JMenuItem addRole;
    private JMenuItem addPartnerLinkType;
    private JMenuItem addProperty;
    private JMenuItem addPropertyAlias;
    
    private Project project=null;
    
    
    static ResourceBundle res = ResChoose.getLanguage();
    
    
    public JProjectMenu() {
        super( res.getString("JPorjectMenu_project"));
        WorkSpace.getInstance().addListener(this);
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void jbInit() {
        
        importWSDL = new JMenu(res.getString("importWsdlFile"));
        itemLOCALWSDL = new JMenuItem(res.getString("lacalImport"));
        
        this.importWSDL.add(this.itemLOCALWSDL);
        itemUDDIWSDL = new JMenuItem(res.getString("fromUDDI"));
        
        this.importWSDL.add(this.itemUDDIWSDL);
        UserDefineWSDL = new JMenuItem(res.getString("user_defined"));
        
        this.add(this.importWSDL);
        this.add(this.UserDefineWSDL);
        this.design = new JMenu(res.getString("design"));
        this.add(this.design);
       
        this.designPortType=new JMenuItem("portType");
        this.design.add(this.designPortType);
        this.designPortType.setEnabled(false);
        
        this.addRole = new JMenuItem("role");
        
        this.design.add(this.addRole);
        this.addPartnerLinkType = new JMenuItem("partnerLinkType");
        
        this.design.add(this.addPartnerLinkType);
        this.addProperty = new JMenuItem("property");
        
        this.design.add(this.addProperty);
        this.addPropertyAlias = new JMenuItem("propertyAlias");
        
        this.design.add(this.addPropertyAlias);
        
        this.display(false);
        
    }
    private void display(boolean isEnable){
        this.importWSDL.setEnabled(isEnable);
        this.UserDefineWSDL.setEnabled(isEnable);
        this.design.setEnabled(isEnable);
        if(isEnable){
            itemLOCALWSDL.addActionListener(new ImportLocalWSDLAction(project));
            itemUDDIWSDL.addActionListener(new ImportUDDIWSDLAction(project));
            this.UserDefineWSDL.addActionListener(new UserDefineWSDLAction(
                    project));
            this.addRole.addActionListener(new AddRoleAction(project));
            this.addPartnerLinkType
            .addActionListener(new AddPartnerLinkTypeAction(project));
            this.addProperty.addActionListener(new AddPropertyAction(project));
            this.addPropertyAlias.addActionListener(new AddPropertyAliasAction(
                    project));
        }
        
    }
    
    public void projectCreated(Project project) {
        this.project=project;
        this.display(true);
    }
    
    public void projectOpened(Project project) {
        this.project=project;
        this.display(true);
    }
    
    public void projectClosed(Project project) {
        this.project=null;
        this.display(false);
    }
    
    public void projectRemoved(Project project) {
                
    }
    
    public void projectSaved(Project project) {
                
    }
}
