package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;
import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.border.Border;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IProjectListener;
import org.act.wsc.bpel4wsmodeling.resource.ResourceManager;
import org.act.wsc.bpel4wsmodeling.resource.StandardImageIcon;
import org.act.wsc.bpel4wsmodeling.view.action.AboutAction;
import org.act.wsc.bpel4wsmodeling.view.action.CloseProjectAction;
import org.act.wsc.bpel4wsmodeling.view.action.CreateProjectAction;
import org.act.wsc.bpel4wsmodeling.view.action.GenerateDeploymentUnitAction;
import org.act.wsc.bpel4wsmodeling.view.action.OpenProjectAction;
import org.act.wsc.bpel4wsmodeling.view.action.QuitAppAction;
import org.act.wsc.bpel4wsmodeling.view.action.SaveProjectAction;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class MainFrame
    extends JFrame
    implements IProjectListener {
	
  private static MainFrame mainFrame = null;
  private ImageIcon image[] = new ImageIcon[10];
  private ImageIcon mainImage;
  
  
 
 ResourceBundle res = ResChoose.getLanguage();
	
  JPanel contentPane;
    MainToolBar mainToolBar=new MainToolBar(this);
  
    JLabel statusBar = new JLabel();
    JMenuBar jMenuBar = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JProjectMenu jMenuProject = new JProjectMenu();
  JMenu jMenuTool = new JMenu();
  JMenu jMenuHelp = new JMenu();
    private JMenuItem jMenuItemCreateWSAR=new JMenuItem(res.getString("createWSAR"));
  private JCheckBoxMenuItem jMenuItemToolBar=new JCheckBoxMenuItem(res.getString("menuItemToolBar"),true);
  private JCheckBoxMenuItem jMenuItemOutput=new JCheckBoxMenuItem(res.getString("menuItemOutput"),true);
  
    JMenuItem JMenuItemNewProject = new JMenuItem(res.getString("new"));
  JMenuItem JMenuItemOpenProject = new JMenuItem(res.getString("open"));
  JMenuItem JMenuItemSaveProject = new JMenuItem(res.getString("save"));
  JMenuItem JMenuItemCloseProject = new JMenuItem(res.getString("close"));
  JMenuItem JMenuItemQuit = new JMenuItem(res.getString("quit"));
  
    JMenuItem JMenuItemAbout = new JMenuItem(res.getString("about"));
  
  JSplitPane jMainAndOutputPane=new JSplitPane();
 
  JSplitPane jTreeAndOtherPane = new JSplitPane();   
  OutputWindow outputWindow=new OutputWindow();    JScrollPane jTreeScrollPane = new JScrollPane();   JPanel jTreePane = new JPanel();
  JSplitPane jViewAndProperty = new JSplitPane();  
    public JPanel jPropertyPane = new JPanel();   JPanel jPanelView = new JPanel();
  Project project;   public MainFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    WorkSpace.getInstance().addListener(this);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    this.addWindowListener(new WindowListener() {
      public void windowActivated(WindowEvent e) {
              }
      public void windowClosed(WindowEvent e) {
              }
      public void windowClosing(WindowEvent e) {
                  new QuitAppAction().quitApp();
      }
      public void windowDeactivated(WindowEvent e) {
              }
      public void windowDeiconified(WindowEvent e) {
              }
      public void windowIconified(WindowEvent e) {
              }
      public void windowOpened(WindowEvent e) {
              }
    });
  }
  private void jbInit() throws Exception {
    image[0] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_NEW);
    image[1] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_OPEN);
    image[2] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_SAVE);
    image[3] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_CLOSE);
    image[4] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_QUIT);
    image[5] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_HELP);
    mainImage = ResourceManager.getImageIcon(StandardImageIcon.MAIN);
    setIconImage(mainImage.getImage());
    this.setTitle("WebSASE Web Service Workflow Designer v2.0");
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        this_componentResized(e);
      }
    });
    contentPane = (JPanel)this.getContentPane();
    statusBar.setText(res.getString("auther"));
        this.jMenuFile.setText(res.getString("file"));
    this.jMenuBar.add(jMenuFile);
    this.jMenuProject.setText(res.getString("project"));
    this.jMenuBar.add(this.jMenuProject);
    this.jMenuTool.setText(res.getString("tool"));
    this.jMenuBar.add(this.jMenuTool);
    this.jMenuHelp.setText(res.getString("help"));
    this.jMenuBar.add(this.jMenuHelp); 
    
    this.jMenuFile.add(this.JMenuItemNewProject);
    this.jMenuFile.add(this.JMenuItemOpenProject);
    this.jMenuFile.add(this.JMenuItemSaveProject);
    this.jMenuFile.add(this.JMenuItemCloseProject);
    this.jMenuFile.add(this.JMenuItemQuit);
    this.JMenuItemNewProject.addActionListener(new CreateProjectAction(this));
    this.JMenuItemOpenProject.addActionListener(new OpenProjectAction());
    this.JMenuItemSaveProject.addActionListener(new SaveProjectAction());
    this.JMenuItemCloseProject.addActionListener(new CloseProjectAction());
    this.JMenuItemQuit.addActionListener(new QuitAppAction());
    this.jMenuTool.add(this.jMenuItemCreateWSAR);
    this.jMenuItemCreateWSAR.setEnabled(false);
    this.jMenuTool.addSeparator();
    this.jMenuTool.add(this.jMenuItemToolBar);
    this.jMenuTool.add(this.jMenuItemOutput);
    
    this.jMenuItemOutput.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent e) {
            if(!MainFrame.this.jMenuItemOutput.isSelected()){
                MainFrame.this.jMainAndOutputPane.setBottomComponent(null);
            }else{
                MainFrame.this.jMainAndOutputPane.setBottomComponent(outputWindow);
                MainFrame.this.jMainAndOutputPane.setDividerLocation( (int) (0.8 * MainFrame.this.getHeight()));
            }
            MainFrame.this.validate();
        }
        
    });
    this.jMenuItemToolBar.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent e) {
            if(!MainFrame.this.jMenuItemToolBar.isSelected()){
                MainFrame.this.remove(mainToolBar);
            }else{
                MainFrame.this.contentPane.add(mainToolBar, BorderLayout.NORTH);
            }
            MainFrame.this.validate();
        }
        
    });
   
    jMenuHelp.add(this.JMenuItemAbout);
    this.JMenuItemAbout.addActionListener(new AboutAction());
    
    
        this.jMainAndOutputPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
    this.jMainAndOutputPane.setTopComponent(this.jTreeAndOtherPane);     this.jMainAndOutputPane.setBottomComponent(this.outputWindow);     this.jMainAndOutputPane.setDividerSize(4);
        this.jTreeAndOtherPane.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
    this.jTreeAndOtherPane.setRightComponent(this.jViewAndProperty);
    jTreePane.setLayout(new BorderLayout());
    this.jTreeAndOtherPane.setLeftComponent(this.jTreePane);     this.jTreeAndOtherPane.setDividerLocation(0.3);
    this.jTreeAndOtherPane.setDividerSize(4);
        this.jViewAndProperty.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
    this.jViewAndProperty.setLeftComponent(this.jPanelView);     this.jViewAndProperty.setRightComponent(this.jPropertyPane);
    this.jViewAndProperty.setDividerSize(4);
        this.jPropertyPane.setLayout(new BorderLayout());
    
        this.setJMenuBar(this.jMenuBar);
    this.contentPane.add(this.mainToolBar, BorderLayout.NORTH);
    this.contentPane.add(this.statusBar, BorderLayout.SOUTH);
    this.contentPane.add(this.jMainAndOutputPane);
    this.jMainAndOutputPane.setDividerLocation( (int) (0.8 * this.getHeight()));
    this.jTreeAndOtherPane.setDividerLocation( (int) (0.15 * this.getWidth()));
    this.jViewAndProperty.setDividerLocation( (int) (0.65 * this.getWidth()));
  }
  void this_componentResized(ComponentEvent e) {
    this.jMainAndOutputPane.setDividerLocation( (int) (0.8 * this.getHeight()));
    this.jTreeAndOtherPane.setDividerLocation( (int) (0.15 * this.getWidth()));
    this.jViewAndProperty.setDividerLocation( (int) (0.65 * this.getWidth()));
  }
    public static MainFrame getmainFrame() {
    if (mainFrame == null) {
      mainFrame = new MainFrame();
    }
    return mainFrame;
  }
  public NavigationPane navigationpane = null;
  public EditPane editPane = null;
  public Map projToNav=new HashMap();
  public Map projToEdit=new HashMap();
  
  
  public void projectCreated(Project project) {
            this.jMenuItemCreateWSAR.setEnabled(true);
      this.jMenuItemCreateWSAR.addActionListener(new GenerateDeploymentUnitAction(project));
      
      if(!WorkSpace.getInstance().getProjects().containsValue(project)){
          this.mainToolBar.getJComboBoxImportedProject().addItem(project.getProjectName());
          this.mainToolBar.getJComboBoxImportedProject().setEnabled(true);
          this.mainToolBar.getJComboBoxImportedProject().setSelectedItem(project.getProjectName());
      }   
            this.project = project;     navigationpane = new NavigationPane(project);
    this.jTreePane.add(navigationpane);
    navigationpane.setMainFrame(this);
    this.jPanelView.setLayout(new BorderLayout());
    editPane = new EditPane(project);
    this.jPanelView.add(editPane);
    
    this.projToNav.put(project,navigationpane);
    this.projToEdit.put(project,editPane);
    
    this.jTreePane.validate();
    this.jPanelView.validate();
    this.repaint();
  }
  
  public void projectOpened(Project project) {
            this.jMenuItemCreateWSAR.setEnabled(true);
      this.jMenuItemCreateWSAR.addActionListener(new GenerateDeploymentUnitAction(project));
          if(!WorkSpace.getInstance().getProjects().containsValue(project)){
          this.mainToolBar.getJComboBoxImportedProject().addItem(project.getProjectName());
          this.mainToolBar.getJComboBoxImportedProject().setEnabled(true);
          this.mainToolBar.getJComboBoxImportedProject().setSelectedItem(project.getProjectName());
      }
        this.project = project;
    navigationpane =(NavigationPane) this.projToNav.get(project);
    if(navigationpane==null){
        navigationpane = new NavigationPane(project); 
        this.projToNav.put(project,navigationpane);
    }
    this.jTreePane.removeAll();
    this.jTreePane.add(navigationpane);
    
    navigationpane.setMainFrame(this);
    this.jPanelView.setLayout(new BorderLayout());
    editPane=(EditPane) this.projToEdit.get(project);
    if(editPane==null){
        editPane = new EditPane(project);
        this.projToEdit.put(project,editPane);
    }
    this.jPanelView.removeAll();
    this.jPanelView.add(editPane);
    this.jPropertyPane.removeAll();
    this.jTreePane.validate();
    this.jPanelView.validate();
    this.repaint();
  }
  
  public void projectClosed(Project project) {
            this.jMenuItemCreateWSAR.setEnabled(false);
      
      mainToolBar.getJComboBoxImportedProject().setSelectedIndex(-1);
      this.jTreePane.remove(this.navigationpane);
      this.jPanelView.remove(this.editPane);
      this.jPropertyPane.removeAll();
      this.jTreePane.validate();
      this.jPanelView.validate();
      this.repaint();
  }
  
  public void projectRemoved(Project project) {
      this.jMenuItemCreateWSAR.setEnabled(false);
      mainToolBar.getJComboBoxImportedProject().removeItem(project.getProjectName());
      this.projToNav.remove(project);
      this.projToEdit.remove(project);
      this.jTreePane.remove(this.navigationpane);
      this.jPanelView.remove(this.editPane);
      this.jPropertyPane.removeAll();
      this.jTreePane.validate();
      this.jPanelView.validate();
      this.repaint();
  }
  
  public void projectSaved(Project project) {
      }
  public void setProcessProperty(JScrollPane jScrollPane,
                                 JScrollPane jScrollPane2,
                                 JScrollPane jScrollPane3,
                                 JScrollPane jScrollPane4) {
    this.jPropertyPane.removeAll();
    this.jPropertyPane.setLayout(new GridLayout(4, 1));
    this.jPropertyPane.add(jScrollPane);
    this.jPropertyPane.add(jScrollPane2);
    this.jPropertyPane.add(jScrollPane3);
    this.jPropertyPane.add(jScrollPane4);
    this.jPropertyPane.validate();
  }
  public void setProperty(JScrollPane jScrollPane) {
    this.jPropertyPane.removeAll();
    this.jPropertyPane.setLayout(new GridLayout(1, 1));
    this.jPropertyPane.add(jScrollPane);
    this.jPropertyPane.validate();
  }
  public void setProperty(JScrollPane jScrollPane, JScrollPane jScrollPane1) {
    this.jPropertyPane.removeAll();
    this.jPropertyPane.setLayout(new GridLayout(2, 1));
    this.jPropertyPane.add(jScrollPane);
    this.jPropertyPane.add(jScrollPane1);
    this.jPropertyPane.validate();
  }
  public void setProperty(List list) {
    this.jPropertyPane.removeAll();
    if (list.size() > 0) {
      this.jPropertyPane.setLayout(new GridLayout(list.size(), 1));
      for (int i = 0; i < list.size(); i++) {
        JScrollPane jTempPane = (JScrollPane) list.get(i);
        this.jPropertyPane.add(jTempPane);
      }
    }
    else {
      this.jPropertyPane.setLayout(new GridLayout(1, 1));
      JScrollPane jTempPane = new JScrollPane();
      this.jPropertyPane.add(jTempPane);
    }
    this.jPropertyPane.validate();
  }
  public Project getProject() {
    return this.project;
  }

public OutputWindow getOutputWindow() {
    return outputWindow;
}
}
