
package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.SwingUtilities;
import org.act.wsc.bpel4wsmodeling.debug.operate.DebugOp;
import org.act.wsc.bpel4wsmodeling.debug.operate.IDebugStateListener;

public class OutputWindow extends JTabbedPane implements IDebugStateListener{
    
    MessagePane messagePane=new MessagePane();
    DataPanel dataPane=new DataPanel();
    WatchPane watchPane=new WatchPane();
    
    public OutputWindow() {
        super();
        jbInit();
        DebugOp.getInstance().addListener(this);
    }
    
    
    private void jbInit() {
                this.addTab("message",new JScrollPane(messagePane));
                
            }
    
    public void entered() {
        this.remove(this.indexOfTab("message"));
        this.addTab("variables",new JScrollPane(dataPane));
        this.addTab("watch",new JScrollPane(watchPane));
        this.setSelectedIndex(this.indexOfTab("variables"));
                this.updateUI();
        this.validate();
        this.repaint();
    }
    
    public void start() {
        this.dataPane.setEnabled(false);
        this.watchPane.setEnabled(false);
    }
    
    public void running() {
        this.dataPane.setEnabled(false);
        this.watchPane.setEnabled(false);
    }
    
    public void pause() {
        this.dataPane.setEnabled(true);
        this.dataPane.updateVariables();
        this.watchPane.setEnabled(true);
        this.watchPane.updateWatch();
    }
    
    public void terminate() {
        this.dataPane.clearAll();
        this.dataPane.setEnabled(false);
        this.watchPane.setEnabled(false);
    }
    
    public void quited() {
                this.remove(this.indexOfTab("variables"));
        this.remove(this.indexOfTab("watch"));
        this.addTab("message",new JScrollPane(messagePane));
        this.updateUI();
    }
    
    public MessagePane getMessagePane() {
        return messagePane;
    }
}
