package org.act.wsc.bpel4wsmodeling.view.processassist;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import javax.swing.table.DefaultTableModel;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSet;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSets;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;

public class CorrelationSetDialog extends JDialog {
	
	static ResourceBundle res = ResChoose.getLanguage();
    JPanel jPanel1 = new JPanel();
    JLabel jLabelName = new JLabel();
    JTextField jTextFieldName = new JTextField();
    ButtonGroup buttonGroup1 = new ButtonGroup();
    JLabel jLabelProperties = new JLabel();
    JButton jButtonOK = new JButton();
    JButton jButtonCancel = new JButton();
    JButton jButtonEdit = new JButton();
        Project project;
    MainFrame frame;
    String propertiesValue = null;
    DefaultTableModel defaultPropertiesValueTableModel;
    BPELProcess process = null;
    Scope scope = null;
    CorrelationSet correlationSet = null;
    CorrelationSets correlationSets = null;
    JScrollPane jScrollPaneTable = new JScrollPane();
    JTable jTableProperties = new JTable();
    public CorrelationSetDialog(MainFrame frame, Object obj,
            CorrelationSet correlationSet) {
        super(frame, res.getString("correlationSet"), true);
        this.frame = frame;
        this.project = frame.getProject();
        if (obj instanceof GraphLayer) {
            this.process = ((GraphLayer) obj).getBPELProcess();
            if (this.process.getCorrelationSets() != null) {
                this.correlationSets = (CorrelationSets) this.process
                        .getCorrelationSets().car();
            }
        } else if (obj instanceof Figure) {
            this.scope = (Scope) ((Figure) obj).getServicesSet();
            if (this.scope.getCorrelationSets() != null) {
                this.correlationSets = (CorrelationSets) this.scope
                        .getCorrelationSets().car();
            }
        }
        this.correlationSet = correlationSet;
        this.defaultPropertiesValueTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        jLabelName.setText("name");
        jLabelName.setBounds(new Rectangle(31, 29, 53, 27));
        jPanel1.setLayout(null);
        jTextFieldName.setBounds(new Rectangle(82, 27, 281, 30));
        jLabelProperties.setText("properties");
        jLabelProperties.setBounds(new Rectangle(29, 66, 91, 32));
        jButtonOK.setBounds(new Rectangle(174, 264, 78, 26));
        jButtonOK.setText(res.getString("yes"));
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonOK_actionPerformed(e);
            }
        });
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.setBounds(new Rectangle(280, 263, 82, 26));
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonCancel_actionPerformed(e);
            }
        });
        jButtonEdit.setText("Edit");
        jButtonEdit.setBounds(new Rectangle(282, 72, 79, 26));
        jButtonEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonEdit_actionPerformed(e);
            }
        });
        jScrollPaneTable.setBounds(new Rectangle(29, 102, 335, 156));
                this.defaultPropertiesValueTableModel.setDataVector(new Object[][] {},
                new Object[] { "Properties" });
        this.jTableProperties.setModel(this.defaultPropertiesValueTableModel);
                                        this.getContentPane().add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jLabelName, null);
        jPanel1.add(jTextFieldName, null);
        jPanel1.add(jLabelProperties, null);
        jPanel1.add(jButtonEdit, null);
        jPanel1.add(jScrollPaneTable, null);
        jPanel1.add(jButtonOK, null);
        jPanel1.add(jButtonCancel, null);
        jScrollPaneTable.getViewport().add(jTableProperties, null);
                if (this.correlationSet != null) {
        }
    }
    public void setDialog() {
        if (this.correlationSet != null) {
            this.jTextFieldName.setText(this.correlationSet.getAtNameValue());
                                    this.propertiesValue = this.correlationSet.getAtPropertiesValue();
            this.updateTable(this.correlationSet.getAtPropertiesValue());
                    }
    }
    public void jButtonEdit_actionPerformed(ActionEvent e) {
        PropertiesDialog pd = new PropertiesDialog(this.project, this.frame);
        pd.setModal(true);
        pd.setSize(new Dimension(440, 300));
        pd.setLocation((this.frame.getWidth() - pd.getWidth()) / 2, (this.frame
                .getHeight() - pd.getHeight()) / 2);
        pd.show();
                        this.propertiesValue = pd.getPropertiesValue();
        updateTable(this.propertiesValue);
            }
    
    public void updateTable(String s) {
        if (s != null && s != "") {
            if (this.defaultPropertiesValueTableModel.getRowCount() > 0) {
                this.defaultPropertiesValueTableModel.removeRow(0);
            }
            Object[] data = new Object[] { s };
            this.defaultPropertiesValueTableModel.addRow(data);
        } else {
            if (this.defaultPropertiesValueTableModel.getRowCount() > 0) {
                this.defaultPropertiesValueTableModel.removeRow(0);
            }
        }
    }
    public void jButtonOK_actionPerformed(ActionEvent e) {
        if (this.correlationSets == null) {
            this.correlationSets = new CorrelationSets();
        }
        CorrelationSet tempSet = new CorrelationSet();
        tempSet.setAtNameValue(this.jTextFieldName.getText());
        tempSet.setAtPropertiesValue(this.propertiesValue);
                if (this.correlationSet == null) {
            this.correlationSet = new CorrelationSet();
            boolean flag = false;
            for (int i = 0; i < this.correlationSets.getChilds().size(); i++) {
                CorrelationSet cs = (CorrelationSet) this.correlationSets
                        .getChilds().get(i);
                if (cs.getAtNameValue().equals(tempSet.getAtNameValue())) {
                    flag = true;
                    break;
                }
            }
            if (flag == false) {
                correlationSet.setAtNameValue(tempSet.getAtNameValue());
                correlationSet.setAtPropertiesValue(tempSet
                        .getAtPropertiesValue());
                if (this.process != null) {
                    this.process.addCorrelationSet(this.correlationSet);
                } else if (this.scope != null) {
                    this.scope.addCorrelationSet(this.correlationSet);
                }
            }
        } else {
                                                                                                                                                this.correlationSet.setAtNameValue(tempSet.getAtNameValue());
                        this.correlationSet.setAtPropertiesValue(tempSet
                    .getAtPropertiesValue());
        }
        this.project.getProcess().write();
                                this.dispose();
    }
    public void jButtonCancel_actionPerformed(ActionEvent e) {
        this.dispose();
    }
}
