
package org.act.wsc.bpel4wsmodeling.view.processassist;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.ResourceBundle;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.wsdl.PortType;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.projectdata.ElementReader;
import org.act.wsc.bpel4wsmodeling.projectdata.ElementWriter;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.InputImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.MessageImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OperationImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OutputImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PortTypeImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistryEntry;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class PortTypeDesignDialog extends JDialog implements MouseListener {
    JList jListPts = new JList();
    JButton jButtonClose = new JButton();
    DefaultListModel listModel = new DefaultListModel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    Project project;
    
    static ResourceBundle res = ResChoose.getLanguage();
    
    public PortTypeDesignDialog(Project project) {
        super(MainFrame.getmainFrame(), res.getString("designPortType"), true);
        this.project = project;
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        jListPts.setModel(listModel);
        this.getContentPane().setLayout(gridBagLayout1);
        this.setSize(400, 300);
        jButtonClose.setText(res.getString("yes"));
        jButtonClose
                .addActionListener(new PortTypeDesignDialog_jButtonClose_actionAdapter(
                        this));
        this.getContentPane().add(
                jButtonClose,
                new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
                        GridBagConstraints.CENTER, GridBagConstraints.NONE,
                        new Insets(0, 327, 2, 0), 14, -1));
        this.getContentPane().add(
                jListPts,
                new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
                        GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                        new Insets(0, 0, 0, 0), 400, 273));
        jListPts.addMouseListener(this);
        setDialog();
    }
    private void setDialog() {
                if(project.getElementReader()!=null&&project.getElementReader().getPortTypeEntrys()!=null){
            for (Iterator iter = project.getElementReader().getPortTypeEntrys()
                    .iterator(); iter.hasNext();) {
                WSDLRegistryEntry entry = (WSDLRegistryEntry) iter.next();
                listModel.addElement(entry);
            }
        }
    }
    public void jButtonClose_actionPerformed(ActionEvent e) {
                Metaset elements = this.project.getElementWriter().getElements();
                if(elements.getChilds()!=null&&elements.getChilds().size()>0){
            elements.remove(".\\*");
        }
                for (int i = 0; i < listModel.toArray().length; i++) {
            WSDLRegistryEntry entry = (WSDLRegistryEntry) listModel.toArray()[i];
            PortTypeImpl portType = (PortTypeImpl) entry.userObject;
            Metaset element = new Metaset("element");
            Metaset portTypeSet = new Metaset("portType");
            portTypeSet.add(new Attribute("name", portType.getQName()
                    .getLocalPart()));
            for (Iterator iter = portType.getOperations().iterator(); iter
                    .hasNext();) {
                OperationImpl operation = (OperationImpl) iter.next();
                Metaset opSet = new Metaset("operation");
                opSet.add(new Attribute("name", operation.getName()));
                if (operation.getInput() != null) {
                    Metaset inMset = new Metaset("inMessage");
                    inMset.add(new Attribute("name",
                            ((MessageImpl) (((InputImpl) operation.getInput())
                                    .getMessage())).toString()));
                    opSet.add(inMset);
                    inMset.setFather(opSet);
                }
                if (operation.getOutput() != null) {
                    Metaset outMset = new Metaset("outMessage");
                    outMset
                            .add(new Attribute("name",
                                    ((MessageImpl) (((OutputImpl) operation
                                            .getOutput()).getMessage()))
                                            .toString()));
                    opSet.add(outMset);
                    outMset.setFather(opSet);
                }
                portTypeSet.add(opSet);
                opSet.setFather(portTypeSet);
            }
            element.add(portTypeSet);
            portTypeSet.setFather(element);
            elements.add(element);
            element.setFather(elements);
        }
        this.project.getElementWriter().write();
        this.dispose();
    }
    
    public void mouseClicked(MouseEvent e) {
        
        if (e.getButton() == 3 && e.getClickCount() == 1) {
            JPopupMenu popupMenu = new JPopupMenu();
            JMenuItem addItem = new JMenuItem(res.getString("addportType"));
            JMenuItem editItem = new JMenuItem(res.getString("editportType"));
            JMenuItem removeItem = new JMenuItem(res.getString("deleteportType"));
            popupMenu.add(addItem);
            popupMenu.add(editItem);
            popupMenu.add(removeItem);
            addItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                                        PortTypeDefineDialog defineDialog = new PortTypeDefineDialog(
                            null, project);
                    defineDialog
                            .setLocation(PortTypeDesignDialog.this.getX()
                                    + PortTypeDesignDialog.this.getWidth() / 2,
                                    PortTypeDesignDialog.this.getY()
                                            + PortTypeDesignDialog.this
                                                    .getHeight() / 2);
                    defineDialog.show();
                    PortType pt = defineDialog.getPortType();
                    if (pt != null) {
                        WSDLRegistryEntry wre = new WSDLRegistryEntry();
                        wre.sourceWSDL = null;
                        wre.namespace = pt.getQName().getNamespaceURI();
                        wre.localName = pt.getQName().getLocalPart();
                        wre.type = WSDLRegistryEntry.TYPE_PT;
                        wre.userObject = pt;
                                                project.getWSDLRegistry().addPortType(wre);
                                                listModel.addElement(wre);
                    }
                }
            });
            editItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    WSDLRegistryEntry wre = (WSDLRegistryEntry) jListPts
                            .getSelectedValue();
                                        if (wre.type == WSDLRegistryEntry.TYPE_PT) {
                        PortType portType = (PortType) wre.userObject;
                        PortTypeDefineDialog defineDialog = new PortTypeDefineDialog(
                                (PortTypeImpl) portType, project);
                        defineDialog
                        .setLocation(PortTypeDesignDialog.this.getX()
                                + PortTypeDesignDialog.this.getWidth() / 2,
                                PortTypeDesignDialog.this.getY()
                                        + PortTypeDesignDialog.this
                                                .getHeight() / 2);
                        defineDialog.show();
                        wre.localName = portType.getQName().getLocalPart();
                    }
                }
            });
            removeItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    WSDLRegistryEntry wre = (WSDLRegistryEntry) jListPts
                            .getSelectedValue();
                                        project.getWSDLRegistry().removePortType(wre);
                                        listModel.removeElement(wre);
                }
            });
            popupMenu.show(e.getComponent(),e.getX(),e.getY());
        }
    }
    
    public void mouseEntered(MouseEvent e) {
            }
    
    public void mouseExited(MouseEvent e) {
            }
    
    public void mousePressed(MouseEvent e) {
            }
    
    public void mouseReleased(MouseEvent e) {
            }
}
class PortTypeDesignDialog_jButtonClose_actionAdapter implements ActionListener {
    private PortTypeDesignDialog adaptee;
    PortTypeDesignDialog_jButtonClose_actionAdapter(PortTypeDesignDialog adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonClose_actionPerformed(e);
    }
}
