package org.act.wsc.bpel4wsmodeling.view.processassist;
import java.awt.BorderLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Iterator;
import java.util.Properties;
import java.util.ResourceBundle;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.wsdl.Definition;
import javax.wsdl.Message;
import javax.wsdl.Part;
import javax.wsdl.WSDLException;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.wsdl.extensions.UnknownExtensibilityElement;
import javax.wsdl.xml.WSDLWriter;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Property;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyAlias;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistry;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistryEntry;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
//<p></p><p></p><p></p><p></p>
public class PropertyAliasDialog extends JDialog {
	
	 static ResourceBundle res = ResChoose.getLanguage();
    Project project = null;
    PropertyAlias propertyAlias = null;
    JPanel jPanelPropertyAlias = new JPanel();
    JLabel jLabelProName = new JLabel();
    JComboBox jComboBoxProName = new JComboBox();
    JLabel jLabelMesType = new JLabel();
    JComboBox jComboBoxMesType = new JComboBox();
    JComboBox jComboBoxPart = new JComboBox();
    JLabel jLabelPart = new JLabel();
    JButton jButtonOK = new JButton();
    JButton jButtonCancel = new JButton();
    PropertyWsdl propertyWsdl;
    Definition wsdlProperty;
    public PropertyAliasDialog(Project proj, MainFrame mainframe,
            PropertyAlias propertyAlias) {
        super(mainframe);
        this.project = proj;
        this.propertyAlias = propertyAlias;
        propertyWsdl = this.project.getPropertyWsdl();
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        jPanelPropertyAlias.setLayout(null);
        jLabelProName.setText("PropertyName");
        jLabelProName.setBounds(new Rectangle(29, 43, 85, 26));
        jComboBoxProName.setBounds(new Rectangle(150, 47, 243, 26));
        jLabelMesType.setText("MessageType");
        jLabelMesType.setBounds(new Rectangle(25, 120, 76, 23));
        jComboBoxMesType.setBounds(new Rectangle(151, 114, 242, 26));
        jComboBoxMesType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jComboBoxMesType_actionPerformed(e);
            }
        });
        jComboBoxPart.setBounds(new Rectangle(152, 185, 241, 26));
        jLabelPart.setText("Part");
        jLabelPart.setBounds(new Rectangle(25, 188, 67, 23));
        jButtonOK.setBounds(new Rectangle(205, 244, 69, 25));
        jButtonOK.setText(res.getString("yes"));
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonOK_actionPerformed(e);
            }
        });
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.setBounds(new Rectangle(288, 243, 69, 25));
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.setBounds(new Rectangle(312, 243, 71, 26));
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonCancel_actionPerformed(e);
            }
        });
        this.getContentPane().add(jPanelPropertyAlias, BorderLayout.CENTER);
        jPanelPropertyAlias.add(jLabelProName, null);
        jPanelPropertyAlias.add(jComboBoxProName, null);
        jPanelPropertyAlias.add(jLabelMesType, null);
        jPanelPropertyAlias.add(jComboBoxMesType, null);
        jPanelPropertyAlias.add(jComboBoxPart, null);
        jPanelPropertyAlias.add(jLabelPart, null);
        jPanelPropertyAlias.add(jButtonCancel, null);
        jPanelPropertyAlias.add(jButtonOK, null);
    }
    public void setDialog() {
        this.jComboBoxProName.removeAllItems();
        java.util.List properties = this.project.getProperties();
        for (int i = 0; i < properties.size(); i++) {
            this.jComboBoxProName.addItem(properties.get(i));
        }
        this.jComboBoxMesType.removeAllItems();
        this.jComboBoxPart.removeAllItems();
        if (this.project.getWSDLRegistry() != null) {
            WSDLRegistry wsdlRegistry = project.getWSDLRegistry();
            java.util.List messages = wsdlRegistry.findMessages();
            for (int i = 0; i < messages.size(); i++) {
                WSDLRegistryEntry wre = (WSDLRegistryEntry) messages.get(i);
                this.jComboBoxMesType.addItem(wre);
                                                                                                            }
        }
        if (this.propertyAlias != null) {
            this.wsdlProperty = this.propertyWsdl.getPropertyWsdl();
            for (int i = 0; i < this.jComboBoxProName.getItemCount(); i++) {
                Property property = (Property) this.jComboBoxProName
                        .getItemAt(i);
                if (property.getName().equals(
                        this.propertyAlias.getPropertyName())) {
                    this.jComboBoxProName.setSelectedIndex(i);
                }
            }
            for (int i = 0; i < this.jComboBoxMesType.getItemCount(); i++) {
                WSDLRegistryEntry wre = (WSDLRegistryEntry) this.jComboBoxMesType
                        .getItemAt(i);
                String prefix = this.wsdlProperty.getPrefix(wre.namespace);                                QName name = new QName(wre.namespace, wre.localName);
                                if (name.equals(this.propertyAlias.getMessageType().getQName())) {
                    this.jComboBoxMesType.setSelectedIndex(i);
                    for (int t = 0; t < this.jComboBoxPart.getItemCount(); t++) {
                        String partName = (String) this.jComboBoxPart
                                .getItemAt(t);
                        if (partName.equals(this.propertyAlias.getPart())) {
                            this.jComboBoxPart.setSelectedIndex(t);
                        }
                    }
                }
            }
        }
    }
    public void jButtonOK_actionPerformed(ActionEvent e) {
        PropertyAlias proat = new PropertyAlias();
        Property pro = (Property) this.jComboBoxProName.getSelectedItem();
        proat.setPropertyName(pro.getName());
        WSDLRegistryEntry wre = (WSDLRegistryEntry) this.jComboBoxMesType
                .getSelectedItem();
        proat.setMessageType((Message) wre.userObject);
        if (this.jComboBoxPart.getSelectedItem() != null) {
            proat.setPart(this.jComboBoxPart.getSelectedItem().toString());
        }
        if (this.propertyAlias == null) {
            this.propertyAlias = proat;
            this.project.addPropertyAlias(this.propertyAlias);
        } else {
            this.propertyAlias.setPropertyName(pro.getName());
            this.propertyAlias.setMessageType((Message) wre.userObject);
            this.propertyAlias.setPart(this.jComboBoxPart.getSelectedItem()
                    .toString());
            this.project.modifyProperty();
        }
        this.dispose();
    }
    public void jButtonCancel_actionPerformed(ActionEvent e) {
        this.dispose();
    }
    void jComboBoxMesType_actionPerformed(ActionEvent e) {
        this.jComboBoxPart.removeAllItems();
        WSDLRegistryEntry wre = (WSDLRegistryEntry) this.jComboBoxMesType
                .getSelectedItem();
        Message message = (Message) wre.userObject;
        if (message.getParts() != null) {
            Iterator iter = message.getParts().values().iterator();
            while (iter.hasNext()) {
                Part part = (Part) iter.next();
                this.jComboBoxPart.addItem(part.getName());
            }
        }
    }
}
