package org.act.wsc.bpel4wsmodeling.view.processassist;
import java.awt.BorderLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.wsdl.Input;
import javax.wsdl.Message;
import javax.wsdl.Operation;
import javax.wsdl.Output;
import javax.wsdl.PortType;
import javax.xml.namespace.QName;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.projectdata.ElementWriter;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.InputImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.MessageImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OperationImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OperationWrapper;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OutputImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PortTypeImpl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistryEntry;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class RoleDialog extends JDialog {
    JPanel jPanel1 = new JPanel();
    JLabel jLabelRole = new JLabel();
    JLabel jLabelPortType = new JLabel();
    JTextField jTextFieldRole = new JTextField();
    JButton jButtonOk = new JButton();
    JButton jButtonCancel = new JButton();
    JLabel jLabelRoleEdit = new JLabel();
    JComboBox jComboBoxPortType = new JComboBox();
    Project project;
    Role role = null;
    
    ResourceBundle res = ResChoose.getLanguage();
    
    public RoleDialog(JFrame mainframe, Project project) {
        super(mainframe);
        this.project = project;
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public RoleDialog(JFrame mainframe, Project project, Role role) {
        super(mainframe);
        this.project = project;
        this.role = role;
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        jPanel1.setLayout(null);
        jLabelRoleEdit.setText(res.getString("editRole"));
        jLabelRoleEdit.setBounds(new Rectangle(6, 9, 139, 24));
        jLabelRole.setBounds(new Rectangle(9, 52, 90, 27));
        jLabelRole.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabelRole.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelRole.setText("Role");
        jLabelPortType.setBounds(new Rectangle(8, 90, 90, 27));
        jLabelPortType
                .setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabelPortType.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPortType.setText("PortType");
        jTextFieldRole.setBounds(new Rectangle(136, 49, 247, 33));
        jComboBoxPortType.setEditable(false);
        jComboBoxPortType.setBounds(new Rectangle(136, 90, 247, 36));
        jButtonOk.setBounds(new Rectangle(160, 140, 77, 24));
        jButtonOk.setText(res.getString("yes"));
        jButtonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonOK_actionPerformed(e);
            }
        });
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.setBounds(new Rectangle(295, 140, 77, 24));
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonCancel_actionPerformed(e);
            }
        });
        jPanel1.add(jButtonOk, null);
        jPanel1.add(jButtonCancel, null);
        jPanel1.add(jLabelRoleEdit, null);
        this.getContentPane().add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jLabelRole, null);
        jPanel1.add(jTextFieldRole, null);
        jPanel1.add(jLabelPortType, null);
        jPanel1.add(jComboBoxPortType, null);
        
    }
    public void setDialog() {
        Vector pts = this.project.wsdlRegistry.findPortTypes();
        for (int i = 0; i < pts.size(); i++) {
            WSDLRegistryEntry we = (WSDLRegistryEntry) pts.get(i);
            this.jComboBoxPortType.addItem(we);
        }
        if (this.role != null) {
            this.jTextFieldRole.setText(role.getName());
            PortType portType = role.getPortType();
            this.jComboBoxPortType.setSelectedItem(this.project.wsdlRegistry
                    .findPortType(portType.getQName().getNamespaceURI(),
                            portType.getQName().getLocalPart()));
        }
    }
    public void jButtonOK_actionPerformed(ActionEvent e) {
        if (this.role == null) {
            this.role = new Role();
            this.project.addRole(role);
        } 
        role.setName(this.jTextFieldRole.getText());
        role.setElementType(new javax.xml.namespace.QName(
                "http://schemas.xmlsoap.org/ws/2003/05/partner-link/", role
                        .getName()));
        if (this.jComboBoxPortType.getSelectedItem() != null) {
            if (this.jComboBoxPortType.getSelectedItem() instanceof WSDLRegistryEntry) {
                WSDLRegistryEntry we = (WSDLRegistryEntry) this.jComboBoxPortType
                        .getSelectedItem();
                PortType pt = (PortType) we.userObject;
                this.role.setPortType(pt);
            }
        }
        dispose();
    }
    void jButtonCancel_actionPerformed(ActionEvent e) {
        dispose();
    }
}
